0.990148 2026-03-17
  [New Features]
    * Add SPVM::Builder::Config::Global and SPVM::Builder::Config::DLL classes.
    * Add SPVM::Builder::Config::Linker and SPVM::Builder::Config::Base classes to clarify the class hierarchy.
    * Add SPVM::Builder::Accessor to generate accessors and move the "has" method from SPVM::Builder::Util to it.

  [Incompatible Changes]
    * Redesign the spvmcc build system and remove almost all compiler and linker options from command line arguments to ensure object file consistency by centralizing flag management into config files.
      Removed options:
        - ccflag, ccflag-spvm, ccflag-native, ccflag-native-class, ccflag-precompile
        - define, define-spvm, define-native, define-native-class, define-precompile
        - optimize, optimize-spvm, optimize-native, optimize-native-class, optimize-precompile
        - include-dir, include-dir-spvm, include-dir-native, include-dir-native-class, include-dir-precompile
    * Add option name validation to SPVM::Builder::Config#new.
  
  [Changes]
    * Refactor SPVM::Builder::Config to inherit from SPVM::Builder::Config::Linker, moving linker-related fields and methods to the parent class.
    * Refactor SPVM::Builder::Config::Linker to inherit from SPVM::Builder::Config::Base, moving common methods to the base class.
    * Refactor SPVM::Builder::Config::Exe to inherit from SPVM::Builder::Config::Global and use SPVM::Builder::Accessor::has for field management.
    * Rename config to config_global in SPVM::Builder::Exe for better clarity and type safety.
    * Rename config_exe to config_global across the entire project.
    * Update the new method in SPVM::Builder::Config and its base classes to use exists instead of defined for field initialization to allow explicit undef values.
    * Split the documentation for the new method and library path resolution into the appropriate classes in the new hierarchy.
    * Organize fields in SPVM::Builder::Config into base, cc, and ld groups.

  [Internal Changes]
    * Add SPVM::Builder::Util::check_option_names to validate option names.
    
0.990147 2026-03-16
  [New Features]
    * Add the input_files option to SPVM::Builder::Util#create_make_rule and get_possible_dependent_files to allow custom dependency tracking in Makefile.

  [Changes]
    * Replace the internal _core option with the generic input_files option in SPVM::Builder::Util and Makefile.PL to manage build dependencies more flexibly.
    * Update SPVM::Builder::LinkInfo to support dynamic_lib_libcpp_ldflags and exe_libcpp_ldflags.
    * Build: Add x_parallel_make_jobs and x_parallel_test_jobs to META_MERGE and extract them from MYMETA.json.
    * Build: Update parallel build instructions to use MAKEFLAGS.
    * Build: Ensure native modules correctly depend on $(INST_DYNAMIC) for reliable parallel builds.
    * CI: Update Linux and Windows workflows to use parallel make and test.

  [Internal Changes]
    * CI: Upgrade GitHub Actions checkout to v4.
    * Build: Parametrize parallel jobs for make disttest.
    * Build: Revert the use of export for parallel job environment variables and use MAKEFLAGS instead.
0.990146 2026-03-14
  [New Features]
    * Add dynamic_lib_libcpp_ldflags and exe_libcpp_ldflags to SPVM::Builder::Config to allow separate C++ linker flags for dynamic libraries and executables.
  
  [Changes]
    * Update the default value of libcpp_ldflags to be empty on macOS, and set the default value of exe_libcpp_ldflags to ['-lc++'] on macOS.
    * Create SPVM::Builder::Util#get_cpu_count subroutine and adopt a Ninja-style parallel job count (N + 2) for improved build performance in Makefile.PL.
  
  [Internal Changes]
    * Update build_precompile_header_content_c_source to update the output file only when the content actually changes to avoid unnecessary re-compilation.
    * Update SPVM::Builder::LinkInfo to support dynamic_lib_libcpp_ldflags and exe_libcpp_ldflags.
    * Use new_cpp11 in SPVM::Builder::Config to simplify C++11 and pthread configurations in tests.
  
0.990145 2026-03-13
  [Changes]
    * Change the default value of the optimize field from '-O3' to '-O3 -DNDEBUG' in SPVM::Builder::Config to disable assertions by default.
    * If the SPVM_BUILD_DIR environment variable is not defined, a temporary directory is created when it is first needed, and the path is set to the environment variable.
  [Incompatible Changes]
    * Move SPVM_CC_DEBUG, SPVM_CC_QUIET, and SPVM_CC_FORCE environment variables from SPVM::Builder::CC to JIT-only in SPVM::Global, which is an incompatible change.
    * Add SPVM_CC_OPTIMIZE environment variable.
  [Internal Changes]
    * Add --devel option to Makefile.PL to set optimization level to -O0 with debug information.
  
  [Bug Fix]
    * Fix a bug that PRId64 format was not correctly parsed in SPVM_API_c_snprintf_len when its value is "ld".
  
0.990144 2026-03-11
  [Incompatible Changes]
    * Disallow void pointers for native types to enforce strict type checking.
  [New Features]
    * Add new Native Internal APIs c_strlen, c_memcpy, c_memset, c_memcmp, c_strtoll, c_strtof, c_strtod, c_fputs, and c_fgetc to the SPVM_ENV structure to provide standard C library functions through the environment.
    * Add the new c_snprintf_len Native Internal API to provide formatted string generation through the environment and update the SPVM_API_INTERNAL structure and its initialization.
    * Add is_generated_from_anon_method to the BasicType Native API.
    
  [Changes]
    * Improve need_generate with high-resolution mtime using Time::HiRes and simplify logic.
  [Internal Changes]
    * Add build_precompile_inline_header_c_source to generate a C file containing an inlined header as a C string literal.
  [Bug Fix]
    * Fix a bug where anonymous methods were incorrectly expected to have their own dynamic libraries by ensuring they are loaded from their outmost class's library.
  [Feature Improvement]
    * Make precompiled C source code self-contained.
    
0.990143 2026-03-09
  [Incompatible Changes]
    * Changed the return type of get_caller_info_stack from void** to SPVM_VALUE* for better type safety and consistency with the SPVM stack.
    
0.990142 2026-03-09
  [New Features and Future Incompatible Changes]
    * Added SPVM_NATIVE_ALLOCATOR, SPVM_NATIVE_STRING_BUFFER, SPVM_NATIVE_COMPILER, SPVM_NATIVE_CLASS_FILE, SPVM_NATIVE_RUNTIME, SPVM_NATIVE_BASIC_TYPE, SPVM_NATIVE_CLASS_VAR, SPVM_NATIVE_FIELD, SPVM_NATIVE_METHOD, SPVM_NATIVE_ARG, and SPVM_NATIVE_MUTEX types to spvm_native.h.

    #ifdef SPVM_NATIVE_TYPE_STRICT
      struct spvm_native_allocator;
      typedef struct spvm_native_allocator SPVM_NATIVE_ALLOCATOR;

      struct spvm_native_string_buffer;
      typedef struct spvm_native_string_buffer SPVM_NATIVE_STRING_BUFFER;

      struct spvm_native_compiler;
      typedef struct spvm_native_compiler SPVM_NATIVE_COMPILER;

      struct spvm_native_class_file;
      typedef struct spvm_native_class_file SPVM_NATIVE_CLASS_FILE;

      struct spvm_native_runtime;
      typedef struct spvm_native_runtime SPVM_NATIVE_RUNTIME;

      struct spvm_native_basic_type;
      typedef struct spvm_native_basic_type SPVM_NATIVE_BASIC_TYPE;

      struct spvm_native_class_var;
      typedef struct spvm_native_class_var SPVM_NATIVE_CLASS_VAR;

      struct spvm_native_field;
      typedef struct spvm_native_field SPVM_NATIVE_FIELD;

      struct spvm_native_method;
      typedef struct spvm_native_method SPVM_NATIVE_METHOD;

      struct spvm_native_arg;
      typedef struct spvm_native_arg SPVM_NATIVE_ARG;

      struct spvm_native_mutex;
      typedef struct spvm_native_mutex SPVM_NATIVE_MUTEX;

      struct spvm_native_opcode;
      typedef struct spvm_native_opcode SPVM_NATIVE_OPCODE;

      struct spvm_obj;
      typedef struct spvm_obj SPVM_OBJ;

      struct spvm_ref;
      typedef struct spvm_ref SPVM_REF;

    #else
      #define SPVM_NATIVE_ALLOCATOR void
      #define SPVM_NATIVE_STRING_BUFFER void
      #define SPVM_NATIVE_COMPILER void
      #define SPVM_NATIVE_CLASS_FILE void
      #define SPVM_NATIVE_RUNTIME void
      #define SPVM_NATIVE_BASIC_TYPE void
      #define SPVM_NATIVE_CLASS_VAR void
      #define SPVM_NATIVE_FIELD void
      #define SPVM_NATIVE_METHOD void
      #define SPVM_NATIVE_ARG void
      #define SPVM_NATIVE_MUTEX void
      #define SPVM_NATIVE_OPCODE void
      #define SPVM_OBJ void
      #define SPVM_REF void
    #endif

      These types are currently defined as void by default for smooth migration. However, if SPVM_NATIVE_TYPE_STRICT is defined, they become strict pointer types using incomplete struct definitions for better type safety.

      Future Plans:

      In a future release, SPVM_NATIVE_TYPE_STRICT will be defined by default.

      Eventually, the #ifdef switch and the void macro definitions will be removed, leaving only the strict struct-based type definitions.
   
   [New Features]
     * Add the ref and address members to the SPVM_VALUE union with the SPVM_REF* and void* types respectively.
       
       union spvm_value {
        int8_t bval;
        int16_t sval;
        int32_t ival;
        int64_t lval;
        float fval;
        double dval;
        SPVM_OBJ* oval;
        SPVM_REF* ref;
        void* address;
        int8_t* bref;
        int16_t* sref;
        int32_t* iref;
        int64_t* lref;
        float* fref;
        double* dref;
      };
     
0.990141 2026-03-07
  [New Features]
    * Add arch_ccflags field to SPVM::Builder::Config and reflect it in compile command.
0.990140 2026-03-06
  [New Features]
    * Add cc_output_option_name and ld_output_option_name fields to SPVM::Builder::Config.
    * Introduce create_option_short/long and use them for output options in CompileInfo and LinkInfo to support MSVC and other compilers.
    * Add experimental SPVM::Builder::Config::Exe::MSVC for Visual Studio support.
  [Bug Fix]
    * Fix SPVM::Builder::Config#load_mode_config to re-bless the config object into the invocant class to ensure correct method inheritance.
    * Change 'standart' to undef of the default value of dialect field in SPVM::Builder::Config.
  [Incompatible Changes]
    * SPVM::Builder::Config#build_option is renamed to create_option.
  [Internal Changes]
    * Add spvm_atomic.h
    * Add spvm_builtin_expect.h
    * Add spvm_unistd.h
  
0.990139 2026-03-02
  [Bug Fix]
    * Fix a bug that numeric object types could not be cast to the same types.
    Fix a bug in the Array->repeat method where the loop logic and copy length were incorrect.
    
  [Incompatibe Changes]
    * Add a check to ensure that all types in a union type are object types, which makes it incompatible with using it as a simple type comment.
    * Add a check to ensure that the element type in a generic type is an object type, which is a backward-incompatible change for users who used it only as a type comment.
    * Add a check to ensure the container type in a generic type is an object type; this may break backward compatibility if a numeric type was used with 'of' as a mere comment.
    * Rename the existing Fn->repeat method to Fn->repeat_string. Introduce a new Fn->repeat method that supports both strings and arrays using union mapping.
    
  [New Features]
    * The following methods in the Fn class now support union mapping for their arguments and return values.

      static method sort_desc : byte[]|short[]|int[]|long[]|float[]|double[]|string[] ($array : byte[]|short[]|int[]|long[]|float[]|double[]|string[]);

      static method sort_asc : byte[]|short[]|int[]|long[]|float[]|double[]|string[] ($array : byte[]|short[]|int[]|long[]|float[]|double[]|string[]);

      static method slice : byte[]|short[]|int[]|long[]|float[]|double[]|string[]|object ($array : byte[]|short[]|int[]|long[]|float[]|double[]|string[]|object, $offset : int, $length :int);

      static method reverse : byte[]|short[]|int[]|long[]|float[]|double[]|string[]|string|object ($array_or_string : byte[]|short[]|int[]|long[]|float[]|double[]|string[]|string|object);

      static method copy : byte[]|short[]|int[]|long[]|float[]|double[]|string[]|string|object ($array_or_string : byte[]|short[]|int[]|long[]|float[]|double[]|string[]|string|object, $shallow : int = 0);
    
   * Add to_object_array method to Array class.
   * Add to_array method to Array class.
   * Add merge method to Array class.
   
0.990138 2026-02-28
  [New Features]
    * Add Union Mapping: a feature that automatically casts the return type of a method call to a specific type at compile time if both the return type and at least one argument type are union types, based on the index of the matched argument type.
    
0.990137 2026-02-26
  [New Features]
    * Add after_link_cbs field and add_after_link_cb method in SPVM::Builder::Config to support callbacks after linking.
    * Add clear_system_settings method to SPVM::Builder::Config to clear default environment settings.
    * SPVM::Builder::Config: Add warn_ccflags, language_ccflags, compiler_ccflags, runtime_ccflags, ld_ccflags, warn_ldflags and debug_ldflags fields.
    * SPVM::Builder::Config: Add build_option method.
    * SPVM::Builder::Config: Add long_option_sep field.
    * SPVM::Builder::Config: Add lib_dir_option_name field and refactor library directory option generation using build_option.
    * Add dynamic_lib_ext, static_lib_ext and exe_ext fields to SPVM::Builder::Config.
    * Add lib_prefix field to SPVM::Builder::Config.
    * Add lib_option_suffix field to SPVM::Builder::Config.
  [Incompatible Change]
    * SPVM::Builder::Config: Remove mingw_ccflags field for backward compatibility and move its Windows settings to runtime_ccflags.
    * SPVM::Builder::Config: Remove new_gnu99 and new_gnu11 method,
      because Enforce C99 as the default C language standard for the entire SPVM ecosystem to improve portability and fix the actual standard from GNU99 to C99.
      Add a note for Linux users: If some functions like lstat are not found when using the C99 standard, 
      insert the following code at the beginning of the C source file:

        #ifdef __linux__
          /* Enable X/Open System Interfaces (SUSv4) functions and POSIX.1-2008 standard functions */
          #define _XOPEN_SOURCE 700

          /* Enable BSD and System V extensions */
          #define _DEFAULT_SOURCE
        #endif
    * Drop support for 32-bit architectures. SPVM now strictly requires a 
          64-bit environment (pointer size of 8 bytes).
          
          Reasons:
          1. To fully comply with the C99 floating-point specifications and 
             ensure consistent results (avoiding non-deterministic behavior 
             caused by x87 80-bit internal precision on 32-bit x86).
             
          2. To support efficient coroutine (goroutine-like) stack management. 
             A 64-bit virtual address space is essential for allocating and 
             optimizing stack sizes for a large number of coroutines using mmap.
  [Changes]
    * SPVM::Builder::Config: Add option_sep field to support different separators for the -std option and update documentation.
    * Update spvmdist to use the new_c99 method by default in the generated 
      native class configuration files to enforce the C99 standard for new modules.
  
0.990136 2026-02-25
  [New Features]
    * Add language and dialect fields to SPVM::Builder::Config.
    * Set language field in new_c and new_cpp methods.
  [Incompatible Change]
    * SPVM::Builder::Config#new method no longer sets a default cc, and new_c method now sets it explicitly.
    * Change the default ld field in SPVM::Builder::Config to clang++/g++ instead of $Config{ld} to support C/C++ mixed linking.
    * Abstract thread flags and libwinpthread static linking into SPVM::Builder::Config on Windows.
    * libstdc++ and libgcc static linking into SPVM::Builder::Config on Windows.
    * C object files are now linked using the C++ linker and its default settingsin spvmcc command.
    
0.990135 2026-02-22
  
  [Changes]
    * Rename "Language Specification" to "Language Standard" in spvmdist template.
    * Change the default C standard to C99 for the SPVM core and its native classes.
    
0.990134 2026-02-20

  [Incompatible Changes]
    * Change the format of spvm-archive.json to use classes_h and update related logic and tests.
    * Add the document for SPVM Archive(SPVM::Builder::SPVMArchive).
    
0.990133 2026-02-19
  
  [New Features]
    * Add the env native method to the Fn class to get the value of an environment variable.
    
  [Incompatible Changes]
    * Rename load_spvm_archive to use_spvm_archive in SPVM::Builder::Config::Exe.
    * Rename --load-spvm-archive option to --spvm-archive in spvmcc. 
    * Rename spvmcc.json to spvm-archive.json in SPVM archive.
    * Remove spvm_archive_skip_classes method and skip option from use_spvm_archive in SPVM::Builder::Config::Exe.
    
0.990132 2026-02-17
  
  [New Features]
    - Add util/cpandeps to analyze dependencies.
    - Add a procedure to reinstall modules affected by ABI breakdown.
      1. Get modules containing native or precompile classes:
         
         util/cpandeps -v --native-class-only SPVM::Your::Module
      
      2. Reinstall them:
         
         util/cpandeps --verbose --native-class-only SPVM::Mojolicious | grep -vx "SPVM" | xargs cpanm --reinstall
      
      3. For a quick fix without downloading the script:
         
         curl -sL https://raw.githubusercontent.com/yuki-kimoto/SPVM/refs/heads/master/util/cpandeps | perl - --verbose --native-class-only SPVM::Mojolicious | grep -vx "SPVM" | xargs cpanm --reinstall
      
      
  [Break Binary Compatiblity]
    * Renumbered native internal API IDs to remove unused slots, breaking binary compatibility.
    * Renumbered native method API IDs to remove unused slots, breaking binary compatibility.
    * Renumbered native API IDs to remove unused slots, breaking binary compatibility.

  [Incompatible Changes]
    * Remove the is_not_permitted and set_is_not_permitted native APIs and related implementation from the SPVM core to eliminate insecure software-based access control.

0.990131 2026-02-16
  [New Features]
    * Add getrandom method to Fn class to get OS-specific secure random bytes.
  [Incompatible Changes]
    * Remove object_data_offset, object_length_offset, object_capacity_offset, stack_index_call_depth, stack_index_caller_info_stack and stack_index_caller_info_stack_record_size to the native API.
    * Add object_data_offset, object_length_offset, object_capacity_offset, stack_index_call_depth, stack_index_caller_info_stack and stack_index_caller_info_stack_record_size to the runtime native API.
    
0.990130 2026-02-13
  [Changes]
    * Allow casting numeric object types to string type.
    * Allow explicit casts from all numeric object types to all numeric primitive types by relaxing cast requirements.
  [New Features]
    * Add $unsigned optional argument to to_int, to_int_with_base, to_long, and to_long_with_base in Fn class.
    * Add Fn#to_byte_object_unsigned, Fn#to_short_object_unsigned, Fn#to_int_object_unsigned, and Fn#to_long_object_unsigned methods.
    * Add new_unsigned class method and unsigned field to Byte, Short, Int, and Long classes.
    
0.990129 2026-02-11
  [New Features]
    * Add set_byte_object_value native API to set the value of a Byte object.
    * Add set_short_object_value native API to set the value of a Short object.
    * Add set_int_object_value native API to set the value of an Int object.
    * Add set_long_object_value native API to set the value of a Long object.
    * Add set_float_object_value native API to set the value of a Float object.
    * Add set_double_object_value native API to set the value of a Double object.
    * Add clone, make_read_only, and is_read_only methods to numeric classes (Byte, Short, Int, Long, Float, Double).
  [Incompatible Changes]
    * Numeric objects (Byte, Short, Int, Long, Float, Double) are now mutable by default. This is a significant change from previous versions where these objects were immutable. Any code assuming the immutability of these objects should be reviewed.
  [Changes]
    * Add Cloneable interface to the default loaded classes.
    
0.990128 2026-02-11
  [New Features]
    * Add is_utf8 native API to check if a string is a valid UTF-8 sequence.
    * Add Fn#is_utf8 method to check if a string is a valid UTF-8 sequence.

  [New Features]
    * Add is_utf8 native API to check if a string is a valid UTF-8 sequence.
    * Add Fn#is_utf8 method to check if a string is a valid UTF-8 sequence.

  [Backward Incompatible Changes]
    * Move method begin/end callback APIs from SPVM_ENV to SPVM_RUNTIME to clarify API responsibilities. #845
    * Remove method_begin_cb, get_method_begin_cb, set_method_begin_cb, method_end_cb, get_method_end_cb, and set_method_end_cb from SPVM_ENV. Use the direct fields method_begin_cb and method_end_cb in the Native Runtime API instead. #845
    * Remove the redundant die_v2 native API.
    * Update Native API IDs: Due to the removal of the above APIs, the IDs of subsequent APIs (call_end_methods, is_utf8) and Runtime APIs have been changed. Any native extensions relying on these specific IDs must be recompiled. #845
    
0.990127 2026-02-04
  [Bug Fix]
    * Fix stack trace depth calculation and loop range in build_exception_message.
    
0.990126 2026-02-03
  [New Features]
    * Add get_monitor_var_type to the BasicType native API to get the type of the $^MONITOR special variable..
    * Add has_monitor_var basic type native API to check for the presence of the $^MONITOR special variable.
    * Add the $^MONITOR special variable to provide the monitoring type information.
    * Add Native::BasicType#has_monitor_var method.
    * Add Native::BasicType#get_monitor_var_type method.
    
0.990125 2026-02-02
  [New Features]
    * Add call_end_methods native API to call consolidated END methods for all classes.
    * Add the END block feature. It allows defining blocks that are executed when the program exits, similar to Perl's END blocks.
  [Incompatibe Changes]
    * The method name "END" is now prohibited because it is reserved for the END block feature.
    
0.990124 2026-01-31
  [New Features]
    * Added the set_method_begin_cb, get_method_begin_cb, set_method_end_cb, and get_method_end_cb native APIs to support method hooks for profilers.
    * Added Fn#get_call_depth method to get the current call stack depth.
    * Add the optional $level argument to the Fn#get_current_method_name method.
    * Add the optional $level argument to the Fn#get_current_basic_type_name method.
    * Add the Fn#get_current_method_abs_name method to get the absolute name of the method that is the basic type name and the method name joined with #.
    
0.990123 2026-01-31
  [New Features]
    * Support the optimize option in create_make_rule_native and create_make_rule_precompile in SPVM::Builder::Util::API.
    * Support the --optimize command-line option in the Makefile.PL file generated by the spvmdist command.
    
  [Internal Changes]
    * Change the command-line option names in Makefile.PL to lowercase (e.g., --optimize, --define).
    
0.990122 2026-01-30
  [New Features]
    * Added the break_point operator to set a break point for debugging.
  [Incompatible Changes]
    * The order of search paths in spvm and spvmcc command has been changed to match Perl's @INC behavior. Now, paths are added in the following priority:
      1. #lib directives in the source code (highest priority)
      2. -Mblib option
      3. -I options
      4. Default @INC paths (lowest priority)
0.990121 2026-01-30
  [Incompatible Changes]
    * Update the arguments of warn native API to use a full function name instead of a basic type name and a method name.
    * This change breaks binary compatibility; all native and precompiled modules which use warn operantor or warn native API must be recompiled.
    * Update the output format of the warn operator to use # as the separator between the class name and the method name.
      
0.990120 2026-01-29
  [Incompatible Change]
    * Change the definition of die native API to set the caller stack correctly.
      [Before]
        int32_t SPVM_API_die(SPVM_ENV* env, SPVM_VALUE* stack, const char* message, ...);
      [After]
        SPVM_API_die(SPVM_ENV* env, SPVM_VALUE* stack, const char* exception_format, const char* func_name, const char* file, int32_t line, ...);
      
0.990119 2026-01-28
  [New Features]
    * Add die_v2 native API to support optimized exception handling with metadata, which will eventually replace die as an alias after all native modules are migrated.
    * Add build_exception_message and build_exception_message_no_mortal to the SPVM_ENV structure and the Native API to reconstruct full exception messages with stack traces from metadata.
    * Add the Fn#build_exception_message method to reconstruct exception messages with stack traces.
  [Incompatible Changes]
    * The exception message ($@) now only contains the raw message specified by the "die" statement, and no longer includes the stack trace by default.
    * To get the exception message with a full stack trace, use the Fn#build_exception_message method.
    * Exception messages are now constructed using the internal caller information stack instead of being concatenated during the exception propagation process.
    * This change significantly improves performance by removing the overhead of string concatenation when an exception is caught by an "eval" block.
    * Binary compatibility is broken due to changes in the exception handling logic within the VM and Precompile.
    * This includes updates to opcode definitions and their operands. All SPVM modules and executables must be recompiled.
    * die native API no longer sets the function name, file name, and line number in the exception message to prevent memory errors on specific architectures.
  [Feature Incompatibe Change]
    * die native API is planned to be replaced by the definition and implementation of die_v2 native API in the near future.
  
0.990118 2026-01-26
  [New Features]
    * Added get_current_method Native API to retrieve the currently executing method from the caller stack.
    * Added Fn#get_current_method_name method to the Fn class to get the name of the currently executing method.
    * Added Fn#get_current_basic_type_name method to the Fn class to get the basic type name of the currently executing method.
    * Add caller and caller_no_mortal native APIs to retrieve caller information at a specific level.
    * Add caller operator to retrieve caller information at a specific level.
  [Incompatibe Changes]
    * Renamed the name field to method_abs_name in the CallerInfo class to more accurately describe that it stores the absolute name of a method.
    * Updated the record layout in SPVM_API_push_caller_info in spvm_api.c.
      The order of elements in each record was changed as follows:
        Old: (current_method, caller_method_abs_name, caller_file, caller_line)
        New: (caller_method_abs_name, caller_file, caller_line, current_method)
      This ensures the current_method is stored at the last index (index 3) of the record.
  
0.990117 2026-01-24
  [Changes]
    * The runtime now pushes caller information (current method, caller name, file, and line) onto the caller stack within the runtime stack before each method call and pops it after the call. (Note: These changes are not yet tested.)
  [New Features]
    * Added stack_index_call_depth, stack_index_caller_info_stack, and stack_index_caller_info_stack_record_size native APIs to store stack indices.
    * Added get_call_depth, get_caller_info_stack, and get_caller_info_stack_record_size native APIs to provide safe and dynamic access to caller information.

0.990116 2026-01-24
  
  [New Features]
    * Added a new Native Method API get_abs_name to retrieve the absolute name of a method.
    * Added the CallerInfo class to represent caller information, including the method name, the file name, and the line number.
    * The CallerInfo class is now loaded by default.
  
  [Backward Incompatible Changes]
    * In SPVM naitve API, added new arguments (func_name, file, and line) to the following function pointers to support the caller operator:

      call_method

      call_method_no_mortal

      call_method_no_mortal_no_check_args

      call_instance_method_no_mortal_less_check_args

      These internal API changes allow the runtime to propagate caller information (method name, file name, and line number) through the call stack efficiently.
  
  [Document Fix]
    * Corrected the Native Method API ID for get_args_signature in SPVM::Document::NativeAPI::Method. It was previously duplicated as 32 and has been fixed to 33).
    
0.990115 2026-01-23
  [New Features]
    * Added the -Mblib option to the spvm command to support the Perl blib directory, which is useful for testing native modules.
    * Add the warn_level operator. This operator throws an exception with the die operator if the level is greater than 0, prints a warning message with the warn operator if the level is 0, and does nothing if the level is less than 0.
  [Document Improvement]
    * Added the missing documentation for the -w, and -M options in the spvm command's Usage and POD.
    * Linked the documentation of the options shared between the spvmcc command and the spvm command to the spvm command's documentation.
  [Incompatible Changes]
      * Removed the --include-dir option from the spvm command because this option is used as native include directories in the spvmcc command. This is an incompatible change. Use the -I option instead.
    
0.990114 2026-01-22
  [Changes]
    * Set the "file" member of the basic type to a virtual file name such as "string.spvm" even for built-in types.
    * Add to_string method to string type and make string type satisfy Stringable interface.
      
0.990113 2026-01-21
  
  [New Features]
    * Added support for the assignment of undef to multi-numeric types for 0-initialization.

      my $val : Point_3i = undef;

    * Added support for type cast from undef to multi-numeric types.

      $val = (Point_3i)undef;

    * Allowed multi-numeric types to be used as optional arguments with undef as a default value.

      method task ($point : Point_3i = undef) { ... }


0.990112 2026-01-20
  [Compilation Error Message Improvement]
    * Improve the compilation error message when a method call is not found.
    * Add a feature to suggest the closest method name when a method name is not found in a method call. The compiler now outputs an error message like "Did you mean Foo#baz?". This search includes methods in parent classes.
    
0.990111 2026-01-20
  [Internal Changes]
    * Refactor logical not operator AST logic.
    * Refactor logical or operator AST logic.
    * Refactor logical and operator AST logic.
  [Bug Fix]
    * Fix a bug that using reference types in field definitions caused an assertion failure instead of a compilation error.
    * Fix a bug that private methods of classes allowed by the allow statement could not be called within anonymous methods.
    * Fix a bug where field access in anon methods was incorrectly handled when a field named "self" existed, by ensuring that the local variable for the "self" field is declared after all other field variables.
  [New Features]
    * Add get_basic_type_name_by_id method to Fn class.
0.990110 2026-01-19
  [Internal Changes]
    * Refactor defined-or-operator AST logic.
  [Bug Fix]
    * Fixed a thernary operator compilation bug.
    
      https://github.com/yuki-kimoto/SPVM/issues/816
      
0.990109 2025-12-08
  [Bug Fix]
    * Fix a bug of exists operator.
    
0.990108 2025-12-03
  [New Features]
    * Add say_stderr native API.
    * Add print STDERR syntax.
    
      print STDERR "Hello";
      
    * Add say STDERR syntax
    
      say STDERR "Hello";
    * Add diag operator.
      
0.990107 2025-11-18
  [Bug Fix]
    * Fix bugs of variable length argument with options.
    
      my $r = $app->get("/a/b/:foo/#bar/*baz/d<title>d/c", {foo => "1", bar => "2", baz => "3"}, "a/b");
    
0.990106 2025-11-11
  [Changes]
    * Any object to numeric converion returns 0 if the object is undef.
    * Allow any object to string conversion.
  [New Features]
    * Add numeric_object_to_string_no_mortal native API.
    * Add numeric_object_to_string native API.
    * Add is_numeric_object native API.
    
0.990105 2025-10-16
  [Bug Fix]
    * Fix a bug that compile_type_name operator causes segfault in some cases.
  [Changes]
    * compile_type_name operator returns a generic type.
    * is_compile_type operator matches if the right type matches partially the type of the operand from the top.
  [Compilation Error Changes]
    * Duplicated mutable type modifier causes a compilation error.
    * The right type of is_compile_type operator must not contain union types.
    
0.990104 2025-10-15
  [New Features]
    * Add element[] type for generics.
  [Changes]
    * Change the return types of the following methods from object[] to element[].
      List#to_array
      List#splice
      List#get_array_unsafe
      List#get_array
      QList#to_array
      QList#splice
      QList#get_array_unsafe
      QList#get_array
      
  [Document Changes]
    * Improve the document for generics.
  [Incompatible Changes]
    * Remove get_array_unsafe or get_string_unsafe methods in the following classes.

      ByteList
      DoubleList
      FloatList
      IntList
      List
      LongList
      QList
      ShortList
      StringBuffer
      StringList
          
0.990103 2025-10-13
  [Incompabible Changes]
    * Sorry, the following methods in Hash class are removed in favor of hash access syntax.
      set_byte
      set_short
      set_int
      set_long
      set_float
      set_double
      set_string
      get_byte
      get_short
      get_int
      get_long
      get_float
      get_double
      get_string
      get_or_default_byte
      get_or_default_short
      get_or_default_int
      get_or_default_long
      get_or_default_float
      get_or_default_double
      get_or_default_string
      delete_or_default_byte
      delete_or_default_short
      delete_or_default_int
      delete_or_default_long
      delete_or_default_float
      delete_or_default_double
      delete_or_default_string
      delete_or_default
      
      # Use hash access syntax
      $book->{"id"} = 4;
      $book->{"name"} = "Perl";
      $book->{"price"} = 3000.0;
      $book->{"point"} = Point->new(1, 2);
      
      my $id = $book->{"id"}->(int);
      my $name = $book->{"name"}->(string);
      my $price = $book->{"price"}->(double);
      my $point = $book->{"point"}->(Point);
      
    * Sorry, the following methods in StringBuffer class are removed in favor of StringBuffer#substr method
      
      replace
      splice
    * Sorry, Fn#substr method's $string argument only receives string type instead of string|string[] type.
    
0.990102 2025-10-10
  [Incompatible Changes]
    * Fn#BYTE_MAX method returns byte type instead of int.
    * Fn#BYTE_MAX method returns byte type instead of int.
    * Fn#UBYTE_MAX method returns byte type instead of int.
    * Fn#INT8_MAX method returns byte type instead of int.
    * Fn#INT8_MAX method returns byte type instead of int.
    * Fn#UINT8_MAX method returns byte type instead of int.
    * Fn#SHORT_MAX method returns short type instead of int.
    * Fn#SHORT_MAX method returns short type instead of int.
    * Fn#USHORT_MAX method returns short type instead of int.
    * Fn#INT16_MAX method returns short type instead of int.
    * Fn#INT16_MAX method returns short type instead of int.
    * Fn#UINT16_MAX method returns short type instead of int.
  [Internal Change with Incompatible Change Posibility]
    * Simplify Hash#get_byte, get_short, get_int, get_long, get_float, get_double, get_string logic.
    * Simplify the logic of StringBuffer methods.
  [Exception Message Changes]
    * The exception message in object to numeric conversion is simplified.
  [Changes]
    * get_field_byte native API can access any numeric type field.
    * get_field_short native API can access any numeric type field.
    * get_field_int native API can access any numeric type field.
    * get_field_long native API can access any numeric type field.
    * get_field_float native API can access any numeric type field.
    * get_field_double native API can access any numeric type field.
    * set_field_byte native API can receive any numeric value.
    * set_field_short native API can receive any numeric value.
    * set_field_int native API can receive any numeric value.
    * set_field_long native API can receive any numeric value.
    * set_field_float native API can receive any numeric value.
    * set_field_double native API can receive any numeric value.
  [Changes]
    * Fn#substr replace argument string directory if $replacement argument exists.
    
  [Deprecation]
    * Deprecate StringBuffer#replace method.
    * Deprecate StringBuffer#splice method.
    
0.990101 2025-10-09
  [New Features]
    * Add ByteList#new_ref method.
    * Add ShortList#new_ref method.
    * Add IntList#new_ref method.
    * Add LongList#new_ref method.
    * Add FloatList#new_ref method.
    * Add DoubleList#new_ref method.
    * Add List#new_ref method.
    * Add StringList#new_ref method.
    * Add StringBuffer#new_ref method.
    * Add ByteList#get_array method.
    * Add ShortList#get_array method.
    * Add IntList#get_array method.
    * Add LongList#get_array method.
    * Add FloatList#get_array method.
    * Add DoubleList#get_array method.
    * Add List#get_array method.
    * Add StringList#get_array method.
    * Add QList#get_array method.
    * Add StringBuffer#get_array method.
    
  [Changes with Incompatible Change Posibility]
    * ByteList class use array length and array capacity instead of fields.
    * ShortList class use array length and array capacity instead of fields.
    * IntList class use array length and array capacity instead of fields.
    * FloatList class use array length and array capacity instead of fields.
    * DoubleList class use array length and array capacity instead of fields.
    * List class use array length and array capacity instead of fields.
    * StringList class use array length and array capacity instead of fields.
    * StringBuffer class use string length and string capacity instead of fields.
  
  [Deprecation]
    * Deprecate ByteList#get_array_unsafe method.
    * Deprecate ShortList#get_array_unsafe method.
    * Deprecate IntList#get_array_unsafe method.
    * Deprecate LongList#get_array_unsafe method.
    * Deprecate FloatList#get_array_unsafe method.
    * Deprecate DoubleList#get_array_unsafe method.
    * Deprecate List#get_array_unsafe method.
    * Deprecate StringList#get_array_unsafe method.
    * Deprecate QList#get_array_unsafe method.
    * Deprecate StringBuffer#get_array_unsafe method.
    
0.990100 2025-10-09
  [Changes]
    * Allow same named local variable declartions as arguments.
      static method foo : void ($var : int) {
        my $var = 2;
      }
    * Allow type cast from any object to any numeric type.
    
  [New Features with Changes]
    * Support minus index in array access.
      
      $array->[-1]
  [New Features]
    * Add the following native APIs.
    
      int8_t (*numeric_object_to_byte)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t* error_id);
      int16_t (*numeric_object_to_short)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t* error_id);
      int32_t (*numeric_object_to_int)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t* error_id);
      int64_t (*numeric_object_to_long)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t* error_id);
      float (*numeric_object_to_float)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t* error_id);
      double (*numeric_object_to_double)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t* error_id);
      
  [Internal Changes]
    * Rename TYPE_CONVERSION_XXX_OBJECT_TO_XXX to TYPE_CONVERSION_NUMERIC_OBJECT_TO_XXX.
    
0.990099 2025-10-06
  [Design Changes]
    * string and array becomes dynamic string and array. The capacity and length can be shorten and extended.
  [Internal Changes]
    * Add SPVM_OBJECT_C_FLAG_IS_FIXED_LENGTH object flag.
  [New Features]
    * Add is_fixed_length operator.
    * Add make_fixed_length operator.
    * Add set_length operator.
    * Add capacity operator.
    * Add set_capacity operator.
    * Add set_length native API.
    * Add capacity native API.
    * Add set_capacity native API.
    * Add object_capacity_offset native API.
    * Add get_object_capacity_offset runtime native API.
    * Add destroy_runtime_permanent_vars exchange API.
    * Add get_version_string exchange API.
  [Changes]
    * Use destroy_runtime_permanent_var exchange API instead of Fn#destroy_runtime_permanent_var method in the test generated by spvmdist command.
    * Use get_version_string exchange API instead of Fn#get_version_string method in the test generated by spvmdist command.
0.990098 2025-10-06
  [Internal Changes with Memory Size Degraration]
    * Add data member variable to SPVM_OBJECT.
  [Internal Changes]
    * SPVM_API_length returns object->length.
  [Internal Changes with Incompatible Change Posibility]
    * string and array data is saved to a different memory from the object itself.
  [Break Binary Compatiblity]
    * Sorry. SPVM modules are needed to be recompiled.
    
0.990097 2025-10-06
  [Internal Changes with Memory Size Degraration]
    * Add capacity member variable to SPVM_OBJECT.
  [Internal Changes]
    * Add capacity member variable to spvm_object.h.
    * Add data member variable to spvm_object.h.
    * get_object_data_offset returns offsetof(SPVM_OBJECT, data).
    * Remove internale object_data_offset argument of internal functions.
    * Remove internale object_length_offset argument of internal functions.
    * SPVM_API_length returns 0 if the data is dynamic.
    * SPVM_API_set_length set the length if the data is dynamic.
    * Add SPVM_API_has_dynamic_data.
    * Add object_data_offset and object_length_offset native APIs.
    * SPVM_API_new_object_common recieve data size instead of allocation size.
    
0.990096 2025-10-02
  [Document Improvement]
    * Add links to new standard modules.
    * Add links to CPAN modules.
  [New Features]
    * Add compile_script compiler native API.
    * Add Native::Compiler#compile_script method.
    * An SPVM script executed by spvm command or compiled by spvmcc command allows a naked script.
      
      # myapp.spvm
      use Fn;
      my $var = 1;
      say $var;
      
  [Incompatible Changes]
    * Remove -E option of spvm command. Use -e instead of -E.
    
0.990095 2025-10-01
  [Changes with Performance Degradation]
    * The offset of the internal array in List object always start at 0. shift method becomes O(n) instead of O(1).
      This is because one wants to sort internal array in List and StringList.
      
  [New Features]
    * Add QList class.
    * Add List#get_array_unsafe method.
    * Add StringList#get_array_unsafe method.
    
0.990094 2025-10-01
  * Support minus index in the following methods.
    ByteList#get
    DoubleList#get
    FloatList#get
    IntList#get
    List#get
    LongList#get
    ShortList#get
    ByteList#set
    DoubleList#set
    FloatList#set
    IntList#set
    List#set
    LongList#set
    ShortList#set
    Immutable::ByteList#get
    Immutable::DoubleList#get
    Immutable::FloatList#get
    Immutable::IntList#get
    Immutable::LongList#get
    Immutable::ShortList#get
    Immutable::StringList#get
    
0.990093 2025-09-30
  [New Features]
    * Add hash access syntax.
    * Add Countable interface.
    * Add Countable interface to the following classes.
      ByteList
      DoubleList
      FloatList
      IntList
      List
      LongList
      ShortList
      StringList
      Immutable::ByteList
      Immutable::DoubleList
      Immutable::FloatList
      Immutable::IntList
      Immutable::LongList
      Immutable::ShortList
      Immutable::StringList
    * array length operator @ can be used for the class that has Countable interface.
    * Array element set operator can be used for tha class that has set method.
    * Array element get operator can be used for tha class that has get method.
    * Hash value set operator can be used for tha class that has set method.
    * Hash value get operator can be used for tha class that has get method.
    * Fn#chomp method return the removed length.
  [Internal Changes]
    * Rename SPVM_OP_C_ID_ELEMENT_ACCESS to SPVM_OP_C_ID_ARRAY_ELEMENT_ACCESS.
    * Rename SPVM_OP_C_FLAG_ELEMENT_ACCESS to SPVM_OP_C_FLAG_ARRAY_ELEMENT_ACCESS.
0.990092 2025-09-25
  [New Features]
    * Add Native#use method.
    * Add Native#push_inc method.
    * Add Native#unshift_inc method.
    * Add Native#inc method.
    * Add Native#set_inc method.
    * Add Native#use_anon_class method.
    * Add Native#eval method.
    * Add Native::Compiler#get_include_dirs_length method.
    * Add Native::Compiler#get_include_dir method.
    * Add Native::Compiler#prepend_include_dir method.
    * Add Native::Compiler#clear_include_dirs method.
    * use statement can be used in methods.
  [Incompatible Changes]
    * Rermove Native::Compiler#eval_string method.
    
0.990091 2025-09-25
  [Changes]
    * Add SVPM github page link to README.md generated by spvmdist command.
  [New Features]
    * Add Hash#to_options method.
    * Add Fn#to_hash method.
    * Add $replacement optional argument to StringBuffer#substr method
      [Before]
      method substr : string ($offset : int, $length : int = -1);
      
      [After]
      method substr : string ($offset : int, $length : int = -1, $replacement : string = undef);
      
  [Incompatible Changes]
    * Revert a change in 0.990084 2025-08-26: The return value of Hash#to_array is enabled options flag.
0.990090 2025-09-17
  [New Features]
    * Add Hash#merge and Hash#merge_options methods.
  [Incompatible Changes]
    * The container type of a generic type must be a basic type.
  [Bug Fix]
    * Fix the bugs that accessor generics does not work.
    * Fix the bugs that Windows isprint depends on locales.
      
      https://github.com/yuki-kimoto/SPVM/issues/780
  [Improve exception messages]
    * Change an exception message.
      [Before]
      "An assignment failed. The right operand does not satisfy type requirement."
      [After]
      "An assignment failed. %s type cannot be assigned to %s type."
      
    * Change an exception message.
      [Before]
      "An array setting failed. The element does not satisfy type requirement."
      [After]
      "An array element set failed. %s type cannot be assigned to %s type."
      
0.990089 2025-09-15
  [New Features]
    * Add generics feature.
      
      my $list = (TestCase::List of string)TestCase::List->new(["a", "b"]);
      
      # $elem is string type
      my $elem = $list->get(0);
      
    * Add element keyword.
    * Add generics feature only in object's return value.
    
  [Internal Changes]
    * Add of member variable to spvm_type.h.
    * Add is_element_type member variable to spvm_type.h.
    * Add type member variable to spvm_call_method.h.
    * Union type is treated as any object type.
    * Add is_union_type member variable to spvm_type.h.
  [Change]
    * Allow union type in all places.
      A union type is treated as any object type C<object>.
    * The folowing methods in List class return element type.
      
      get
      pop
      remove
      shift
    
    * The folowing methods in List class return element type.
      
      delete
      get
      get_or_default
      delete_or_default
    
  [Document Changes]
    * Type Comment is renamed to Generic Type.
    
0.990088 2025-09-11
  [Incompatible Changes]
    * Fn#pack method receives variable length arguments.
    
      my $binary = Fn->pack("l", 3);

0.990087 2025-09-10
  [Incompatible Changes]
    * Change variable length arguments syntax.
      
      [Before]
      static method foo : void ($var1 : int, $args : varargs object[]) {}
      
      [After]
      static method foo : void ($var1 : int, $args : object...) {}
    * The use of variable length arguments cannot have a default value.
    
    * Variable length arguments is always expanded even if the type of the argument is object[].
      And added (object...) type cast not to expand it.
      
        (object...)$objects
    * The second argument of Format#sprintf method is changed back.
    
      static method foo : void ($var1 : int, $args : object[]) {}
    
  [Fix Bugs]
    * Fix the bug that segfault occured in argments check.

0.990086 2025-09-09
  [New Features]
    * Add SPVM_NATIVE_C_TYPE_FLAG_VARARGS natvie constant.
    * Add variable length arguments syntax.
      
      static method foo : void ($var1 : int, varargs object[]) {}
      
      &foo(1, "abc", Int->new) is parsed to &foo(1, [(object)"abc", Int->new]);
  [New Features with Incompatible Changes]
    * Fn#sprintf and Format#sprintf method can receive variable length arguments.
    
      my $ret = Fn->sprintf("Foo %d %s %.3f Bar", 123, "abc", 1.115);
    
0.990085 2025-09-08
  [Compilation Error Message Changes]
    * Improve English for void return compilation error messages.
  [Changes]
    * If the type of a method is void, the method call returns undef.
    * Change assignment requirement.
      void type can be assigned to any object type.
      
  [Internal Changes]
    * Add return_type_is_void member variable to spvm_runtime_method.h.
0.990084 2025-08-26
  [Document Improvement]
    * Improve the document for Stringable interface.
    
  [Incompatible Changes]
    * The return value of Hash#to_array is enabled options flag.
  
0.990083 2025-08-25
  [Compilation Error Message Improvement]
    * Add the following compilation error message to weak, unweak, isweak, exists, delete operators.
    
      The incovant of the field access must be a class type.
  [Incompatible Changes]
    * copy_fields operator do not copy nonexistent fields.
    
0.990082 2025-08-20
  [New Features]
    * Add get_fields_size native basic type API.
    * Add get_exists_offset native field API.
    * Add get_exists_bit native field API.
    * Add exists operator.
    * Add delete operator.
    * Add exists_field native API.
    * Add exists_field_by_name native API.
    * Add delete_field native API.
    * Add delete_field_by_name native API.
    
  [Changes]
    * Change the format of the output from dump operator a bit.
    
  [Internal Changes]
    * Add exists_offset member variable to spvm_field.h and spvm_runtime_field.h.
    * Add exists_bit member variable to spvm_field.h and spvm_runtime_field.h.
    * Fields are sorted by the field order.
  [Document Changes]
    * Change headings for set and get operations.
    
0.990081 2025-08-15
  [New Features]
    * Byte, Short, Int, Long, Float, Double classes has Stringable interface.
    * Add to_string method to Byte, Short, Int, Long, Float, Double classes.
    
  [Document Inprovement]
    * Improve the documents for Error classes.
  [Change]
    * Stringable class becomes a default loaded class.
0.990080 2025-08-06
  [New Features]
    * set syntax allow the setter to define the return type.
    
0.990079 2025-08-05
  [Changes]
    * Add "=encoding utf8" and the following heading to the .pm file generated by spvmdist command.
    
      =encoding utf8
      
      =head1 Well Known Child Classes
  [New Features]
    * Add virtual class attribute and field attribute.
    * set syntax allow the setter defining the argument.
    
0.990078 2025-08-04
  [New Features]
    * Add user defined field and class variable setter/getter syntax.
      class MyClass {
        our $VALUE : rw int
          get {
            return $VALUE;
          }
          set {
            $VALUE = $_;
          }
        ;
        
        has value : rw int
          get {
            return $self->{value};
          }
          set {
            $self->{value} = $_;
          }
        ;
      }
      
  [Compilation Error Message Changes]
    * Fix English in compilation error messages.
  [Exception Message Changes]
    * Fix English in exception messages.
  [Internal Changes with Document Changes]
    * copy_fields statement is renamed to copy_fileds operator.
0.990077 2025-07-04
  [Performance Improvement]
    * Ternary operator does not performe type cast from/to any object type internally.
    * Improve performance of Fn#grep method. List class is not used.
  [New Features]
    * Add the following methods to Fn class.
    
      grep_byte
      grep_short
      grep_int
      grep_long
      grep_float
      grep_double
    
    * Add the following interfaces.

      Callback::Grep::Byte
      Callback::Grep::Double
      Callback::Grep::Float
      Callback::Grep::Int
      Callback::Grep::Long
      Callback::Grep::Short
            
0.990076 2025-07-03
  [Exception Messages Improvement]
    * Improve an exception message.
      [Before]
      The invocant of a method call must be defined.
      [After]
      Can't call %s method on undefined value.
  [Incompatible Changes]
    * The type of the left operand of the ternary operator must be the same as the type of the right operand.
    * Ternary operator couses a compilation error if the types of the left and right operands are not the same type.
  [New Features]
    * Add Hash#new_from_keys method.
    * Add is_any_object_array native API.
  [Changes]
    * The return value of Fn#merge_options method is enabled options flag.
    * enable_options native API turn on C<options> flag only if the type of the object is any object array.
    * enable_options, disable_options, is_options receives the value of an object type instead of any object array type.
0.990075 2025-06-26
  [New Features]
    * Add enable_options native API.
    * Add disable_options native API.
    * Add is_options native API.
    * Add enable_options operator.
    * Add disable_options operator.
    * Add is_options operator.
    
0.990074 2025-06-26
  [New Features]
    * Allow for(;;) { } syntax.
    * Allow repeated type comments.
      
      Hash of List of Point
    * Allow type comments in tyep cast operator
      
      (Hash of List of Point)$object
  [Internal Changes]
    * Change yacc. Qualified Type contains type comments.
  [Incompatible Changes]
    push_array methods in the following classes are renamed to push_.
    unshift_array methods in the following classes are renamed to unshift_.
    
      ByteList
      ShortList
      IntList
      LongList
      FloatList
      DoubleList
      List
      StringList
    
    Sorry, but with this, I hope to establish a convention for method names that take one argument and those that take multiple arguments.
    
0.990073 2025-06-24
  [Performance Improvement]
    * Improve the logic of instance method call. malloc is not called each time when a method is called. Reused stack frames are implemented.
  [Internal Changes]
    * Reused stack frames are implemented. This is a big internal change with potential for memory corruption.
  [Bug Fix]
    * Fix a bug that "SPVM_OPCODE_BUILDER_build_opcodes: Assertion `mortal_stack_tops_index == 0'" occurs sometimes  in native methods.
  [New Features]
    * warn operator can receive an operand of a reference type.
    
0.990072 2025-06-23
  [New Features]
    Add address operator.
    
0.990071 2025-06-18
  [Incompatibe Changes]
    * Rename call_method_no_mortal_less_check_args native API to call_method_no_mortal_no_check_args.
    * Add decl_args_signature argument to call_method_no_mortal_less_check_args native API.
  [Ingernal Changes]
    * Add args_signature member variable to spvm_method.h.
    * Add args_signature member variable to spvm_runtime_method.h.
  [Performance Improvement]
    * Improve the logic of instance method call. If argument signature is matched, runtime type checking is skipped.
  [New Features]
    * Add get_args_signature method native API.
    * Add get_args_signature method to Native::Method class.
    
0.990070 2025-06-17
  [New Features]
    * Add call_method_no_mortal_less_check_args native API.
    * Add call_instance_method_no_mortal_less_check_args native API.
  [Performance Improvement]
    * Improve the logic of method call. Only if object argument check is needed, check it.
0.990069 2025-06-17
  [Internal Chnages]
    * Use __sync_fetch_and_add to get and set runtime memory_blocks_count member variable.
    * Use __sync_fetch_and_add to get and set object ref_count member variable.
    * Improve isa performance when types are exactly mached.
  [Changes]
    * make_read_only operator becomes thread safe.
    * set_no_free native API becomes thread safe.]
  [Bug Fix]
    * Fix bugs that can_assign type API did not work with type flags.
    * Fix bugs that compilation of resources detect force and quiet corectly in jit.
  [Changes]
    * Native class is not compiled when its SPVM class file is updaed.
    * Remove force => 1 from build_dynamic_lib_dist_native and build_dynamic_lib_dist_precompile written in Makefile.PL.
      And all possible depenent files are written in Makefile.
      This fixed the bug that all resource files are compiled if they are not updated.
      
  
0.990068 2025-06-16
  [Performance Improvement]
    * Improve peformance of method call, entering scope, leaving scope.
    
  [Internal Changes]
    * Add is_object_type member variable to spvm_runtime_basic_type.h.
    * Add has_object_args member variable to spvm_runtime_method.h.
    * Add return_type_is_object member variable to spvm_runtime_method.h.
  [Changes]
    * When calling a method from a native class,
      if the argument length is insufficient and no optional arguments are specified,
      the arguments will now be initialized to all 0-bit values instead of throwing an exception.
    
0.990067 2025-06-13
  [Exception Message Changes]
    * Change an exception message when instance method call without invocant.
      [Before]
      An instance method call failed. The invocant of the method call for %s#%s method must be defined.
      [After]
      The invocant of a method call must be defined.
    
    * Change an exception message when instance method call when the method is not found.
      Reported class name becomes the class name of the invocant instead of a declared class name.
      
      [Before]
      An instance method call failed. The implementation of %s#%s method is not found.
      [After]
      An instance method call failed. %s#%s method is not found.
  [New Features]
    * Add call_instance_method_no_mortal native API.
    * Add call_instance_method native API.

0.990067 2025-06-13
  [Incompatible Changes]
    * In this release, the syntax of exception handling for error classes is improved.
      
      [Before]
      eval {
        die Error::System "System Error";
      }
      
      if ($@) {
        if (eval_error_id isa_error Error::System) {
          # Do something for a system error
        }
        else {
          die eval_error_id, $@;
        }
      }
      
      [After]
      eval {
        die Error::System "System Error";
      }
      
      if ($@) {
        if ($@ isa Error::System) {
          # Do something for a system error
        }
        else {
          die $@;
        }
      }
      
    * Add the following syntax to isa operator and is_type operator.
    
      $@ isa TYPE_WITHOUT_STRING
      
      $@ is_type TYPE_WITHOUT_STRING
    * Add the following syntax to die stateiment.
    
      die $@;
    
0.990066 2025-06-12
  [Bug Fix]
    * Fix a bug that is_precompile_fallback method native API retunrs a correct value.
  [New Features]
    * Add Error::MethodCallNotPermitted class.
    * Add set_is_not_permitted native method API.
    * Add is_not_permitted native method API.
    * Add new_stack_with_all_method_call_permitted native API.
0.990065 2025-06-11
  [New Features]
    * Add SPVM archive feature to spvmcc command.
    * Add --build-spvm-archive option to spvmcc command.
    * Add SPVM::Builder::Config::Exe#external_object_files field.
    * Add SPVM::Builder::Config::Exe#add_external_object_file method.
    * Add SPVM::Builder::Config::Exe#load_spvm_archive method.
    * Add SPVM::Builder::Config::Exe#get_spvm_archive method.
    * Add SPVM::Builder::Config::Exe#spvm_archive_skip_classes field.
  [Internal Changes]
    * Remove --load-spvm-archive option from spvmcc command.
  [Incompatibe Changes]
    * The messages from SPVM::Builder::CC and spvmcc are printed to STDIO instead of STDERR.
    * utf8 pragma is enabled in config file.
    
  [Bug Fix]
    * Fix a bug that spvmcc --quiet option does not work in the compilation of resouce classes.
  [Changes]
    * Simplify config file generated by spvmdist command. Remove use strict etc.
    
0.990064 2025-06-09
  [Incompatible Changes]
    * In this release, the resource "mode" feature is removed.
      The decision was made because it would be better if resources were the same on every load,
      leaving only the option to change behavior based on environment variables.
      The mode feature is only for the config file for spvmcc command.
      
    * Remove mode field from SPVM::Builder::Resource.
    * Remove mode option from SPVM::Builder::Config#use_resource method.
    * Move mode field from SPVM::Builder::Config to SPVM::Builder::Config::Exe.
    * Move load_mode_config method from SPVM::Builder::Config to SPVM::Builder::Config::Exe.
    * Move load_base_config method from SPVM::Builder::Config to SPVM::Builder::Config::Exe.
    
  [Internal Changes]
    * Change the format of spvmcc.json.
    * Change the pathes of resouce object files generated by spvmcc command.
    * Remove "static_lib" output type from SPVM::Builder::CC#link method.
0.990063 2025-06-08
  [New Features]
    * Add --object-file option to spvmcc command. This will be public in the neer future release.
  [Internal Bug Fix]
    * Fix the output path of a bootstrap object file.
  [Internal Changes]
    * Add SPVM::Builder::CC#builder field.
    * Remove SPVM::Builder::CC#build_dir field.
    * Add SPVM::Builder#work_dir field.
    * Add --load-spvm-archive option which is not working yet to spvmcc command. This will be public in the neer future release.
    * Add --build-spvm-archive which is not working yet to spvmcc command. This will be public in the neer future release.
    * Remove create_build_xxx_path function in SPVM::Builder::Util and add create_build_xxx_path method to SPVM::Builder.
    * Temporary files created by spvmcc command is saved to each application directory.
  [Bug Fix]
    * Fix a bug of "multiple definition of `SPVM__Native__Env__DESTROY'"
      
      https://github.com/yuki-kimoto/SPVM/issues/732
      
0.990062 2025-06-04
  [Incompatible Changes]
    * The source file name and object file name of a bootstrap file generated by spvmcc command is changed.
      [Before]
      src/eval/anon_class/0.boot.c
      src/eval/anon_class/0.boot.o
      
      [After]
      src/bootstrap/myapp.c
      src/bootstrap/myapp.o
  [Incompatibe Changes]
    * The base name of the script name specified in spvm and spvmcc command must be a valid script base name.
    
      A script base name ends with C<.spvm>.

      A script base name without C<.spvm> consists of L<word characters|SPVM::Document::Language::Tokenization/"Word Characters"> and C<->.

      It dose not contains C<__>.

      It dose not begin with C<0-9>.

      It dose not begin with C<->.

      It dose not end with C<->.

      It dose not contains C<-->.
    * XXX_build_runtime function in a bootstrap file generated by spvmcc command is now public.
       
       void SPVM_BOOTSTRAP_myapp______build_runtime(SPVM_ENV* env, void* compiler)
       
  [Internal Changes]
    * bootstrap function have own name space.
    * Done a lot of refactoring of a bootstrap file generated by spvmcc command.
  [Changes]
    * Remove Fn::Resource. This class was for tests, but spvmdeps output this class.
  
0.990061 2025-06-03
  [Changes]
    * file option in SPVM::Builder::Config has no effect. That value is automatically set in load_config method.
  [Incompatible Changes]
    * Remove SPVM::Builder::Config#file_optional field.
0.990060 2025-06-03
  [Bug Fix]
    * Fix a bug that an anon class with anon methods caused segfault.
      
      SPVM::Thread segfault #730
      https://github.com/yuki-kimoto/SPVM/issues/730
      
0.990059 2025-06-02
  [Exception Message Improvement]
    * Improve exception messages in exchange APIs. Use Class#method representation in all places.
    * Improve exception messages thrown by spvm_api.c. Use Class#method representation in all places.
    * Improve exception messages. Use word "type requirement" instead of "type assignability".
  [Bug Fix]
    * Fix bugs that $@ is not set to undef in the end of eval block in the case of an excpetion is not thrown.
0.990058 2025-05-02
  [Note]
    * In this release, many imcompatible changes in spvmcc and SPVM::Builder::Config::Exe are performed.
  [New Features]
    * Add SPVM::Builder::Config#defines field.
    * Add SPVM::Builder::Config#add_define method.
    * Add the following methods to SPVM::Builder::Config::Exe.
      ccflags_global

      ccflags_spvm

      ccflags_native

      ccflags_native_class

      ccflags_precompile

      defines_global

      defines_spvm

      defines_native

      defines_native_class

      defines_precompile

      optimize_global

      optimize_spvm

      optimize_native

      optimize_native_class

      optimize_precompile

      include_dirs_global

      include_dirs_spvm

      include_dirs_native

      include_dirs_native_class

      include_dirs_precompile

      add_ccflag_global

      add_ccflag_spvm

      add_ccflag_native

      add_ccflag_native_class

      add_ccflag_precompile

      add_define_global

      add_define_spvm

      add_define_native

      add_define_native_class

      add_define_precompile
      
      add_include_dir_global

      add_include_dir_spvm

      add_include_dir_native

      add_include_dir_native_class

      add_include_dir_precompile

    * Add SPVM::Builder::LinkInfo#no_generate field.
    * Add SPVM::Builder::CompileInfo#no_generate field.
    * Remove current --include-dir option in spvmcc command. This option means source file include directory now.
    * Add the following options to spvmcc command.
      --ccflag
      --ccflag-spvm
      --ccflag-native
      --ccflag-native-class
      --ccflag-precompile
      --define
      --define-spvm
      --define-native
      --define-native-class
      --define-precompile
      --optimize
      --optimize-spvm
      --optimize-native
      --optimize-native-class
      --optimize-precompile
      --include-dir
      --include-dir-spvm
      --include-dir-native
      --include-dir-native-class
      --include-dir-precompile
    
  [Incompatible Changes]
    * Remove config_bootstrap field in SPVM::Builder::Config::Exe.
    * Rename config_spvm_core field to config_spvm in SPVM::Builder::Config::Exe.
    * Remove SPVM::Builder::Config::Exe#set_global_optimize method.
    * SPVM::Builder::Config#before_compile_cbs and SPVM::Builder::Config::Exe#global_before_compile_cbs are exected even if the output file is not needed to generate.
    * SPVM::Builder::Config#before_link_cbs is exected even if the output file is not needed to generate.
    * Remove SPVM::Builder::Config#after_create_compile_info_cbs, add_after_create_compile_info_cb and SPVM::Builder::Config::Exe#global_after_create_compile_info_cbs, add_global_after_create_compile_info_cb.
    * Remove SPVM::Builder::Config#after_create_link_info_cbs, add_after_create_link_info_cb.
    * Enable strict and warnings pragma in config file and use SPVM::Builder::Config and use SPVM::Builder::Config::Exe.
    * Remove config argv system because we decided to use environment variables.
      Remove config-argv and config-argv-option options in spvmcc command.
      Remove all resource and config argument argv passing.
    * Remove SPVM::Builder::Config::Exe#config_spvm field, SPVM::Builder::Config::Exe itself is used to compile SPVM core source files and a bootstrap file.
    * Rename SPVM::Builder::Config::Exe#add_global_before_compile_cb to add_before_compile_cb_global.
    * Rename SPVM::Builder::Config::Exe#global_before_compile_cbs to before_compile_cbs_global.
    
  [spvmcc Message Improvement]
    * Improve messages from spvmcc command.
  [Requirement Changes]
    * Require Perl 5.20.
  [Changes]
    * config file passed to before_compile_cbs is cloned one.
    * SPVM::Builder::Config#load_config's argv argument is optional.
0.990057 2025-04-25
  [Bug Fix]
    * Fix a bug that warn operator moves native mortal stack forward.
  [Internal Changes with some impact]
    * Remove unneeded native enter/leave scope logic from vm and precompile.
0.990056 2025-04-25
  [Revertion]
    * Revert "Remove unneeded native enter/leave scope logic from vm and precompile."

0.990055 2025-04-25
  [Internal Changes]
    * Mortal stack length has been reduced to the actual required length.
    * Cleanup exception logig in opcode_builder.c.
    * Fix bugs in scope. There was quite a bit of rework done to fix a bug (issue 715) regarding scope,
      where the mortal stack was using compile-time information and now uses dynamic information to fix bugs,
      and the LEAVE_SCOPE opcode has been reworked for this purpose.
  [Bug Fix]
    * Fix a scope bug referered by issue 715
    
      https://github.com/yuki-kimoto/SPVM/issues/715
      
      This bug is fixed, but other scope bugs is found.
    * Fix potential scope bugs that enter scope operation is not performed, but leave scope operation in the same scope is performed.
    
  [Incomptible Changes that are unlikely to have any impact]
    * Rename leave_scope_local internal native API to removed3.
    * Add new leave_scope_local internal native API at index 5.
  [Changes]
    * The condition part  in switch statement has own scope.
  [Big Internal Changes]
    * The AST logic for while and for statement are rewritten completely.
    * The AST logic for if and unless are rewritten completely.
    * The AST logic for switch is rewritten completely. Some potential scope bugs are fixed.
    
0.990054 2025-04-17
  [Changes]
    * Fn#substr method does not throw an eception even if $offset + $length is greater than the length of $string.
    * StringBuffer#substr method does not throw an eception even if $offset + $length is greater than the length of $string.
    * Remove runtime check for too many argument
  [Design Changes]
    Method calls no longer throw exceptions when they are passed too many arguments in runtime.
    The length of the arguments is reduced to the length of the methog.
    
0.990053 2025-04-17
  [Bug Fix with Incompatible Changes]
    * Fix operator precidence of ternary operator CONDITION ? LEFT : RIGHT.
      This now has the same operator precedence as Perl's one.
  [Changes that probably won't affect your program]
    * Clarified operator precedence.
      
      ,
      =>
      )
      (
      [
      {
      
  [New Features]
    * Add raw string literal \C, \E, \Q.
    * Add Fn#range method.
  
  [Design Bug Fix with Incompatible Changes]
    
    Fn#substr method returns always cut string, not replaced string. This was design mistake.
    
    The replaced string is set to the first argument when it is a string array of 1-length.
    
0.990052 2025-04-04
  [Bug Fix]
    * Fix a bug that assignment of sequencial operator caused segfault.
  [New Features]
    * Add special assign operator //=.
    * Add copy_fields statement.
      
      copy_fields $foo, $bar, Point;
      
0.990051 2025-04-03
  [Incompatible Changes]
    * The return type of ternary operator becomes the type of the left operand.
    
0.990050 2025-04-02
  [New Features]
    * Add Error::FieldNotSpecified class.
    * Add StringBuffer#splice method.
    * Allow sequencial operator to use if statement.
    
      (OPERAND1, OPERAND2, ..., IF_STATEMENT, OPERANDn)
    * Add defined-or operator
      
      $left // $bar
      
    * Add ternary operator
      
      $condition ? $left : $rigth
      
0.990049 2025-03-21
  [Document Fix]
    * Fix an example of a doc for lib directive.
  [Document Improvement]
    * Improve documents for lib directive.
    * Add links to SPVM::Document from its child documents.
    
0.990048 2025-03-12
  [Bug Fix]
    * Fix a bug that duplicate fields in parent and child does not work well.
    
0.990047 2025-03-12
  [Bug Fix]
    * Fix a bug that super class's DESTROY method is not called in its child class in some cases.
    
0.990046 2025-03-11
  [Changes]
    * The right type of is_compile_type operator is allowed to be specify type modifier(such as mutable).
  
  [Incompatible Changes]
    * is_compile_type operator checks the equality that contains type modifier.
    * The return type of new_string_len operator becomes mutable string. Originally this is string.
0.990045 2025-02-21
  [New Features]
    * Add local temporary variable feature. $_ is a local temporary variable. A internally named temporary variable is created each when $_ is declared.
      
      my $_ = 1;
      
      my $_ = 2;
      
      my $_ = Point->new;
  [Incompatible Changes]
    * Changes the definition of Fn#grep method.
      [Before]
      static method grep : object[] ($array : object[], $callback : Callback::Grep);
      [After]
      static method grep : object[] ($callback : Callback::Grep, $array : object[]);
      
    * Changes the definition of Fn#map method.
      [Before]
      static method map : object[] ($array : object[], $callback : Callback::Map);
      [After]
      static static method map : object[] ($callback : Callback::Map, $array : object[]);
    * Changes the definition of Fn#map_expand method.
      [Before]
      static method map_expand : object[] ($array : object[], $callback : Callback::MapExpand);
      
      [After]
      static method map_expand : object[] ($callback : Callback::MapExpand, $array : object[]);
0.990044 2025-02-19
  [New Features]
    * Add StringBuffer#index method.
    * Add StringBuffer#contains method.
    * Add ByteList#clone method.
    * Add ShortList#clone method.
    * Add IntList#clone method.
    * Add LongList#clone method.
    * Add FloatList#clone method.
    * Add DoubleList#clone method.
    * Add List#clone method.
    * Add StringList#clone method.
    * Add Cloneable interface to ByteList class.
    * Add Cloneable interface to ShortList class.
    * Add Cloneable interface to IntList class.
    * Add Cloneable interface to LongList class.
    * Add Cloneable interface to FloatList class.
    * Add Cloneable interface to DoubleList class.
    * Add Cloneable interface to List class.
    * Add Cloneable interface to StringList class.
    * Add push_array and unshift_array method to ByteList, ShortList, IntList, LongList, FloatList, DoubleList, List, StringList.
    * Add splice method to ByteList, ShortList, IntList, LongList, FloatList, DoubleList, List, StringList.
    
0.990043 2025-02-07
  [New Features]
    * Add StringBuffer#compare_string method.
    * Add StringBuffer#equals_string method.
    * Add StringBuffer#substr method.
  [Internal Chnages]
    * Cleanup logic of error of code generated by spvmcc command.
  [Incompatible Changes]
    * The defalut access control of new operator becomes protected instead of private.
    * The defalut access control of field access becomes protected instead of private.
    * The defalut access control of class variable access becomes protected instead of private.
0.990042 2025-01-22
  [New Features]
    * Add cache class variable attribute.
    * Add is_cache class variable native API.
    * Add Native::ClassVar#is_cache method.
    * Add destroy_cache_class_vars native API.
    * Add Fn#destroy_cache_class_vars method.
    * Add Fn#destroy_runtime_permanent_vars method.
  [Compilation Error Message Changes]
    * Change compilation error message.
      [Before]
      The private MyClass2#$FOO class variable cannnot be called from the current class MyClass
      
      [After]
      The private $MyClass2::FOO class variable cannnot be called from the current class MyClass
  [Changes]
    * Replace $api->set_exception(undef); with SPVM::Fn->destroy_runtime_permanent_vars: in basic.t generated by spvmdist command.
    
0.990041 2025-01-20
  [Incompatibe Changes]
    * Remove deprecated CommandInfo#$BASE_TIME method.
    
0.990040 2025-01-20
  [New Features]
    * Add CommandInfo#WARNING class variable.
    * Add set_command_info_warning native API.
    * Add -w flag to spvm command.
    * Add -w flag to spvmcc command.
  [Incompatibe Changes]
    * Rename set_command_info_base_time native API to set_command_info_basetime.
    * Rename CommandInfo#$BASE_TIME class variable to $BASETIME. BASE_TIME gettor is deprecated and will be removed in the future.
    
0.990039 2025-01-13
  [Internal Changes]
    * Clanup .gitignore.
    * Clanup MANIFEST.skip.
  [Changes]
    * Changes .gitignore file generated by spvmdist command.
    
      [After]
      /blib
      /Makefile
      /Makefile.old
      /MYMETA.yml
      /MYMETA.json
      /pm_to_blib
      /core.*
      /core
      /SPVM-*
      *.bak
      *.BAK
      *.tmp
      *.o
      *.bs
      .tmp
      .git
      .spvm_build

    * Changes MANIFEST.SKIP file generated by spvmdist command.
      
      [After]
      ^blib(/|$)
      ^Makefile$
      ^Makefile.old$
      ^MYMETA.yml$
      ^MYMETA.json$
      ^pm_to_blib$
      ^core\.
      ^core$
      ^SPVM-
      \.bak$
      \.BAK$
      \.tmp$
      \.o$
      \.bs$
      (^|/)\.tmp(/|$)
      (^|/)\.git(/|$)
      (^|/)\.spvm_build(/|$)
    * $config->is_resource(1); is contained in the config file generated by spvmdist command with --resource option.
    * Load the class in SPVM class file generaged by spvmdist command with --resource option.
  [New Features]
    * Add --version_from option to spvmdist command.
    * Add mode field to SPVM::Builder::Config.
  [Exception Message Improvement]
    * Compilation messages of resources are improved.
  [Incompatible Changes]
    * The resource class used from a config file must be loaded.
  [Document Improvement]
    * Use upper case option value in docs for spvm, spvmcc, spvmdeps, spvmdist commands.
0.990038 2025-01-09
  [Bug Fix]
    * Fix a bug that when resource class is loaded more than once, spvmcc failed.
    * Fix a bug that an anon class name is not corresponding to its file name.
  [New Features]
    * Add SPVM::Builder::Config#is_resource accessor method.
    
  [Incompatible Changes]
    * Remove SPVM::Builder::Config#used_as_resource accessor method.
    * Remove SPVM::Builder::Config#no_compile_resource accessor method.
    
0.990037 2025-01-08
  
  [Incompatible Changes]
    * Rename SPVM::Builder::Config::Info to SPVM::Builder::ScriptInfo.
    * SPVM::Builder::ScriptInfo#get_class_names returns also multi-numeric types.
    * Remove --resource-info option in spvmcc command in favor of spvmdeps command.
    * Remove --dependency option in spvmcc command in favor of spvmdeps command.
    * Remove --dependency-cpan option in spvmcc command in favor of spvmdeps command.
    
  [Internal Changes]
    * Rename version_from_basic_type_name member in struct spvm_basic_type to basic_type_name_in_version_from.
    * Rename version_from_basic_type member in struct spvm_runtime_basic_type to basic_type_in_version_from.
    * Add SPVM::Builder::Native::BasicType#get_basic_type_in_version_from.
  [New Features]
    * Add get_basic_type_in_version_from basic type native API.
    * Add Native::BasicType#get_basic_type_in_version_from method.
  
  [Bug Fix]
    * Fix a bug that Native::BasicType#get_parent method does not work well.
    * Native::BasicType#get_version_string method returns undef if it is not specified.
    * SPVM::Builder::Native::BasicType#get_version_string method returns undef if it is not specified.

0.990036 2025-01-07

  [New Features]
    * Add version_from statement.
    * Add get_basic_type_name_in_version_from native API.
    * Add Fn#get_basic_type_name_in_version_from method.
    * Add SPVM class.
    * Add version_from SPVM to all classes.
  [Document Changes]
    * The heading "Version Statement" to "version Statement".
    * Add docs for Fn#get_version_string method.
  [Changes]
    * Fn#rand method throws an exception unless $max is greater than 0.
    * Add check for the reference argument of Fn#crand.
    * Add check for the reference argument of Fn#get_code_point.
  [Bug Fix]
    * Fix a bug that SPVM_NATIVE_VERSION_STRING is not used as an operator.
    * Fix a bug that Error::Compile class is not recognized.
    
0.990035 2025-01-04
  
  [New Features]
    * Add Fn#dump_object_internal method.
    * Add dump_object_internal native API.
    * Add Fn#set_no_free method.
    * Add set_seed native API.
    * Add get_seed native API.
    * Add seed_initialized native API.
    * Add Fn#set_seed method.
    * Add Fn#get_seed method.
    * Add Fn#seed_initialized method.
    
  [Changes]
    * Add argument count check to native method call.
    * no_free native API returns 1 if no_free flag is enabled.
    
0.990034 2025-01-01
  [Changes]
    * Changes the order of file of MANIFEST.skip and .gitignore generated by spvmdist.
    * Allow right operand of == operater undef in the case that the left operand is reference type.
    * Allow right operand of != operater undef in the case that the left operand is reference type.
    
  [Bug Fix]
    * Fix a bug that Format->strpinf("%s", "") does not work well.
  [Changes]
    * Format->strpinf("%s", undef) is treaded as Format->strpinf("%s", "");
  [Compilation Error Messages Improvement]
    * Improve a compilation error massage.
      [Before]
      The types other than the numeric type and the object type cannnot be used in the optional argument.
      [After]
      The optional argument %s is not allowed. The type must be a numeric type, an object type, or a numeric reference type.
    * Improve a compilation error massage.
      [Before]
      Arguments after optional arguments must be optional arguments.
      [After]
      Optional arguments must be placed at the end of the arguments.
   [New Features]
     * Allow optional argument in numeric reference type.
       
       method foo ($ref : int* = undef);
     * Allow optional argument in multi-numeric reference type.
       
       method foo ($ref : Complex_2d* = undef);
     * Allow numeric comparison operator a referene type == undef
     * Allow numeric comparison operator a referene type != undef
     
   [Incompatible Changes]
     * undef can assign to a reference type. This means you must check the reference is NULL in native classes.
     * undef can cast to a reference type. This means you must check the reference is NULL in native classes.
     
   [Internal Changes]
     * SPVM_IMPLEMENT_GET_DEREF_BYTE changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_DEREF_SHORT changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_DEREF_INT changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_DEREF_LONG changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_DEREF_FLOAT changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_DEREF_DOUBLE changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_DEREF_BYTE changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_DEREF_SHORT changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_DEREF_INT changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_DEREF_LONG changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_DEREF_FLOAT changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_DEREF_DOUBLE changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_BYTE changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_SHORT changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_INT changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_LONG changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_FLOAT changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_DOUBLE changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_BYTE changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_SHORT changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_INT changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_LONG changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_FLOAT changes from macro function to inline function.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_DOUBLE changes from macro function to inline function.
     * SPVM_IMPLEMENT_GET_DEREF_BYTE throws an exception when input is undef.
     * SPVM_IMPLEMENT_GET_DEREF_SHORT throws an exception when input is undef.
     * SPVM_IMPLEMENT_GET_DEREF_INT throws an exception when input is undef.
     * SPVM_IMPLEMENT_GET_DEREF_LONG throws an exception when input is undef.
     * SPVM_IMPLEMENT_GET_DEREF_FLOAT throws an exception when input is undef.
     * SPVM_IMPLEMENT_GET_DEREF_DOUBLE throws an exception when input is undef.
     * SPVM_IMPLEMENT_SET_DEREF_BYTE throws an exception when output is undef.
     * SPVM_IMPLEMENT_SET_DEREF_SHORT throws an exception when output is undef.
     * SPVM_IMPLEMENT_SET_DEREF_INT throws an exception when output is undef.
     * SPVM_IMPLEMENT_SET_DEREF_LONG throws an exception when output is undef.
     * SPVM_IMPLEMENT_SET_DEREF_FLOAT throws an exception when output is undef.
     * SPVM_IMPLEMENT_SET_DEREF_DOUBLE throws an exception when output is undef.
     * SPVM_IMPLEMENT_DEREF_MULNUM_BYTE throws an exception when input is undef.
     * SPVM_IMPLEMENT_DEREF_MULNUM_SHORT throws an exception when input is undef.
     * SPVM_IMPLEMENT_DEREF_MULNUM_INT throws an exception when input is undef.
     * SPVM_IMPLEMENT_DEREF_MULNUM_LONG throws an exception when input is undef.
     * SPVM_IMPLEMENT_DEREF_MULNUM_FLOAT throws an exception when input is undef.
     * SPVM_IMPLEMENT_DEREF_MULNUM_DOUBLE throws an exception when input is undef.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_BYTE throws an exception when input is undef.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_SHORT throws an exception when input is undef.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_INT throws an exception when input is undef.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_LONG throws an exception when input is undef.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_FLOAT throws an exception when input is undef.
     * SPVM_IMPLEMENT_GET_MULNUM_FIELD_DEREF_DOUBLE throws an exception when input is undef.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_BYTE throws an exception when input is undef.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_SHORT throws an exception when input is undef.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_INT throws an exception when input is undef.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_LONG throws an exception when input is undef.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_FLOAT throws an exception when input is undef.
     * SPVM_IMPLEMENT_SET_MULNUM_FIELD_DEREF_DOUBLE throws an exception when input is undef.
     * Add SPVM_OPCODE_C_ID_MOVE_REF_UNDEF opcode.
     * Rename SPVM_OPCODE_C_ID_IS_UNDEF to SPVM_OPCODE_C_ID_IS_UNDEF_OBJECT.
     * Rename SPVM_OPCODE_C_ID_IS_NOT_UNDEF to SPVM_OPCODE_C_ID_IS_NOT_UNDEF_OBJECT.
     * Add SPVM_OPCODE_C_ID_IS_UNDEF_REF.
     * Add SPVM_OPCODE_C_ID_IS_NOT_UNDEF_REF.
0.990033 2024-12-17
  [Bug Fix]
    * Fix a bug that rehash of Hash class dose not copy weaken flag.
      
      https://github.com/yuki-kimoto/SPVM/issues/649
      
0.990032 2024-12-02
  [New Features]
    * Add pointer attribute to the following classes.
      
      Native::API
      Native::Arg
      Native::BasicType
      Native::ClassFile
      Native::ClassVar
      Native::Field
      Native::Method
      Native::MethodCall
    * Add C, S, L, Q specifiers to Packer#unpack and Packer#pack methods.
    * Add H, h specifiers to Packer#unpack and Packer#pack methods.
    * Support wildcard * in Packer#unpack and Packer#pack methods.
    * Add print_exception_to_stderr native API.
  [Performance Improvement]
    * Methods in Packer class are precompiled.
  [Internal Changes]
    * Add Native::BasicType#ref_class_var field.
    * Add Native::BasicType#ref_field field.
    * Add Native::BasicType#ref_arg field.
    * Add Native::Arg#ref_method field.
  [Bug Fix]
  [Compilation Bug Fix]
    * Fix a bug that version statement caused a segmentation fault when a number is given.
  [Warnings Fix]
    * Fix the following warning in child class.
      
      While trying to resolve method call %s->%s() can not locate package "%s" yet it is mentioned in @%s::ISA (perhaps you forgot to load "%s"?)
  [Bug Fix]
    * Fix a bug that die native API do not set correct exception message when get_stack_tmp_buffer is used.
      https://github.com/yuki-kimoto/SPVM/issues/639
    * Fix Native::Compiler bugs that runtime object is not set.
   
0.990031 2024-11-17
  [New Features]
    * Add Hash#weaken method.
    * Add Hash#unweaken method.
    * Add Hash#isweak method.
    
0.990030 2024-11-15
  [New Features]
    * Add lib directive.
      
      #lib "$FindBin::Bin/lib"
    * spvm command can detect class search directories specified by lib directive.
    * spvmcc command can detect class search directories specified by lib directive.
    
    * Support SPVM script such as the following script that has a sheban line.
      
      #!spvm
      
      #lib "$FindBin::Bin/../lib/SPVM"
      
      class {
        use TestCase;
        
        static method main : void () {
          
          my $sum = TestCase->sum(1000, 2000);
          
          say "$sum";
        }
      }

  [Changes]
    * A file directive before a shebang line is allowed.
    
      #!command
      #file "FILE_PATH"
  [Compilation Error Messages Improvement]
    * Fix A compilation error message.
      
      [Before]
      A file in a line directive must end with ".
      
      [After]
      A file in a file directive must end with ".
  [Document Changes]
    * The heading "File Directive" is renamed to "file Directive".
    * The heading "Line Directive" is renamed to "line Directive".
    
0.990029 2024-11-08
  [New Features]
    * Add SPVM::Builder::ConfigBuilder class.
    * Add Native::MethodCall#new_proto_with_method_name method.
    * Add get_stack_tmp_buffer native API.
  [Internal Changes]
    * Change the following constants for stack data to be more safe.
      
      [Before]
      enum {
        SPVM_API_C_STACK_INDEX_EXCEPTION = 511,
        SPVM_API_C_STACK_INDEX_MORTAL_STACK = 510,
        SPVM_API_C_STACK_INDEX_MORTAL_STACK_TOP = 509,
        SPVM_API_C_STACK_INDEX_MORTAL_STACK_CAPACITY = 508,
        SPVM_API_C_STACK_INDEX_ARGS_WIDTH = 507,
        SPVM_API_C_STACK_INDEX_CALL_DEPTH = 506,
        SPVM_API_C_STACK_INDEX_ENV = 503,
        SPVM_API_C_STACK_INDEX_TMP_BUFFER = 256,
      };
      
      [After]
      enum {
        SPVM_API_C_STACK_INDEX_TMP_BUFFER = 384, // 384 to 511
        SPVM_API_C_STACK_INDEX_EXCEPTION = 383,
        SPVM_API_C_STACK_INDEX_MORTAL_STACK = 382,
        SPVM_API_C_STACK_INDEX_MORTAL_STACK_TOP = 381,
        SPVM_API_C_STACK_INDEX_MORTAL_STACK_CAPACITY = 380,
        SPVM_API_C_STACK_INDEX_ARGS_WIDTH = 379,
        SPVM_API_C_STACK_INDEX_CALL_DEPTH = 378,
        SPVM_API_C_STACK_INDEX_ENV = 377,
      };
    * Remove SPVM_API_C_TMP_BUFFER_SIZE. Use SPVM_NATIVE_C_STACK_TMP_BUFFER_SIZE.
0.990028 2024-11-04
  [Internal Changes]
    * The related classes of Native::Compiler use new_pointer method instead of new_pointer_object_by_name native API.
  [Document Improvement]
    * Add the doc for "Pointer Value".
    * Improve docs for Pointer Class.
0.990027 2024-11-03
  [New Features]
    * Add Fn#get_pointer method.
    * Add Fn#set_pointer method.
    * Add Fn#has_null_pointer method.
    * Add Fn#eq_pointer method.
    * Add Fn#pointer_to_string method.

  [Exception Message Fix]
    * Fix the line number of the following exception message.
    
      %s#%s method must be an instance method because its interface method is defined in %s %s.
      
      %s#%s method must be an instance method.
      
      The length of the arguments of %s#%s method must be greater than or equal to the length of the required arguments of %s#%s method.
      
      The %dth argument(%s type) of %s#%s method must be able to be assigned to the %dth argument(%s type) of %s#%s method.
  [Changes]
    * Allow empty strings in the ccflags of a compiler comamnd excecuted spvmcc command.
    * Allow empty strings in the ldflags of a linker comamnd excecuted spvmcc command.
    
0.990026 2024-11-01
  [New Features]
    * Add -c option to spvm command.
    * Add no_free native API.
    * Add set_no_free native API.
    * Add Fn#no_free method.
    
  [Incompatible Changes]
    * Remove as_bool operator added at 0.990025 2024-10-25
      bacause field setters cannot behave this way and creating 0 or 1 has no meaing.
  [Internal Changes]
    * Add SPVM_OBJECT_C_FLAG_NO_FREE to spvm_object struct.
    * Remove Native::Stack#no_destroy field. Use no_free flag.
    * Remove Native::Env#no_destroy field. Use no_free flag.
0.990025001 2024-10-26
  [Document Fix]
    * Fix docs for the following native APIs.

      set_class_var_byte_by_name native API
      set_class_var_short_by_name native API
      set_class_var_int_by_name native API
      set_class_var_long_by_name native API
      set_class_var_float_by_name native API
      set_field_byte_by_name native API
      set_field_short_by_name native API
      set_field_int_by_name native API
      set_field_long_by_name native API
      set_field_float_by_name native API
    
0.990025 2024-10-25
  [Test Improvement]
    * Add tests for NaN comparison and NaN condition evaluation.
  [New Features]
    * Add as_bool operator.
    * Add is_numeric_type type native API.
    * Add is_class_type type native API.
  [Internal Changes]
    * SPVM_OP_C_ID_BOOL is renamed to SPVM_OP_C_ID_CONDITION_EVALUATION.
  [Exception Message Improvement]
    * Improve exception messages in Hash class.
  [Changes]
    * Hash#get_int method can get a value from Byte, Short, Int object.
    * Hash#get_short method can get a value from Byte, Short object.
    * Hash#get_long method can get a value from Byte, Short, Int, Long object.
  [Bug Fix]
    * Fix a bug that get_type_width type native API did not work well when the argument type is a multi-numeric reference type.
  [Changes]
    * Improve the type check of the invocant in get_field_byte_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in get_field_short_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in get_field_int_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in get_field_long_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in get_field_double_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in get_field_object_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in set_field_byte_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in set_field_short_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in set_field_int_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in set_field_long_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in set_field_float_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in set_field_double_by_name native API. The invocant must be a class type.
    * Improve the type check of the invocant in set_field_object_by_name native API. The invocant must be a class type.
  [Changes with Potentially Incompatible Change]
    * Improve the type check of the field in get_field_byte_by_name native API. The field must be byte type.
    * Improve the type check of the field in get_field_short_by_name native API. The field must be within short type.
    * Improve the type check of the field in get_field_int_by_name native API. The field must be within int type.
    * Improve the type check of the field in get_field_long_by_name native API. The field must be within long type.
    * Improve the type check of the field in get_field_float_by_name native API. The field must be within float type.
    * Improve the type check of the field in get_field_double_by_name native API. The field must be within double type.
    * Improve the type check of the field in get_field_object_by_name native API. The field must be an object type.
    * Improve the type check of the field in get_field_object_ref_by_name native API. The field must be an object type.
    * Improve the type check of the field in set_field_byte_by_name native API. The field must be byte or large type.
    * Improve the type check of the field in set_field_short_by_name native API. The field must be short or large type.
    * Improve the type check of the field in set_field_int_by_name native API. The field must be int or large type.
    * Improve the type check of the field in set_field_long_by_name native API. The field must be long or large type.
    * Improve the type check of the field in set_field_float_by_name native API. The field must be float or large type.
    * Improve the type check of the field in set_field_double_by_name native API. The field must be double or large type.
    * Improve the type check of the field in set_field_object_by_name native API. The field must be an object type.
    * Improve the type check of the class_var in get_class_var_byte_by_name native API. The class variable must be byte type.
    * Improve the type check of the class_var in get_class_var_short_by_name native API. The class variable must be within short type.
    * Improve the type check of the class_var in get_class_var_int_by_name native API. The class variable must be within int type.
    * Improve the type check of the class_var in get_class_var_long_by_name native API. The class variable must be within long type.
    * Improve the type check of the class_var in get_class_var_float_by_name native API. The class variable must be within float type.
    * Improve the type check of the class_var in get_class_var_double_by_name native API. The class variable must be within double type.
    * Improve the type check of the class_var in get_class_var_double_by_name native API. The class variable must be an object type.
    
    * Improve the type check of the class_var in set_class_var_byte_by_name native API. The class variable must be byte or larger type.
    * Improve the type check of the class_var in set_class_var_short_by_name native API. The class variable must be short or larger type.
    * Improve the type check of the class_var in set_class_var_int_by_name native API. The class variable must be int or larger type.
    * Improve the type check of the class_var in set_class_var_long_by_name native API. The class variable must be long or larger type.
    * Improve the type check of the class_var in set_class_var_float_by_name native API. The class variable must be float or larger type.
    * Improve the type check of the class_var in set_class_var_double_by_name native API. The class variable must be double type.
    * Improve the type check of the class_var in set_class_var_double_by_name native API. The class variable must be an object type.
0.990024 2024-10-23
  [New Features]
    * Allow multiple INIT blocks.
      
      class Foo {
        
        INIT {
        
        }
        
        INIT {
          
        }
      }

  [Internal Changes]
    * Add SPVM_BLOCK_C_ID_INIT_BLOCK to spvm_block.h.
    * Remove SPVM_OP_C_ID_INIT_BLOCK from spvm_op.h.
    * Add init_statements member variable to spvm_basic_type.h.
    * Add SPVM_TYPE_is_user_defined_type.
  [Test Improvement]
    * Add tests for INIT block.
  [Document Changes]
    
    * Change a token name in SPVM::Document::Language::SyntaxParsing.
    * Improve docs for INIT statement.
  [Bug Fix]
    * Fix a warning related to inheritance problem in exchange API.
      
      https://github.com/yuki-kimoto/SPVM/issues/606
      
0.990023 2024-10-18
  [Exception Message Fix]
    * Fix an exception message "An array setting failed. The invocant must be defined." on a field.
      
      [After]
      An field access failed. The invocant must be defined.

0.990022 2024-10-17
  [Bug Fix]
    * Fix a bug that compilation error messages were cut off.
    
      https://github.com/yuki-kimoto/SPVM/issues/603
    
0.990021 2024-10-12
  [New Features]
    * Add Array#repeat method.
    
  [Improvement]
    
    * Fix an exception message in Fn#repeat method.
    * Improve the performance of Fn#repeat method.
    * Fix docs in Fn#repeat method. The return type was wrong.
    
0.990020 2024-10-12
  [Bug Fix]
    * Fix a bug that child class does not call DESTROY method of its super class.
  
  [Changes]
    * Allow the same type and name field in a child class.
    
0.990019 2024-10-08
  [New Features]
    * Add --dependency-cpan option to spvmcc command.
  [Incompatible Changes]
    * spvmcc  --dependency option do not contains SPVM.
  [Document Fix]
    * Fix docs for spvmcc --dependency option.
0.990018 2024-10-08
  [New Features]
    * Add --dependency option to spvmcc command.
  [Internal Changes]
    * Add get_version_string method to SPVM::Builder::Native::BasicType.
    * Add get_spvm_version_string method to SPVM::Builder::Native::Runtime module.
    * Add dump_dependency method to SPVM::Builder::Exe module.
0.990017 2024-10-07
  [Exception Message Changes]
    * Change an exception message.
      [Before]
      $var variable is not found.
      [After]
      $var is not found.
      
  [Internal Changes]
    * is_init member variable in spvm_method.h and spvm_runtime_method.h is renamed to is_init_method.
    * Add SPVM_OP_C_ID_INIT_BLOCK to spvm_op.h
    * Remove init_method argument of SPVM_OP_build_method_definition function.
    * SPVM_OP_build_class_var_definition is renamed to SPVM_OP_build_class_var.
    * SPVM_OP_build_enumeration_definition is renamed to SPVM_OP_build_enumeration.
    * SPVM_OP_build_field_definition is renamed to SPVM_OP_build_field.
    * SPVM_OP_build_method_definition is renamed to SPVM_OP_build_method.
    * Remove op_list_anon_method_fields argument from SPVM_OP_build_method.
  [Document Changes]
    * token names are changes in SPVM::Document::Language::SyntaxParsing
  [Bug Fix]
    * Fix a bug that anon method local variable declaration cause a leak of memory allocation.
      
      #567
      
0.990016 2024-10-05
  [Internal Changes]
    * SPVM::Builder::Native::Compiler#compile and compile_anon_class methods throw an exception when a compliation failed.
  [Changes]
    * spvm command throw an exception when command line options are invalid.
    * spvmcc command throw an exception when command line options are invalid.
    * spvmdist command throw an exception when command line options are invalid.
    
  [New Features]
    * Add --resource-info option to spvmcc command.
    
  [Exception Changes]
    * An exception in spvmcc is changed to a warning if Foo.config exists, but Foo.c do not exists.
      
      [Warning]Can't find source file.
  [Document Improvement]
  
    * Add the way to search dependent resourcees to the help of spvmcc command.
    
0.990015 2024-10-04
  [Exception Message Improvement]
    * An exception message in an array access is improved.
      
      [After]
      An array access failed. The index is out of range.
  [Incompatible Changes]
    * Remove deprecated <class_name> argument in spvm command. This is a big imcompatible change, but without this, the bug that FindBin->Bin do not work well will be not fixed.
    * Remove deprecated <class_name> argument in spvmcc command. This is a big imcompatible change, but without this, the bug that FindBin->Bin do not work well will be not fixed.
  [New Features]
    * Add -E option to spvm command.
    
0.990014 2024-10-04
  [New Feature]
    * spvm command support script name. Currently script name must start with [a-z] or contain / or \ because of class name argument is not removed.
      
      spvm path/foo.spvm
      spvm foo.spvm
      spvm foo
      
      the script contains main method in an anon class.
      
        class {
          static method main : void () {
            
          }
        }
      
    * spvmcc command support script name. Currently script name must start with [a-z] or contain / or \ because of class name argument is not removed.
      
      spvmcc path/foo.spvm
      spvmcc foo.spvm
      spvmcc foo
      
      the script contains main method in an anon class.
      
        class {
          static method main : void () {
            
          }
        }
      
  [Deprecation]
    * Deprecate spvm command's class name argument.
    
      spvm Foo
      
      this will be changed to script name in a future release.
      
      spvm path/foo.spvm
    
    * Deprecate spvmcc command's class name argument.
    
      spvmcc Foo
      
      this will be changed to script name in a future release.
      
      spvmcc path/foo.spvm
      
  [Improve Compilation Error Messages]
    * Improve a compilation message in file derective.
      
      A file directive must start with '\"'.
  [Internal Bug Fix]
    * Fix a bug that compile_with_exit do not receive the file and line in arguments in SPVM::Global::build_class.
  [Bug Fix]
    * Fix a bug that spvm command -e option do not work well in precompilation and native methods.
0.990013 2024-10-02
  [New Features]
    * Add Fn#pack method.
    * Add Fn#unpack method.
    * Add Packer class.
    * Add Fn#system_endian_to_little_endian method.
    * Add Fn#little_endian_to_system_endian method.
    * Add optional $offset argument to Fn#change_endian method.
    * Add optional $offset argument to Fn#big_endian_to_system_endian method.
    * Add optional $offset argument to Fn#system_endian_to_big_endian method.
    
0.990012 2024-09-26
  [New Features]
    * Add Fn#system_endian_to_big_endian method.
    * Add Fn#big_endian_to_system_endian method.
    * Add Fn#change_endian method.
    * Add Fn#sort method.
    * Add Fn#sort_asc method.
    * Add Fn#sort_desc method.
    * Add Fn#sprintf method.
    * Add Fn#system_is_little_endian method.
0.990011 2024-09-20
  [New Features]
    * Add Array#shuffle method.
    * Add Array#shuffle_any_numeric method.
    * Add Fn#reverse method.
    * Add Fn#slice method.
0.990010 2024-09-18
  [New Features]
    * Add Fn#length method.
    * Add Fn#get_elem_or_char_size method.
    * Add Array#new_proto_any method.
    * Add Array#copy_any_numeric method.
    * Add Fn#copy method.
    * Add Cloner#default_cloner method.
    * Add Comparator#default_comparator method.
    * Add EqualityCheckable interface.
    * Add eq method to Point class.
    * Add eq method to Point3D class.
    * Add eq method to StringBuffer class.
    * Add EqualityChecker#default_equality_checker method.
    * Add $shallow argument to Array#equals method.
  [Changes]
    * x and y field in Point class becomes protected.
    * Point class has EqualityCheckable interface.
    * Point3D class has EqualityCheckable interface.
    * StringBuffer class has EqualityCheckable interface.
  [Bug Fix]
    * Fix a bug that static method call is not used in anon method.
    
      https://github.com/yuki-kimoto/SPVM/issues/582
    
0.990009 2024-09-11
  [New Features]
    * Add SPVM_NATIVE_C_STACK_TMP_BUFFER_SIZE to spvm_native.h
    * Add get_stack_tmp_buffer internal native API.
    * Add the following methods to Complex_2d multi-numeric type.
    
      new

      new_array_from_pairs

      new_array_from_re_array

      new_array_from_im_array

      to_re_array

      to_im_array

      to_pairs

      to_string

    * Add the following methods to Complex_2f multi-numeric type.
    
      new

      new_array_from_pairs

      new_array_from_re_array

      new_array_from_im_array

      to_re_array

      to_im_array

      to_pairs

      to_string

  [Revert]
    * Revert the following change in 0.990008 for performance degradation.
      
      * Use a new runtime stack for DESTROY method instead of using the current runtime stack.
    
  [Internal Changes]
    * Improve runtime save/restore logic in destructor.
    * Add the following enum values in spvm_api.h
      SPVM_API_C_STACK_INDEX_TMP_BUFFER = 256,
      SPVM_API_C_TMP_BUFFER_SIZE = 512,
      SPVM_API_C_STACK_LENGTH = 512,
    * Use snprintf instead of sprintf in all places in SPVM_API_dump_recursive function in spvm_api.c.
    * Use the temporary buffer of the runtime stack in SPVM_API_dump_recursive function in spvm_api.c.
    * Use the temporary buffer of the runtime stack in SPVM_API_new_stack_trace_no_mortal function in spvm_api.c.
    * Reduce SPVM_API_new_memory_block calls in SPVM_API_die function in spvm_api.c.
    * Add SPVM_API_get_stack_tmp_buffer function to spvm_api.c.
    * Add SPVM_API_INTERNAL_get_stack_tmp_buffer to spvm_api_internal.c.
    * Use the temporary buffer in a runtime stack is used in any place in spvm_implement.h.
  
  [Changes]
    * Allow multi-numeric type to have class methods.
  
  [Test Fix]
    * Change a variable name in a test for the following issue.
      
      https://github.com/yuki-kimoto/SPVM/issues/567
      
      Some Mac clang compilier may cause this problem, but I don't know the reason for now.
      
0.990008 2024-09-10
  [New Features]
    * Add Fn#memcmp method.
    * Add Comparable interface.
    * Add StringBuffer#cmp method.
    * StringBuffer class has Comparable interface.
    * Add new syntax for anon method field definition. You can use the varialbe name that is different from the varialbe name of a default value.
    
      VAR : ATTRIBUTE1 ATTRIBUTE2 ATTRIBUTEn TYPE = OPERAND
      
      # Example
      {
        my $default1 = 7;
        my $default2 = 10;
        my $object = [$var1 : int = $default1, $var2 : int = $default2] method : int () {
          
          my $total = $var1 + $var2;
          
          return $total;
        };
      }
    * Add Fn#reverse_inplace method.
    * Add Array#equals method.
    * Add Fn#is_string_array method.
    * Add Native::MethodCall#new_proto method.
    
  [Exception Message Improvement]
    * Exception messages in Native::MethodCall#call method are improved.
    
    https://github.com/yuki-kimoto/SPVM/issues/528
  
  [Internal Changes]
    * Rename SPVM_IMPLEMENT_MOVE_OBJECT_CHECK_READ_ONLY to SPVM_IMPLEMENT_MOVE_OBJECT_CHECK_READ_ONLY_STRING.
    * Rename SPVM_OPCODE_C_ID_MOVE_OBJECT_CHECK_READ_ONLY to SPVM_OPCODE_C_ID_MOVE_OBJECT_CHECK_READ_ONLY_STRING.
    * SPVM_IMPLEMENT_MOVE_OBJECT_CHECK_READ_ONLY checks if the type is string type.
    * Use a new runtime stack for DESTROY method instead of using the current runtime stack.
  [Bug Fix]
    * Fix a bug that the creation of multi dimensional array of any object by new operator is allowed.
      
      https://github.com/yuki-kimoto/SPVM/issues/541
    
    * Fix a bug that a case of compilation error causes segmentation fault.
    
      https://github.com/yuki-kimoto/SPVM/issues/522
    
    * Fix a bug that the count of memory blocks is wrong.
      
      https://github.com/yuki-kimoto/SPVM/issues/521
    
    * Fix th bug that (mutable string)$object cast does not throw an exception when $object is read-only.
      
      https://github.com/yuki-kimoto/SPVM/issues/565
  
  [Incompatible Changes]
  
    * The fix https://github.com/yuki-kimoto/SPVM/issues/565 cause an incompatible changes.
    
      An exception is thrown if your code contains (mutable string)$object and $object is a read-only string.
    
  [Exception Message Changes]
    * Improve exception messeges in Array class.
    * Improve exception messeges in Fn class.
    * Improve exception messages in spvmcc command.
    * Improve an exception message "[An exception thrown in DESTROY method is coverted to a warning]".
  
  [Changes]
    * Add $api->set_exception(undef); to a test file generated by spvmdist command.
    
0.990007 2024-09-02
  [New Features]
    * Add StringBuffer#clone method.
    * Add Fn#is_any_numeric_array method.
    * Add Fn#array_length method.
    * Add Fn#get_elem_size method.
    * Add Fn#get_elem_type_name method.
    * Add Fn#print_stderr method.
    * Add Fn#say_stderr method.
  [Document Fix]
    * Fix links in docs for Fn class.
    * Fix the definition of length native API.
      [Before]
      int32_t (*length)(SPVM_ENV*, void* array);
      
      [After]
      int32_t (*length)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
      
      And improve the docs.
      
  [Document Changes]
    * "=head1 Inheritance" is changed to "=head1 Super Class".
  [Changes]
    * "=head1 Inheritance" outputted by spvmdist command is changed to "=head1 Super Class".
    * Add "=head1 See Also" section to the output from spvmdist command.
    * Improve "Description" outputted from spmvdist command.
    * Add commented meta-spec "release_status" option to Makefile.PL outputted from spvmdist command.
    * "the foo type" in docs, exception messages, compilation messages are changed to "foo type".
    * The type conversion from float constant to double is allowed.
  [Exception Message Changes]
    * Improve exception messages outputted from spvmdist command.
    * The heading of a compilation error message is changed from [Compile Error] to [Compilation Error]
    * Improve exception messages in operators.
    * Improve exception messages in the instance method call.
  [Test Improvement]
    * Add a test for Fn#split method when a input is an empty string.
    * Clean up tests for array operations.
    * Clean up tests for type cast.
  [Bug Fix]
    * Fix a bug mention by "Segfault:compile_type_name" https://github.com/yuki-kimoto/SPVM/issues/554.
    * Fix a bug that wrong static method call cause an segmentation fault.
    * Fix a bug that the compile error message of 256 or more characters is cut off.
    * Fix a bug that constant narrowing conversion causes a compilation error in the distribute type is a numeric array type.
      
      https://github.com/yuki-kimoto/SPVM/issues/560
  [Complilation Message Improvement]
    * Use field notation "MyClass#foo field" in compilation error messages.
    * Use class variable notation "MyClass#$Foo class variable" in compilation error messages.
    * Use method notation "MyClass#foo method" in compilation error messages.
  [Bug Fix with Incompatible Changes]
    * There are some imcompatible changes in is_type operator to fix the following bug.
      
      https://github.com/yuki-kimoto/SPVM/issues/545
      
      For this, is_type operator must check runtime type instead of compile-time type if TYPE is an object type including object[].
      
      And if TYPE is any object type(object), an compilation error occurs.
  [Incompatible Changes]
    * warn operator output a stack trace even if the end of the input string is "\n".
      Along with this, the same change occurs in warn Native API.
      
      The reason of this change is that debugging data with trailing \n does not show a stack trace.
      
      We will add Fn#print_stderr and Fn#say_stderr to achieve the original behavior, no stack trace, of warn operator.
    
0.990006 2024-05-09
  [Feature Improvement]
    * Users know caller when a class loading from a Perl script failed.
    
0.990005 2024-05-07
  [New Features]
    * Add the following argument native APIs.
      int32_t (*is_optional)(void* runtime, void* arg);
      SPVM_VALUE (*get_default_value)(void* runtime, void* arg);
    * Add the following methods to the Native::Arg class.
      is_optional

      get_default_value_byte

      get_default_value_short

      get_default_value_int

      get_default_value_long

      get_default_value_float

      get_default_value_double

      get_default_value_object
    
  [Internal Changes]
    * Use information of SPVM_RUNTIME_ARG to set default values of optional argument in native method calls.
    * Remove the following operation codes.
      SPVM_OPCODE_C_ID_GET_STACK_OPTIONAL_BYTE
      SPVM_OPCODE_C_ID_GET_STACK_OPTIONAL_SHORT
      SPVM_OPCODE_C_ID_GET_STACK_OPTIONAL_INT
      SPVM_OPCODE_C_ID_GET_STACK_OPTIONAL_LONG
      SPVM_OPCODE_C_ID_GET_STACK_OPTIONAL_FLOAT
      SPVM_OPCODE_C_ID_GET_STACK_OPTIONAL_DOUBLE
      SPVM_OPCODE_C_ID_GET_STACK_OPTIONAL_OBJECT

0.990004 2024-05-07
  [Bug Fix with Incompatible Changes]
    * Change arguments requirement in Interface Method Requirement. This fix deglation of the SPVM::Regex module.
    [Before]
    The length of the required arguments of the method of the I<INSTANT_METHOD_TYPE_FROM> type must be equal to the length of the required arguments the method of the I<INTERFACE_METHOD_TYPE_TO> type.
    The length of the arguments of the method of the I<INSTANT_METHOD_TYPE_FROM> must be greather than or equal to the length of the arguments of the method of the I<INTERFACE_METHOD_TYPE_TO> type.
    
    [After]
    The length of the arguments of the method of the I<INTERFACE_METHOD_TO> type must be greater than or equal to the length of the required arguments the method of the I<INSTANT_METHOD_TYPE_FROM> type.
  
0.990003 2024-05-01
  [Incompatible Changes and New Features]
    * Add the mingw_ccflags field to the SPVM::Builder::Config class.
      This value is set to ['-D__USE_MINGW_ANSI_STDIO'] in Windows. This changes printf format in Windows becuase the output is compliant to C99.
  [Internal Changes]
    * Do not use _set_output_format in Windows. -D__USE_MINGW_ANSI_STDIO contains _set_output_format effect.
0.990002 2024-04-29
  [Bug Fix]
    * Fix sprintf %g format in old Windows. 1.0e008(3 digit) is changed to 1.0e08(2 digit). This is C11 compliant.
0.990001 2024-04-23
  [Document Improvement]
    * Add the doc of the spvmdist command.
    * Add the doc of the spvm command.
    * Add the doc of the spvmcc command.
    * Improve the doc of the Error class.
    * Fix links in docs.
  [Remove Files]
    * Remove unneeded SPVM/Env.pm file.
    * Remove unneeded SPVM/Stack.pm file.
    * Remove unneeded SPVM/Runtime.pm file.
    
0.990 2024-04-23
  [Major Version Up]
    * SPVM 0.990 is a major version up. The document is finished.
  [Document Improvement]
    * Add the doc of the Sync::Mutex class.
    * Add the doc of Thread Safe to SPVM::Document::Language::System.
0.989105 2024-04-23
  [Fix Bug]
    * Fix the bug that native mortal stack is not released properly in a normal method and a precompilation method implementation.
      env->enter_scope and env->leave_scope are added to the start and end of a normal method and a precompilation method implementation.
  [Document Improvement]
    * Improve the doc of Operators.
    * The heading "Mortal Stack" in SPVM::Document::NativeClass is changed to "Native Mortal Stack".
  [Internal Changes]
    * Cleanup method calls.
0.989104 2024-04-20
  [Document Improvement]
    * Improve the doc of Tokanization.
  [Internal Changes]
    * SPVM_OP_C_ID_CURRENT_CLASS to SPVM_OP_C_ID_OUTMOST_CLASS.
  [Fix Bug with Incompatible Changes]
    * An ASCII a-zA-Z must follow "=" in POD start.
  [Document Fix]
    * \0 is a octal escape character.
    
0.989103 2024-04-16
  [Internal Changes]
    * Remove the is_anon field from spvm_runtime_method.h.
    * Remove the is_anon field from spvm_method.h.
  [Document Improvement]
    * Improve the doc of Types.
    * Improve the doc of Class.
    * Improve the doc of Operators.
    * Improve the doc of GarbageCollection.
    
0.989102 2024-04-15
  [Internal Changes]
    * The is_super_class basic type native API shares the logic of its compiler.
    * The has_interface basic type native API shares the logic of its compiler.
  [Imcompatible Changes]
    * The class name created by an anon method is changed.
      [Before]
      MyClass::anon::3::23
      [After]
      MyClass::anon_method::3::23

    * The anon class name is changed.
      [Before]
      eval::anon::3
      [After]
      eval::anon_class::3
  [Imcompatible Changes]
    * The class generated by a anon method is not an anon class.
    
.989101 2024-04-14
  [Imcompatible Changes]
    * An instance method cannot be assigned to a statice method of its super classes in the interface method requirement.
  [Internal Changes]
    Internal assignment requirement and cast requirement method does not set compiler error messages directly.
  [Compilation Error Message Improvement]
    * Improve a compilation error message related to the assignment requirement, cast requirement, the interface method requirement, the interface requirement.  [Document Fix and Improvement]
    * Improve the doc of Class.
    * Improve the doc of Types.
0.989100 2024-04-10
  [Document Fix and Improvement]
    * The heading "Boolean Conversion is changed to "Condition Evaluation", and it is moved from the doc of Types to the doc of Operators.
    * The concept "Implicite Type Conversion" is changed to "Data Conversion".
    * The hedding "Type Conversion" is renamed to "Data Conversion", and moved from Types to Operators.
  [Compilation Error Message Improvement]
    * Improve a compilation error message.
    
    [Before]
    The implicite type conversion from \"%s\" to \"%s\" in %s is not allowed.
    
    [After]
    The \"%s\" type cannot be assigned to the \"%s\" type in %s.
    
0.989099 2024-04-08
  [Document Fix and Improvement]
    * Fix and improve the document of Operators.
    * Fix and improve the document of Types.
  [Support Changes]
    * SPVM doesn't support C++ compilers that does not support -std=c++11 option.
0.989098 2024-04-04
  [Document Fix and Improvement]
    * Fix and improve the document of Operators.
    * Fix and improve the document of Class.
    * The heading "Array Access" is changed to "Element Access".
  [Internal Changes]
    * The type check logic is simplified and it is shared with the compilation time and runtime.
0.989097 2024-04-02
  [Imcompatible Changes]
    * The copy operator does not thrown an exception, and causes an compilation error instead of an exception.
    * The warn operator causes an compilation error if the type of the operand is the undef type.
  [Compilation Error Messsage Improvement]
    * Improve compilation error messages in the isa, is_type, isa_error, is_error operators.
    * The compilation error messages in the != operator are improved.
    * The compilation error messages in the == operator are improved.
  [Document Fix and Improvement]
    * Fix and improve the document of operators.
    * Fix and improve the document of class definition.
    
0.989096 2024-03-27
  [Incompatible Changes]
    * Change the definition of the value field in the Bool class.
      [Before]
        has value : ro int;
      [After]
        has value : ro byte;
    * Remove the new_env method from the Native::Runtime.
  [New Features]
    * Add the following native APIs.
    
      int32_t (*get_byte_object_value)(SPVM_ENV* env, SPVM_VALUE* stack, void* byte_object);
      int32_t (*get_short_object_value)(SPVM_ENV* env, SPVM_VALUE* stack, void* short_object);
      int32_t (*get_int_object_value)(SPVM_ENV* env, SPVM_VALUE* stack, void* int_object);
      int64_t (*get_long_object_value)(SPVM_ENV* env, SPVM_VALUE* stack, void* long_object);
      float (*get_float_object_value)(SPVM_ENV* env, SPVM_VALUE* stack, void* float_object);
      double (*get_double_object_value)(SPVM_ENV* env, SPVM_VALUE* stack, void* double_object);
    * Add the following native runtime APIs.
      SPVM_ENV* (*get_env)(void* runtime);
    * Add the get_env method to the Native::Rutnime.
  [Internal Changes]
    * A runtiem has its runtime environment.
  [Breaking Binary Compatibility]
    Native API IDs are changed after 195
    [Before]
    
      195 reserved195,
      196 new_stack,
      197 free_stack,
      198 get_field_object_defined_and_has_pointer_by_name,
      199 get_field_object_ref,
      200 get_field_object_ref_by_name,
      201 is_binary_compatible_stack,
      202 assign_object,
      203 new_string_array_no_mortal,
      204 new_memory_block,
      205 free_memory_block,
      206 get_memory_blocks_count,
      207 say,
      208 warn,
      209 spvm_stdin,
      210 spvm_stdout,
      211 spvm_stderr,
      212 check_bootstrap_method
      213 new_array_proto_element_no_mortal
      214 new_array_proto_element
    [After]
      195 is_binary_compatible_stack,
      196 new_stack,
      197 free_stack,
      198 get_field_object_defined_and_has_pointer_by_name,
      199 get_field_object_ref,
      200 get_field_object_ref_by_name,
      201 check_bootstrap_method
      202 assign_object,
      203 new_string_array_no_mortal,
      204 new_memory_block,
      205 free_memory_block,
      206 get_memory_blocks_count,
      207 say,
      208 warn,
      209 spvm_stdin,
      210 spvm_stdout,
      211 spvm_stderr,
      212 new_array_proto_element_no_mortal
      213 new_array_proto_element
      214 get_byte_object_value
      215 get_short_object_value
      216 get_int_object_value
      217 get_long_object_value
      218 get_float_object_value
      219 get_double_object_value
    
0.989095 2024-03-26
  [Bug Fix]
    * Fix the bug that second compilation use freed op field information.
    
      https://github.com/yuki-kimoto/SPVM/issues/507
    
    * Fix the bug that second compilation use freed op class variable information.
    
0.989094 2024-03-26
  [Internal Changes]
    * SPVM::Builder::Config::Info does not depend on the SPVM::Native::Compiler.
  [Bug Fix]
    * Fix the bug that the spvmcc command does not compile precompilation anon methods.
  [Incompatible Changes]
    * Precompilation methods are no more fallback if is_precompile_fallback is set to a true value.
0.989093 2024-03-25
  [Bug Fix]
    * Fix the bug that the logical OR operator set the internal condition flag where it should not be changed.
    * Fix the bug that the logical AND operator set the internal condition flag where it should not be changed.
  [Internal Changes]
    * Remove REFCNT operation in syntax parsing.
    * Operations are reorder and renamed in syntax parsing.
  [Test Cleanup]
    * Cleanup tests for operators
    * Cleanup tests for statements
0.989092 2024-03-23
  [New Features]
    * Add the get_basic_types method to the Native::Runtime class.
    * Add the get_methods method to the Native::BasicType class.
    * Add the get_fields method to the Native::BasicType class.
    * Add the get_class_vars method to the Native::BasicType class.
  [Incompatible Changes]
    * Add the Native::Constant class.
    * Remove the get_class_names in the Native::Runtime class.
    * Remove the get_basic_type_names in the Native::Runtime class.
    * Remove the get_method_names in the Native::Runtime class.
    * Remove the get_field_names in the Native::Runtime class.
    * Remove the get_class_var_names in the Native::Runtime class.
    * Remove the  in the Native::Runtime class.
    * Change the return values of the get_class_names method in the SPVM::Builder::Config::Info.
      [Before]
      This method is the same as the L<get_class_names|Native::Runtime/"get_class_names"> method in the C<Native::Runtime>, but the return value is converted to an array reference of strings.
      
      [After]
      Returns the all class and interface names except for anon classes loaded by the runtime.
  [Bug Fix]
    * Fix the bug that the is_read_only operator set the internal condition flag.
    * Fix the bug that the isweak operator set the internal condition flag.
    * Fix the bug that the can operator set the internal condition flag.
    * Fix the bug that the string comparison operators and the numeric comparison operators set the internal condition flag.
    * Fix the bug that the isa, isa_error, is_type, is_error, is_compile_type operators set the internal condition flag.
    * Fix the bug that the logical NOT operator set the internal condition flag where it should not be changed.

  [Internal Changes]
    * Runtime precompilation can be detected in easy way that update blib/lib/SPVM/Builder/include/spvm_version.h in Makefile.PL.
    * The can operator receive the constant string ID for method name.
0.989091 2024-03-21
  [Incompatible Changes]
    * The check_stack_env native API is renamed to is_binary_compatible_stack.
    * Remove the call_class_method_for_env method in the Native::MethodCall class.
    * Remove the call_callback method in the Native::MethodCall class.
    * Change the set_exception method in the Native::MethodCall class.
      [Before]
        static method set_exception : void ($exception : string, $);
      [After]
        static method set_exception : void ($exception : string, $stack : Native::Stack = undef, $env : Native::Env = undef);
    * Change the get_exception method in the Native::MethodCall class.
      [Before]
        static method get_exception : string ($stack : Native::Stack = undef, $env : Native::Env = undef);
      [After]
        method get_exception : string ();
  [New Features]
    * Add the get_current_method argument native API.
    * Add the get_current_runtime basic type native API.
    * Add the new_class_method_with_env_stack, new_instance_method_static_with_env_stack, new_instance_method_with_env_stack methods to the Native::MethodCall class.
    * Add the Native::MethodCall::Error::ExceptionThrown class.
    * Add the optional argument $error_id_ref to the call, call_class_method, call_instance_method_static, call_instance_method.
  [New Features]
    * Add the get_current_method argument native API.
    * Add the get_current_runtime basic type native API.
    * Add the new_class_method_with_env_stack, new_instance_method_static_with_env_stack, new_instance_method_with_env_stack methods to the Native::MethodCall class.
    * Add the Native::MethodCall::Error::ExceptionThrown class.
    * Add the optional argument $error_id_ref to the call, call_class_method, call_instance_method_static, call_instance_method.
0.989090 2024-03-20
  [Exception Message Improvement]
    * Improve exception messages in Modules.
      [Before]
      $length must be greater than or equal to 0.
      [After]
      The length $length must be greater than or equal to 0.
  [Compilation Error Message Improvement]
    * Improve compilation error messages.
      [Before]
      The operand of the type_name operator must be an object type.
      [After]
      The type of the operand of the type_name operator must be an object type.
  [New Features with Incompatible Changes]
    * The warn operator output undef if the operand is an object type and the value in runtime is undef.
    * The warn operator output the type and the address if the operand is an object type that is not the string type.
    * The warn operator output the empty string if the operand is an empty string.
0.989089 2024-03-20
  [Incompatible Changes]
    * Rename the get_method, get_field, get_class_var methods from the Native::Runtime::Info class to get_method_by_name, get_field_by_name, get_class_var_by_name.
    * Remove the Native::Runtime::Info class and its methods are moved to the Native::Runtime::Class.
    * Remove the info method in the Native class.
  [Internal Changes]
    * Remove the SPVM::Builder::Native::Runtime::Info module.
  
0.989088 2024-03-19
  [New Features]
    * Add the Native::API class.
  [Internal Changes]
    * Add the SPVM::Builder::Native::BasicType module.
    * Add the SPVM::Builder::Native::Method module.
    * Add the SPVM::Builder::Native::ClassFile module.
    * Add the SPVM::Builder::Native::API module.
    * Add the SPVM::Builder::Native::Runtime::Info module.
    * Rename SPVM::Builder::Compiler to SPVM::Builder::Native::Compiler
    * Rename SPVM::Builder::Runtime to SPVM::Builder::Native::Runtime
    * Rename SPVM::Builder::Env to SPVM::Builder::Native::Env
    * Rename SPVM::Builder::Stack to SPVM::Builder::Native::Stack

  [Incompatible Changes]
    * Remove the new method in the Native::Env and add the new_env method to the Native::Runtime class.
      [Removed]Native::Env
      static method new : Native::Env ($compiler : Native::Compiler = undef);
      
      [Added]Native::Runtime
      static method new_env : Native::Env ();
    * Remove the set_command_info_program_name method in the Native::Env and add the set_command_info_program_name method to the Native::API class.
    * Remove the set_command_info_argv in the Native::Env and add the set_command_info_argv method to the Native::API class.
    * Remove the set_command_info_base_time in the Native::Env and add the set_command_info_base_time method to the Native::API class.
    * Remove the call_init_methods in the Native::Env and add the call_init_methods method to the Native::API class.
    * Remove the destroy_class_vars in the Native::Env and add the destroy_class_vars method to the Native::API class.
    * Remove the get_exception in the Native::Env and add the get_exception method to the Native::API class.
    * Remove the set_exception in the Native::Env and add the set_exception method to the Native::API class.
  [Bug Fix]
    * Fix bug that the SPVM language is not build by only Perl and the C language.
0.989087 2024-03-14
  [Document Improvement and Changes]
    * The heading "Type Assignability" to "Assignment Requirement".
    * The heading "Type Castability" to "Cast Requirement".
    * Add the heading "Method Override".
  [Bug Fix]
    * Fix the bug that the object arguments in the instance method call are not type safe.
  [New Features]
    * Add the new_array_proto_element_no_mortal Native API.
    * Add the new_array_proto_element Native API.
    * Add the new_array_proto_element method ot the Array class.
    
0.989086 2024-03-11
  [New Features]
    * Add the following methods to the Array class.
      to_object_array_byte
      to_object_array_short
      to_object_array_int
      to_object_array_long
      to_object_array_float
      to_object_array_double
      to_array_byte
      to_array_short
      to_array_int
      to_array_long
      to_array_float
      to_array_double
    * Add the Callback::Grep class.
    * Add the Callback::Map class.
    * Add the Callback::MapExpand class.
    * Add the get_compile_type_name method to the Fn class.
    * Add the following method to the Native::Runtime::Info class.
      get_method_names
      get_field_names
      get_class_var_names
      get_method
      get_field
      get_class_var
    * Add the SPVM::Builder::Config::Info module.
  [OS Support]
    * Makefile.PL does not thrown the "OS unsupported" exception when the OS is Alpine Linux.
  [Incompatible Changes]
    * Remove --required-resources, -r options from the spvmcc command.
      
      As alternative way, SPVM::Builder::Config::Info is added.
      
      How to dump resource information - SPVM Wiki
      
      https://github.com/yuki-kimoto/SPVM/wiki/Config
      
0.989085 2024-03-08
  [New Features]
    * Add the or method to the Fn class.
    * Add the if method to the Fn class.
    * Add the following native APIs.
      int32_t (*is_precompile_fallback)(void* runtime, void* method);
      void (*set_is_precompile_fallback)(void* runtime, void* method, int32_t is_precompile_fallback);
    * Add the following method to the Native::Method class.
      method is_precompile_fallback : int ();
      method set_is_precompile_fallback : void ($is_precompile_fallback : int);
    * Add the Native::Runtime::Info class is added.
    * Add the info method to the Native class.
  [Incompatible Changes]
    * The argument $argv in the load_config method in the SPVM::Builder::Config class must be defined.
  [Future Plan]
    * A precompilation method will be not fallback to the vm method by default.
  [Changes]
    * Change segfault to an exeption if an native address is not found.
  
  [Ingernal Changes]
    * Remove removing "SPVM::" from from class names in arguments.
    
0.989084 2024-03-07
  [New Features]
    * Add -B and --build-dir to the spvm command.
    * Add the --config-argv option to the spvmcc command.
    * Add the --config-argv-option option to the spvmcc command.
  [Incompatible Changes and New Features]
    * The string-to-byte type conversion is added.
    * The string-to-short type conversion is added.
    * The string-to-int type conversion is added.
    * The string-to-long type conversion is added.
    * The string-to-float type conversion is added.
    * The string-to-double type conversion is added.
    
  [Incompatible Changes]
    * An argument of the load_config method in the SPVM::Builder::Config class is changed.
      [Before]
      my $config = $config->load_config($config_file, @argv);
      
      [After]
      my $config = $config->load_config($config_file, $argv);
      
    * An argument of the load_base_config method in the SPVM::Builder::Config class is changed.
      [Before]
      my $config = $config->load_base_config($config_file, @argv);
      
      [After]
      my $config = $config->load_base_config($config_file, $argv);
      
    * An argument of the load_mode_config method in the SPVM::Builder::Config class is changed.
      [Before]
      my $config = $config->load_mode_config($config_file, $mode, @argv);
      
      [After]
      my $config = $config->load_mode_config($config_file, $mode, $argv);
    * The spvmcc command must be given the -o, --output option.
  [Incompatible Changes and Breaking Binary Compatibility]
    * The length operator returns 0 if the operand is undef.
  [Changes]
    * Chaingin --optimize option in the spvmcc command is detected.
  [Internal Changes]
    * mode changes in the spvmcc command are detected by --mode option.
  [Fix Bug]
    * Fix the bug that if spvmcc mode and optimize does not work in compiling native classes and precompilation classes.
    * Fix the bug that the string-to-byte[] type conversion cause segfault when the operand is undef.
      
0.989083 2024-03-06
  [Internal Changes]
    * Add parentheses to the confess function so that Perl does not interpret it as the indirect syntax.
  [New Features]
    * Add the add_lib_abs method to the SPVM::Builder::Config class.
    * Add the add_static_lib_abs method to the SPVM::Builder::Config class.
  [Document Improvement]
    * Improve and fix the document of the SPVM::Builder::Config class.
    * Improve and fix the document of the SPVM::Builder::Config::Exe class.
    * Improve and fix the document of the SPVM::Builder::API class.
    * Improve and fix the document of the SPVM::Builder::Util::API class.
    * Improve and fix SPVM::Document::NativeClass.
    
0.989082 2024-03-01
  [New Features]
    * The spvm_warn function in native APIs outputs the function name, the file name, and the line number.
    * The spvm_warnf function in native APIs outputs the function name, the file name, and the line number.
  [New Features and Incompatible Changes and Breaking Binary Compatibility]
    * The warn operator outputs the function name. This change cuases breaking binary compatibility of the warn operator.
    * Change the definition of the warn native API.
      [Before]
      void (*warn)(SPVM_ENV* env, SPVM_VALUE* stack, void* string, const char* file, int32_t line);
      [After]
      void (*warn)(SPVM_ENV* env, SPVM_VALUE* stack, void* string, const char* basic_type_name, const char* method_name, const char* file, int32_t line);
  [Document Improvement and Fix]
    * Fix and improve the documents of native APIs.
  [Bug Fix]
    * Fix the bug that the shorten native API cannot culcurate the length of \0 filling.
    
0.989081 2024-02-29
  [Document Improvement]
    * Improve the documents of native APIs.
  [Bug Fix]
    * Fix the error id set by native APIs. This was wrongly 1. The correct value is the basic type ID of the Error class.
    * Fix the error id set by spvm_vm.c. This was wrongly 1. The correct value is the basic type ID of the Error class.
    * Fix the error id set by spvm_implement.h. This was wrongly 1. The correct value is the basic type ID of the Error class.
    * Fix the bug that the count of memory blocks is incremented when the memory is not allocated in some errors.
    * Fix the bug that even if an object creating failed and logic access to object.
  [Exception Messages Changes]
    * Symbol names in exception messages in native APIs are quoted by "".
  [Changes]
    * Add the logic to thrown an exception in the following native APIs when creating object failed.
    
      new_object_by_name
      
      new_pointer_object_by_name
      
      new_object_array_by_name
      
      new_muldim_array_by_name
      
      new_mulnum_array_by_name
   * Check assignability in the call_instance_method_static_by_name native API.
   * Check the type of the prototype array in the new_array_proto_no_mortal native API.
  [Incompatible Changes]
    * The copy_no_mortal native API does not return NULL if the argument object is invalid type. This is replaced with an assersion.
    
0.989080 2024-02-23
  [Document Improvement]
    * Add SPVM::Document page.
    * Improve the documents of native APIs.
  [Document Changes]
    * "Execution Environemnt" is renamed to "Runtime Environment".
    * "Call Stack" is renamed to "Runtime Stack".
    
0.989080 2024-02-23
  [Document Fix]
    * Fix language specification document pathes.
    
0.989079 2024-02-22
  [Document Improvement]
    * Separate SPVM::Document::Language to the following documents.
    
      =item * L<Lexical Tokenization|SPVM::Document::Language::Tokenization>

      =item * L<Syntax Parsing|SPVM::Document::Language::SyntaxParsing>

      =item * L<Class Definition|SPVM::Document::Language::Class>

      =item * L<Types|SPVM::Document::Language::Types>

      =item * L<Statements|SPVM::Document::Language::Statements>

      =item * L<Operators|SPVM::Document::Language::Operators>

      =item * L<Exception Handling|SPVM::Document::Language::ExceptionHandling>

      =item * L<Garbage Collection|SPVM::Document::Language::GarbageCollection>

      =item * L<System Setting|SPVM::Document::Language::System>
    * Improve many docs.
  [Test Improvement]
    * Add tests for native APIs.
0.989078 2024-02-21
  [Document Improvement]
    * Improve "Usage" of SPVM program.
    * Add SPVM::Document::EnvironmentVariables.
    * Improve the doc of basic type Native APIs.
    * Improve the doc of class variable Native APIs.
  [New Features]
    * Add the get_file basic type native API.
    * Add the new_instance_method_static to the Native::MethodCall class.
    * Add the call_instance_method_static to the Native::MethodCall class.
    * Add the new_instance_method to the Native::MethodCall class.
    * Add the call_instance_method to the Native::MethodCall class.
  [Bug Fix]
    * Fix argument types and return types in argument native APIs.
    
      -  const void* (*get_name)(void* runtime, void* arg);
      +  const char* (*get_name)(void* runtime, void* arg);

    * Fix argument types and return types in basic type native APIs.
      
      -  const void* (*get_name)(void* runtime, void* basic_type);
      +  const char* (*get_name)(void* runtime, void* basic_type);

      -  const void* (*get_version_string)(void* runtime, void* basic_type);
      +  const char* (*get_version_string)(void* runtime, void* basic_type);

      -  const void* (*get_class_dir)(void* runtime, void* basic_type);
      +  const char* (*get_class_dir)(void* runtime, void* basic_type);

      -  const void* (*get_class_rel_file)(void* runtime, void* basic_type);
      +  const char* (*get_class_rel_file)(void* runtime, void* basic_type);

      -  void* (*get_class_var_by_name)(void* runtime, void* basic_type, const void* class_var_name);
      +  void* (*get_class_var_by_name)(void* runtime, void* basic_type, const char* class_var_name);

      -  void* (*get_field_by_name)(void* runtime, void* basic_type, const void* field_name);
      +  void* (*get_field_by_name)(void* runtime, void* basic_type, const char* field_name);

      -  void* (*get_method_by_name)(void* runtime, void* basic_type, const void* method_name);
      +  void* (*get_method_by_name)(void* runtime, void* basic_type, const char* method_name);

    * Fix argument types and return types in method native APIs.

      -  const void* (*get_name)(void* runtime, void* method);
      +  const char* (*get_name)(void* runtime, void* method);
      
0.989077 2024-02-20
  [New Features]
    * Add file directive syntax.
    
      #file "/Foo/Bar.spvm"
    * Add the check_bootstrap_method native API.
    * Add the check_bootstrap_method method to the Native class.
    
  [Incompatible Changes and breaking binary compatibility]
    * The warn native API is changed. This change causes breaking binary compatibility in the warn operator.
      [Before]
      void (*warn)(SPVM_ENV* env, SPVM_VALUE* stack, void* string, const char* class_dir, const char* class_rel_file, int32_t line);
      
      [After]
      void (*warn)(SPVM_ENV* env, SPVM_VALUE* stack, void* string, const char* file, int32_t line);
      
  [Incompatible Changes]
    * The __FILE__ operator returns current file path, instead of the relative file name of the class.
    * The main method return type of a given class to the spvmcc command becomes void .
    * The main method return type of a given class to the spvm command becomes void.
  [Document Changes]
  
    * Remove the specification of "End of Source Code"

    * Improve the specification of "Character Encoding of Source Code"

      The character encoding of SPVM source codes is UTF-8.

      If a character is ASCII, it must be ASCII printable characters or ASCII space characters except for ASCII C<CR>.

      Compilation Errors:

      The charactor encoding of SPVM source codes must be UTF-8. Otherwise a compilation error occurs.

      If a character in a SPVM source code is ASCII, it must be ASCII printable or space.

      The new line of SPVM source codes must be LF. The source code cannot contains CR and CRLF.

0.989076 2024-02-19
  [Changes]
    * Improve the compilation error message in the compile and compile_anon_class in the Native::Compiler class.
  [New Features]
    * Add line directive syntax.
    
      #line 35
      
0.989075 2024-02-19
  [Changes]
    * The $args argument in the call_class_method method in the Native::MethodCall class becomes optional.
    * The $args argument in the call method in the Native::MethodCall class becomes optional.
  [New Features]
    * Add the eval_string method in the Native::Compiler class.
    * Add the spvm command
0.989074 2024-02-14
  [New Features]
    * Add anon class syntax. Anon class cause compilation error, but this will be used for the compile_anon_class method.
      class {
        
      }
    * Add the compile_anon_class native compiler API.
    * Add the compile_anon_class method to the Native::Compiler class.
      
0.989073 2024-02-14
  [Changes]
    * The spvmdist command outputs .gitattributes file that contains "*.spvm text eol=lf".
    * Add the spvm_utf8.c and spvm_utf8.h files.
  [Incompatible Changes and New Features]
    * Rename the call_class_method in the Native::MethodCall class to call_class_method_for_env.
    * Add the new call_class_method to the Native::MethodCall class.
      
      static method call_class_method : void ($basic_type_name : string, $method_name : string, $args : object[]);
    
    
  [Incompatible Changes]
    * The new line of SPVM source codes must be LF. Otherwise compilation error occurs.
    * Change the specification of "Line Terminators"

      The line terminators are C<LF> of ASCII.

      When a line terminator appears, the current line number is incremented by 1.

      Compilation Errors:

      The new line of SPVM source codes must be LF. The source code cannot contains CR and CRLF.
    * The charactor encoding of SPVM source codes must be UTF-8. Otherwise a compilation error occurs.
    
  [Document Improvement]
  
    * Add the specification of "End of Source Code"

      A SPVM source code ends with C<\0> in ASCII. If a source code is loaded by a file, C<\0> is added to the end of the source code.

    * Add the specification of "Character Encoding of Source Code"

      The character encoding of SPVM source codes is UTF-8.

      Compilation Errors:

      The charactor encoding of SPVM source codes must be UTF-8. Otherwise a compilation error occurs.


0.989072 2024-02-14
  [New Features]
    * Add single quote string literal syntax.
    
      q'Hello World!'
    
    * Add the global_before_create_compile_info_cbs field to the SPVM::Builder::Config::Exe class.
    * Add the add_global_before_create_compile_info_cb method to the SPVM::Builder::Config::Exe class.
    * Add the after_create_compile_info_cbs method to the SPVM::Builder::Config class.
    * Add the add_after_create_compile_info_cb method to the SPVM::Builder::Config class.
    * Add the after_create_link_info_cbs to the SPVM::Builder::Config class.
    * Add the add_after_create_link_info_cb to the SPVM::Builder::Config class.
    * Add the set_global_optimize to the SPVM::Builder::Config::Exe class.
  [Bug Fix]
    * Fix the bug that not found basic type names cause segfault in the followin APIs.
      call_class_method_by_name
      call_instance_method_static_by_name
      call_instance_method_by_name
    * Fix bug that the following methods are not mortal.
      call_class_method_by_name
      call_instance_method_static_by_name
      call_instance_method_by_name
    * Fix bug that spvmcc do not set config_exe to compile SPVM core source and bootstrap source.
  [Changes]
    * Add periods to exception messages in native APIs.
  [Incompatible Changes]
    * The before_each_compile_cbs field in the SPVM::Builder::Config::Exe is renamed to global_before_compile_cbs.
    * The add_before_each_compile_cb method in the SPVM::Builder::Config::Exe is renamed to add_global_before_compile_cb.
    * before_compile_cbs are executed just before the compilation.
    * before_link_cbs are executed just before the link.
0.989071 2024-02-12
  [New Features]
    * Add the input_dir field to SPVM::Builder::Config.
  [Changes]
    * Add the "=head1 Inheritance" to the Perl module file generated by the spvmcc command.
  [Bug Fix]
    * Fix the output of a binary string of the dump operator.
    * Checks the definition of the main method generated by the spvmcc command.
    * Checks input class file and config file of the spvmcc command for dependencies.
    * Fix the bug that the class name could not contains :: in the spvmcc command.
    * before_compile_cbs are executed before the compilation needed checking.
    * Fix the bug that update of resource file is not detected in jit compile.
  [Incompatible Changes]
    * The merge_options method in the Fn class is changed.
      
      If $options1 is not defined, $options1 is set to an empty any object array.
      
      If $options2 is not defined, $options2 is set to an empty any object array.
      
      The following process is not performed.
      
        If $options2 contains the same key of $options1, the key of $options1 is overwritten by the key of $options2.
    
    * The executable file generated by the spvmcc command returns status code as same as SPVM error id.
    * Include directories by add_include_dir is high priority than native include direcotory and resource include directory.
0.989070 2024-02-09
  [New Features]
    * Add the force option to the build_dynamic_lib_dist_precompile method and the build_dynamic_lib_dist_native method
      in the SPVM::Builder::API class.
  [Internal Changes]
    * Add spvm_version.h, and spvm_native.h includes spvm_version.h.
  [Changes]
    * SPVM compilation dependency is checked by spvm_version.h update, instead of checking all files.
    * Add spvm_version.h to dependency of Makefile generated by create_make_rule_native and create_make_rule_precompile in Makefile.PL.
0.989069 2024-02-09
  [New Features]
    * Add a message in compiling and linking a source file like
      [Compile a %s source file ...]
      [Generate a dynamic link file ...]
    * Add the resource_loader_config field to the SPVM::Builder::Config class.
    * Add the category field to the SPVM::Builder::Config class.
    * Add the category field to the SPVM::Builder::CompileInfo class.
    * Add the --no-config option to the spvmcc command.
    * Add the -m, --mode option to the spvmcc command.
    * Add the config_exe field to SPVM::Builder::Config.
    * Add the is_jit field to SPVM::Builder::Config.
    * Add the cc_output_dir field to SPVM::Builder::Config.
    * Add the output_dir field to SPVM::Builder::Config.
    * Add the output_file field to SPVM::Builder::Config.
    * Add the used_as_resource field to SPVM::Builder::Config.
  [Deprecation]
    * The SPVM:: prefix is no more required in the class name given to the create_make_rule function in Makefile.PL.
  [Bug Fix]
    * Add resource dependency to the create_make_rule_native method in Makefile.PL.
  [Incompatible Changes]
    * A resource must need its SPVM class file.
    * Remove the -c, --config option in the spvmcc command. 
    * The format of the --required-resources option in the spvmdist command
      [After]
      
      {"argv":["args1","args2"],"class_name":"TestCase::Resource::Mylib1","mode":"mode1","resource_loader_class_name":"TestCase::NativeAPI2"}
      
  [Changes]
    * Linker messages output before executing command.
    * No native class file and no ext is allowed.
    * A config file --config given to the spvmcc command can be plcaed in the directory as same as the SPVM class file.
    * Unshift "lib" directory in Makefile.PL that is generated by the spvmdist command.
  [Internal Changes]
    * Resources are loaded in a compilattion instead of a link.
0.989068 2024-01-22
  [New Features]
    * Add the copy_object_with_proto method to the Array class.
    * Add the copy_object_address_with_proto method to the Array class.
  [Bug Fix]
    * Fix the bug that the unweaken operator does not work well.
    * Fix the bug that the get_string method in the Hash class throws exception when the value is undef.
    * Fix the bug that parant's private fields can access from child classes.
0.989067 2024-01-05
  [Incompatible Changes]
    * Remove the DEFAULT_CAPACITY enumeration from the StringBuffer class.
  [New Features]
    * Add the memset_char method to the Fn class.
    * Add the set_length method to the StringBuffer class.
    * Add the set method to the StringBuffer class.
  [Incompatible Changes]
    * The dump operator print escaped character if caracters in the string is not valid UTF-8 or is not printable ASCII.
  [Bug Fix]
    * Fix the bug that {"foo"} causes a segmentation fault.
  [Exception Messages Improvement]
    * Improve the exception message of the new method in the SPVM::Builder::Config.
  [Document Fix and Improvement]
    * Fix and improve the doc of SPVM::Builder::Config.
    * Fix and improve the doc of SPVM::Builder::Resource.
    * Fix and improve the doc of SPVM::Builder::Config::Exe.
  [Document Improvement]
    * Improve the docs of the Byte, Short, Int, Long, Float, Double classes.
    * Improve the docs of the ByteList, ShortList, IntList, LongList, FloatList, DoubleList classes.

0.989066 2024-01-03
  [Document Fix]
    * Fix and improve the doc of SPVM::Builder::Config.
  [New features]
    * Add the config field to the SPVM::Builder::LibInfo.
  [New features and Incompatible Changes]
    * Remove the static_option_cb in the SPVM::Builder::LibInfo class and add the static_lib_ldflag option to the SPVM::Builder::Config.
    * Add the create_ldflags method to the SPVM::Builder::LibInfo and remove the to_arg method from the SPVM::Builder::LibInfo.
  [Incompatible Changes]
    * Rename the to_cmd method in the SPVM::Builder::CompileInfo class to the to_command method.
    * Rename the to_cmd method in the SPVM::Builder::LinkInfo class to the to_command method.
    * Rename the create_link_command method in the SPVM::Builder::LinkInfo class to the create_command method.
    * Rename the create_compile_command method in the SPVM::Builder::CompileInfo class to the create_command method.
    * The new method in the SPVM::Builder::LibInfo must be given the config option.
    * The create_command_args in the SPVM::Builder::LinkInfo is renamed to create_ldflags.
    * The create_command_args in the SPVM::Builder::CompileInfo is renamed to create_ccflags.
    * The new method in the SPVM::Builder::LinkInfo must be given the config option.
    * The new method in the SPVM::Builder::CompileInfo must be given the config option.

  [Document Fix and Improvement]
    * Fix and improve the doc of SPVM::Builder::LibInfo.
    * Fix and improve the doc of SPVM::Builder::LinkInfo.
    * Fix and improve the doc of SPVM::Builder::CompileInfo.
    * Fix and improve the doc of SPVM::Builder::ObjectFileInfo.
0.989065 2023-12-22
  [Incompatible Changes]
    * The divui operator is renamed to the div_uint operator.
    * The divul operator is renamed to the div_ulong operator.
0.989064 2023-12-20
  [Exception Message Fix and Improvement]
    * Fix and improve the exception messages in the get_(byte|short|int|long|float|double|string) methods in the Hash class.
  [New Features]
    * Add the following method to the Hash class.
      
      get_or_default_byte
      get_or_default_short
      get_or_default_int
      get_or_default_long
      get_or_default_float
      get_or_default_double
      get_or_default_string
      get_or_default

    * Add the following method to the Native class.
      
      get_current_runtime
      get_current_compiler
    * The is_type operator can receive non-object types.
    * Add the repeat_string method to the Array class.
  [Document Improvement]
    * Improve the doc of the Cloneable interface.
  
  [Changes]
    * Add "Details", "Interfaces", "Enumerations" sections to the doc generated by the spvmdist command.
    * "of L<SPVM>" in the doc generated by the spvmdist command is changed to "in L<SPVM">.
    * Change the beheivior of the isa operator. If the right type is object[], a compilation time type check is performed.
    * The default buffer length of the strerror_string, strerror, strerror_string_nolen, strerror_nolen native APIs becomes 128.
    * errno is set to an appropriate value if the strerror_string, strerror, strerror_string_nolen, strerror_nolen native APIs failed.
    * The strerror_string, strerror, strerror_string_nolen, strerror_nolen native APIs does not return NULL.
  [Bug Fix]
    * Fix the bug that '+' in 1234+ is parsed as the part of numeric literal.
    * Fix the bug of types of optional arguments.
    * Fix the bug that deep recursion cause a segfault.
  [Incompatible Changes]
    * Remove the deprecated new_memory_stack native API.
    * Remove the deprecated free_memory_stack native API.
    * The % operator returns modulo instead of C remainder. This is the same as the Perl's % beheivor.
      int32_t ret = in1 % in2;
      if ((in1 < 0) != (in2 < 0) && ret) { ret += in2; }
    * The remui operator is renamed to the mod_uint operator.
    * The remul operator is renamed to the mod_ulong operator.
    * The depth of the recursive calls becomes from 10000 to 1000.
  [Language Specification Changes]
    * The % operator is called the modulo operator.
  
0.989063 2023-11-20
  [Incompatible Changes]
    * The SPVM_NATIVE_C_BASIC_TYPE_ID_ERROR_COMPILE native API constant is renamed to SPVM_NATIVE_C_BASIC_TYPE_ID_ERROR_COMPILE_CLASS.
    * The build_precompile_module_source runtime native API constant is renamed to build_precompile_class_source.
  [Breaking Binary Compatibility]
    * The Native API IDs are changed.
    
      0 runtime
      1 api
      2 new_env,
      3 free_env,
      4 call_init_methods,
      5 set_command_info_program_name,
      6 set_command_info_argv,
      7 set_command_info_base_time,
      8 destroy_class_vars,
      9 args_width,
      10 get_object_basic_type,
      11 get_object_basic_type_id,
      12 get_object_basic_type_name,
      13 get_object_type_dimension,
      14 get_basic_type,
      15 get_basic_type_by_name,
      16 get_basic_type_by_id,
      17 get_basic_type_id,
      18 get_basic_type_id_by_name,
      19 get_class_var,
      20 get_class_var_byte,
      21 get_class_var_short,
      22 get_class_var_int,
      23 get_class_var_long,
      24 get_class_var_float,
      25 get_class_var_double,
      26 get_class_var_object,
      27 get_class_var_string,
      28 set_class_var_byte,
      29 set_class_var_short,
      30 set_class_var_int,
      31 set_class_var_long,
      32 set_class_var_float,
      33 set_class_var_double,
      34 set_class_var_object,
      35 set_class_var_string,
      36 get_class_var_object_ref,
      37 get_class_var_byte_by_name,
      38 get_class_var_short_by_name,
      39 get_class_var_int_by_name,
      40 get_class_var_long_by_name,
      41 get_class_var_float_by_name,
      42 get_class_var_double_by_name,
      43 get_class_var_object_by_name,
      44 get_class_var_string_by_name,
      45 set_class_var_byte_by_name,
      46 set_class_var_short_by_name,
      47 set_class_var_int_by_name,
      48 set_class_var_long_by_name,
      49 set_class_var_float_by_name,
      50 set_class_var_double_by_name,
      51 set_class_var_object_by_name,
      52 set_class_var_string_by_name,
      53 get_field,
      54 get_field_static,
      55 get_field_byte,
      56 get_field_short,
      57 get_field_int,
      58 get_field_long,
      59 get_field_float,
      60 get_field_double,
      61 get_field_object,
      62 get_field_string,
      63 set_field_byte,
      64 set_field_short,
      65 set_field_int,
      66 set_field_long,
      67 set_field_float,
      68 set_field_double,
      69 set_field_object,
      70 set_field_string,
      71 get_field_byte_by_name,
      72 get_field_short_by_name,
      73 get_field_int_by_name,
      74 get_field_long_by_name,
      75 get_field_float_by_name,
      76 get_field_double_by_name,
      77 get_field_object_by_name,
      78 get_field_string_by_name,
      79 set_field_byte_by_name,
      80 set_field_short_by_name,
      81 set_field_int_by_name,
      82 set_field_long_by_name,
      83 set_field_float_by_name,
      84 set_field_double_by_name,
      85 set_field_object_by_name,
      86 set_field_string_by_name,
      87 get_field_string_chars_by_name,
      88 get_method,
      89 get_class_method,
      90 get_instance_method_static,
      91 get_instance_method,
      92 call_method_no_mortal,
      93 call_method,
      94 call_class_method_by_name,
      95 call_instance_method_static_by_name,
      96 call_instance_method_by_name,
      97 new_object_no_mortal,
      98 new_object,
      99 new_object_by_name,
      100 new_pointer_object_no_mortal,
      101 new_pointer_object,
      102 new_pointer_object_by_name,
      103 get_pointer,
      104 set_pointer,
      105 new_string_nolen_no_mortal,
      106 new_string_nolen,
      107 new_string_no_mortal,
      108 new_string,
      109 new_byte_array_no_mortal,
      110 new_byte_array,
      111 new_short_array_no_mortal,
      112 new_short_array,
      113 new_int_array_no_mortal,
      114 new_int_array,
      115 new_long_array_no_mortal,
      116 new_long_array,
      117 new_float_array_no_mortal,
      118 new_float_array,
      119 new_double_array_no_mortal,
      120 new_double_array,
      121 new_object_array_no_mortal,
      122 new_object_array,
      123 new_object_array_by_name,
      124 new_string_array,
      125 new_muldim_array_no_mortal,
      126 new_muldim_array,
      127 new_muldim_array_by_name,
      128 new_mulnum_array_no_mortal,
      129 new_mulnum_array,
      130 new_mulnum_array_by_name,
      131 new_array_proto_no_mortal,
      132 new_array_proto,
      133 length,
      134 get_elems_byte,
      135 get_elems_short,
      136 get_elems_int,
      137 get_elems_long,
      138 get_elems_float,
      139 get_elems_double,
      140 get_elem_object,
      141 get_elem_string,
      142 set_elem_object,
      143 set_elem_string,
      144 get_chars,
      145 get_bool_object_value,
      146 concat_no_mortal,
      147 concat,
      148 shorten,
      149 make_read_only,
      150 is_read_only,
      151 print,
      152 print_stderr,
      153 dump_no_mortal,
      154 dump,
      155 dumpc,
      156 copy_no_mortal,
      157 copy,
      158 get_spvm_version_string,
      159 get_spvm_version_number,
      160 get_version_string,
      161 get_version_number,
      162 die,
      163 get_exception,
      164 set_exception,
      165 new_stack_trace_no_mortal,
      166 new_stack_trace,
      167 is_string,
      168 is_class,
      169 is_pointer_class,
      170 is_array,
      171 is_object_array,
      172 is_numeric_array,
      173 is_mulnum_array,
      174 isa,
      175 isa_by_name,
      176 is_type,
      177 is_type_by_name,
      178 elem_isa,
      179 get_elem_size,
      180 get_type_name_no_mortal,
      181 get_type_name,
      182 get_compile_type_name_no_mortal,
      183 get_compile_type_name,
      184 enter_scope,
      185 leave_scope,
      186 push_mortal,
      187 weaken,
      188 isweak,
      189 unweaken,
      190 strerror_string,
      191 strerror_string_nolen,
      192 strerror,
      193 strerror_nolen,
      194 new_memory_stack,
      195 free_memory_stack,
      196 new_stack,
      197 free_stack,
      198 get_field_object_defined_and_has_pointer_by_name,
      199 get_field_object_ref,
      200 get_field_object_ref_by_name,
      201 check_stack_env,
      202 assign_object,
      203 new_string_array_no_mortal,
      204 new_memory_block,
      205 free_memory_block,
      206 get_memory_blocks_count,
      207 say,
      208 warn,
      209 spvm_stdin,
      210 spvm_stdout,
      211 spvm_stderr,

0.989062 2023-11-20
  [New Features]
    * Add the prepend_include_dir compiler native API is added.
  [Changes]
    * An interface can have class methods.
  [Bug Fix]
    * Fix the bug that the env got by the get_current_env method in the Native class does not contains the current runtime.
  [New Features]
    * Add the get_basic_type_id method to the Fn class.
    * Add the Error::Compile class.
  [Test Improvement]
    * Add tests of error classes.
  [Incompatible Changes]
    * The compile method in the Native::Compiler throw an exception when compilation errors occurred.
    * The compile method in the Native::Compiler returns void.
    * The code_point method in the Fn class throw an exceptions.
    * Remove the GET_CODE_POINT_ERROR_OVER_STRING_RANGE and GET_CODE_POINT_ERROR_INVALID_UTF8 methods from the Fn class.
  [Exception Message Improvement]
    * Add periods to exception messages.
0.989061 2023-11-14
  [Incompatible Changes]
    * The __PACKAGE__ operator returns its outer class in anon method.
    * The current class "&" means its outer class in anon method.
    * If the class variable is used in an anon method and it is not full qualified, its current class means its outer class.
  [Changes]
    * The Perl module file Name section the spvmdist command generates is change a little.
0.989060 2023-11-09
  [Compilation Error Messages Improvement]
    * Improve compilation error messages in interface.
  [New Features]
    * Add more simple anon method filed definition syntax

        class Foo::Bar {
          method some_method : void () {
            my $foo = 1;
            my $bar = 5L;
            
            my $comparator = (Comparator)[has foo : int = $foo, has bar : long = $bar] method : int ($x1 : object, $x2 : object) {
              my $foo = $self->{foo};
              my $bar = $self->{bar};
              
              print "$foo\n";
              print "$bar\n";
            };
          }
        }

      Same as avobe but more simple with new syntax:

        class Foo::Bar {
          method some_method : void () {
            my $foo = 1;
            my $bar = 5L;
            
            my $comparator = (Comparator)[$foo : int, $bar : long] method : int ($x1 : object, $x2 : object) {
              print "$foo\n";
              print "$bar\n";
            };
          }
        }

      
0.989059 2023-11-09
  [Test Improvement]
    * Add tests of thread safetiness.
  [Changes]
    * The first version number of the Changes file generated by the spvmdist command is changed from 0.01 to 0.001.
    * Add a test that checks the count of memory blocks to the t/basic.t file generated by the spvmdist command.
  [Bug Fix]
    * Fix the bug that line numbers in compilation error messages.
  [New Features]
    * Add the check_option_names method to the Fn class.
    * Add the shuffle_object method to the Array class.
    * Add syntax of die OPERAND_ERROR_ID ',' OPERAND_MESSAGE.
    * Add spvm_warnf Native API.
    * Add the spvm_stdin native API.
    * Add the spvm_stdout native API.
    * Add the spvm_stderr native API.
    
  [Breaking Binary Compatibility]
    * Break the binary compatibility of the die statement.
  [Internal Changes]
    * SET_ERROR_ID in spvm_impelment.h receives a basic type ID instead of a basic type.
    * SET_ERROR_ID in spvm_opcode.h is renamed to SET_ERROR_ID_BY_TYPE.
0.989058 2023-10-30
  [Bug Fix]
    * Fix the bug that the print_stderr native API print output to stdout.
  [Incompatible Changes]
    * The new_stack native API uses the new_memory_block native API.
    * The free_stack native API uses the free_memory_block native API.
    
0.989057 2023-10-30
  [Internal Changes]
    * Keys of spvm_hash is allocated temporary in temporary hash.
    * Entries of spvm_hash is allocated temporary in temporary hash.
    * The val field of the Hash::Entry is renamed to value.
  [Incompatible Changes]
    * The get_memory_blocks_count method in the SPVM::ExchangeAPI returns the count of memory blocks the runtime allocate.
    * The get_memory_blocks_count in the native API returns the count of memory blocks the runtime allocate.
    * Remove the get_meory_block_count_stack in the native API.
0.989056 2023-10-30
  [Incompatible Changes]
    * Remove the lock_object in the internal native API.
    * Remove the unlock_object in the internal native API.
    * The inc_ref_count in the internal native API becomes atomic operation.
    * The dec_ref_count in the internal native API becomes atomic operation.
  [Internal Changes]
    * Each object does not have a mutex.
  [Bug Fix]
    * Some mutex bugs are fixed.
    
0.989055 2023-10-28
  [Incompatible Changes]
    * Revert the following changes
      
      [Incompatible Changes] 0.989054 2023-10-26
        * The pop and shift methods in the List class and the StringList class return undef if the length is 0, instead of throwing an exception.
          
0.989054 2023-10-26
  [Incompatible Changes]
    * Remove the get_array_unsafe method from the StringList class and the List class.
    * Remove the set_array methods are removed from the ByteList, ShortList, IntList, LongList, FloatList, DoubleList, StringList, and List classes.
    * Remove the DEFAULT_CAPACITY enumerations are removed from the ByteList, ShortList, IntList, LongList, FloatList, DoubleList, StringList, and List classes.
  [Changes]
    * The StringList class extends the List class.
    * The shift and unshift method becomes O(1) in the List and StringList classes.
    
  [Bug Fix]
    * Fix the bug that the reserve method in the List class creates any object array instead of using Array->new_proto.
0.989053 2023-10-26
  [New Feautres]
    * Add the to_address method to the Fn class.
    
      static method to_address : string ($object : object);
  [Compilation Error Message Changes]
    * A compilation error message is changed.
      [before]
        The character -2 in a 8bit signed integer is not expected.
      [after]
        Use of the character code "FE" is not allowed in source code.
  [Bug Fix]
    * Fix a bug that a token is returned when the charactor is not allowed in source code.
    * Fix a bug where the tokenizer was affected by locale.
    
0.989052 2023-10-24
  [New Features]
    * Add the get_memory_blocks_count method to the Fn class.
      
      static method get_memory_blocks_count : int ();
  [Fix Warnings]
    * Fix warnings in Windows such as "warning: implicit declaration of function 'InitializeSRWLock';"
    
0.989051 2023-10-11
  [New Feature]
    * Add the Callback class.
    * Add the defer method to the Fn class.
    * Add the SPVM_NATIVE_GET_POINTER macro function to the Native APIs.
    * Add the SPVM_NATIVE_SET_POINTER macro function to the Native APIs.

  [Incompatible Changes]
    * The handler field in the Scope::Guard class is renamed to the callback field.
    * Remove the Scope::Guard::Handler.
    * Change the definition of the new method in the Scope::Guard class.
      [before]
        static method new : Scope::Guard ($handler : Scope::Guard::Handler);
      
      [after]
        static method new : Scope::Guard ($callback : Callback);
    * Remove the Native::MethodCall::Callback class.
    * Change the definition of the new method in the Scope::Guard class.
      [before]
        static method call_callback : void ($callback : Native::MethodCall::Callback, $error_id : int*, $stack : Native::Stack = undef);
      
      [after]
        static method call_callback : void ($callback : Callback, $error_id : int*, $stack : Native::Stack = undef);
    
    * Rename the SPVM_API_new_env function in spvm_native.h to SPVM_NATIVE_new_env. This is undocumented function.
    * Remove the SPVM_API_free_env function. This is undocumented function.
  [Internal Changes]
    * The pointer member is moved to the beginning of spvm_object structure.
0.989050 2023-10-04
  [Incompatible Changes]
    * Rename the Mutex class to the Sync::Mutex class.
    
0.989049 2023-10-04
  [New Features]
    * Add the mutex native APIs.
    * Add the Mutex class.
    
0.989048 2023-10-03
  [Internal Changes]
    * The warn operator does not call fflush function in the C language.
    * The print operator uses the print native API.
    * The say operator uses the say native API.
    * The say operator uses the warn native API.
  [Incompatible Changes]
    * The print native API outputs to SPVM stdout instead of the C language stdout.
    * The print_stderr native API outputs to SPVM stderr instead of the C language stderr.
  [New Feature]
    * The say native API is added.
    * The warn native API is added.
0.989047 2023-09-30
  [New Features]
    * SPVM has own stdin, stdout, stderr.
    
    * Add the following runtime native APIs
    
      FILE* (*get_spvm_stdin)(void* runtime);
      
      FILE* (*get_spvm_stdout)(void* runtime);
      FILE* (*get_spvm_stderr)(void* runtime);
  [Bug Fix]
    * Fix bugs that SPVM stdio does not work well on latest Windows 2022 Server.

0.989046 2023-09-28
  [Internal Changes]
    * Use setmode instead of _setmode because _setmode fails in latest MinGW.
  [Incompatible Changes]
    * Remove the leave_scope_local native API.
    * Remove the compiler field from the Native::Env class.
    * Remove the compiler Native API.
    * The get_memory_blocks_count method in the ExchangeAPI class returns the count of the memory blocks allocated by the current call stack,
      instead of the current environment.
    * The new_memory_stack method do not increment the memory blocks count allocated by the runtime allocator.
    * The free_memory_stack method do not decrement the memory blocks count allocated by the runtime allocator.
    * Remove the new_memory_env native API.
    * Remove the free_memory_env native API.
    * Remove the get_memory_blocks_count_env native API.
    * Remove the allocator native API.
    
  [New Features]
    * Add the following runtime native APIs
    
      void* (*get_compiler)(void* runtime);
      
      void (*set_compiler)(void* runtime, void* compiler);
    * Add the get_compiler method to the Native::Runtime class.
    * Add the following Native APIs.
    
      void* (*new_memory_block)(SPVM_ENV* env, SPVM_VALUE* stack, size_t size);
      void (*free_memory_block)(SPVM_ENV* env, SPVM_VALUE* stack, void* block);
      int32_t (*get_memory_blocks_count)(SPVM_ENV* env, SPVM_VALUE* stack);

  [Deprecations]
    * Deprecate the following Native APIs.
    
      void* (*new_memory_stack)(SPVM_ENV* env, SPVM_VALUE* stack, size_t size);
      void (*free_memory_stack)(SPVM_ENV* env, SPVM_VALUE* stack, void* block);
      int32_t (*get_memory_blocks_count_stack)(SPVM_ENV* env, SPVM_VALUE* stack);
    
0.989045 2023-09-26
  [New Features]
    * Make SPVM Language thread-safe logically. The tests are not done.
    
0.989044 2023-09-18
  [Internal Changes]
    * A blessed object has SV* object instead of the reference to SV* object
  [New Features]
    * Add the following Native APIs.
    
      void* (*new_string_array_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
    * Add internal native APIs.
  [Changes]
    * The unweaken operator and the unweaken native API becomes thread safe.
    * The weaken operator and the weaken native API becomes thread safe.
    
  [Incompatible Changes]
    * The following native APIs are removed.
    
      -  void (*dec_ref_count)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
      -  void (*dec_ref_count_only)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
      -  void (*inc_ref_count)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
      -  int32_t (*get_ref_count)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
    
0.989043 2023-09-18
  [New Features]
    * Add the following native APIs.
    
      void (*dec_ref_count_only)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
      void (*leave_scope_local)(SPVM_ENV* env, SPVM_VALUE* stack, void** object_vars, int32_t* mortal_stack, int32_t* mortal_stack_top_ptr, int32_t original_mortal_stack_top);
      void (*assign_object)(SPVM_ENV* env, SPVM_VALUE* stack, void** dist_address, void* src_object);
  [Changes]
    * SPVM object have a mutex data.
  
  [Internal Changes]
    * Assignability symbol table becomes thread safe.
    * compile becomes thread safe.

  [Incompatible Changes]
    
    * The following native APIs are renamed.
    
      -  void** (*get_class_var_object_address)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var);
      +  void** (*get_class_var_object_ref)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var);
      
      -  void** (*get_field_object_address)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      +  void** (*get_field_object_ref)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      
      -  void** (*get_field_object_address_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* field_name, int32_t* error_id, const char* func_name, const char* file, int32_t line);
      +  void** (*get_field_object_ref_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* field_name, int32_t* error_id, const char* func_name, const char* file, int32_t line);
    
    * The following native APIs are removed.
      
      int32_t (*remove_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t scope_id, void* remove_object);

0.989042 2023-09-12
  [Incompatible Changes]
    * The create_default_config function in the SPVM::Builder::Util module return gnu99 instead of c99.
    * The default config become gnu99 instead of c99 in all places.
    * The default value of the dynamic_lib_ccflags in the SPVM::Builder::Config module.
      [Before]
        if ($Config{cccdlflags} =~ /-fPIC\b/) {
          $self->dynamic_lib_ccflags(['-fPIC']);
        }
        else {
          $self->dynamic_lib_ccflags([]);
        }
      [After]
        if ($^O eq 'MSWin32') {
          $self->dynamic_lib_ccflags([]);
        }
        else {
          $self->dynamic_lib_ccflags(['-fPIC']);
        }
  [New Features]
    * The following fidlds are added to the SPVM::Builder::Config module.
    
      thread_ccflags
      thread_ldflags
    
    * All modules are compiled and linked with "-pthread" option except for Windows.
      This is because of using mutex features.
      
    * All SPVM source files are compiled and linked with "-pthread" option except for Windows.
      This is because of using mutex features.
    
    * Add spvm_mutex.h and spvm_mutex.c.
  [Document Improvement]
    * Class names in the return value and argument in method definitions in doc are linked.
0.989041 2023-09-09
  [New Features]
    * The call_method method in the SPVM::ExchangeAPI class: any object argument can receive a value of string type.
    
  [Exception Messages Changes]
    * English syntax is improved. "the $arg" is changeded to "$arg".
    * SPVM.xs: Exception messages are improved.
  [Bug Fix]
    * Fix a bug that when the global Exchange API object is refered from sub routnie, a segfault occur.
    * Fix a bug that the plcae that needs only a basic type name uses SPVM::BlessedObject::String.
      Segfault occured in some places.
      
0.989040 2023-09-06
  [Changes]
    * Anon class has the same access constrol as the outer class.
    * Anon class has the same alias names as the outer class.
  [Test Bug Fix]
    * Tests of the add_before_link_cb in the SPVM::Builder::Config are fixed.
0.989039 2023-09-05
  [New Features]
    * The following methods are added to the Array class.

      static method merge_byte : byte[] ($array1 : byte[], $array2 : byte[]);

      static method merge_short : short[] ($array1 : short[], $array2 : short[]);

      static method merge_int : int[] ($array1 : int[], $array2 : int[]);

      static method merge_long : long[] ($array1 : long[], $array2 : long[]);

      static method merge_float : float[] ($array1 : float[], $array2 : float[]);

      static method merge_double : double[] ($array1 : double[], $array2 : double[]);

      static method merge_string : string[] ($array1 : string[], $array2 : string[]);

      static method merge_object : object[] ($array1 : object[], $array2 : object[]);

  [Bug Fix]
    * A bug fix: The following tests has not succeeded.
    
      {
        my $source = [
          'class MyClass2 extends MyClass { use Point; use Point3D; method main : void ($point : Point3D) {} }',
          'class MyClass { use Point; use Point3D; method main : void ($point : Point) {} }',
        ];
        compile_ok($source);
      }
      
      {
        my $source = [
          'class MyClass2 extends MyClass { use Point; use Point3D; method main : void ($point : Point) {} }',
          'class MyClass { use Point; use Point3D; method main : void ($point : Point3D) {} }',
        ];
        compile_not_ok($source, q|The type of the 1th argument of the "main" method in the "MyClass2" class must be able to be assigned to the type of the 1th argument of the "main" method in the "MyClass" class.|);
      }

0.989039 2023-08-30
  [Warnings Fix]
    * Suppress warning: unknown warning option ‘-Wno-compound-token-split-by-macro’ [-Wunknown-warning-option] in Mac.
    
0.989038 2023-08-29
  [New Features]
    * Here document is supported.
    
0.989037 2023-08-28
  
  [Document Changes]
    * The doc of the Hash class is improved.
  [Internal Changes]
    * ppport.h is upgraded to 3.68
    * The default entries length of a hash become 1.
  [Incompatible Bug Fix]
  
    * The is_class_method field in the SPVM::Builder::LibInfo is renamed to is_static.
      This is wrongly changed.
    * The count field in the Hash class is renamed to the keys_length method.
    * The the to_array method in the Hash class support decendent order.
  [Incompatible Changes]
    * The delete method in the Hash class throws an excetpion.
    
      The $key must be defined.
    
    * The exists method in the Hash class throws an excetpion.
    
      The $key must be defined.
    
    * The get method in the Hash class throws an excetpion.
    
      The $key must be defined.
    
0.989036 2023-08-17

  [New Features]
    * The type native APIs are added.
  [Incompatible Changes]
    * The following runtime nataive APIs are removed and moved to the type native APIs.
    
      int32_t (*get_type_width)(void* runtime, void* basic_type, int32_t dimension, int32_t flag);
      int32_t (*can_assign)(void* runtime, void* dist_basic_type, int32_t dist_type_dimension, int32_t dist_type_flag, void* src_basic_type, int32_t src_type_dimension, int32_t src_type_flag);
      int32_t (*is_object_type)(void* runtime, void* basic_type, int32_t type_dimension, int32_t flag);
      
    * Native API IDs of runtime nataive API are changed.
      
      0 get_object_data_offset
      1 get_object_ref_count_offset
      2 get_object_length_offset
      3 get_basic_type_by_id
      4 get_basic_type_by_name
      5 get_basic_types_length
      6 build_precompile_module_source
      7 build_precompile_method_source
      
0.989035 2023-08-14

  [Changes]
    * An interface can have multiple required methods.
    * An interface can define an interface of itself.
      class MyClass : interface_t {
        interface MyClass;
      }
  [Document Changes]
    * Module Attribute is renamed to Class Attribute
    * SPVM::Document::NativeModule is renamed to SPVM::Document::NativeClass
  
  [Incompatible Changes]
    * All methods and fields and native APIs that names are "module_name" are renamed to "class_name".
    * The module file native API is renamed to the class file native API.
  [Bug Fix]
    * A bug fix: the get_field_string native API does not work well.
0.989034 2023-08-14

  [Bug Fix]
    * A bug is fixed: the interface checking has not worked well in compilation time.
    * A bug is fixed: the has_interface basic type native APIhas not worked well.
    * A bug is fixed: The checking of interface compatibility has not worked well in required interface methods.
  [Changes]
    * The checking of interface compatibility is performed when a type conversion is performed.
  [New Feature]
    * The duck typing is supported.
    * The type assignability is cached.
0.989033 2023-08-08

  [New Features]
    * The following native APIs are added.

      void** (*get_field_object_address)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      void** (*get_field_object_address_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* field_name, int32_t* error_id, const char* func_name, const char* file, int32_t line);
      int32_t (*check_stack_env)(SPVM_ENV* env, SPVM_VALUE* stack);

    * The Native class is added.
    * The Native::MethodCall::Callback class is added.
    * The following methods are added to the Native::MethodCall class.
    
      static method call_callback : void ($callback : Native::MethodCall::Callback, $error_id : int*, $stack = undef : Native::Stack);

      static method call_class_method : void ($basic_type_name : string, $method_name : string, $error_id : int*, $stack : Native::Stack = undef, $env : Native::Env = undef);
      
      static method get_exception : string ($stack : Native::Stack = undef, $env : Native::Env = undef);

      static method set_exception : void ($exception : string, $stack : Native::Stack = undef, $env : Native::Env = undef);
    
0.989032 2023-08-04
  [Revertion]
    * The following change is reverted.
    
      The definitions of the following fields in the Env class are changed.
      
      -  has compiler : ro Native::Compiler;
      +  has compiler : Native::Compiler;

      -  has runtime : ro Native::Runtime;
      +  has runtime : Native::Runtime;
0.989031 2023-08-02
  [New Features]
    * The Native::MethodCall class is added.
  [Incompatibe Changes]
    * The definitions of the following fields in the Stack class are changed.
      -  has env : ro Native::Env;
      +  has env : Native::Env;

    * The definitions of the following fields in the Env class are changed.
    
      -  has compiler : ro Native::Compiler;
      +  has compiler : Native::Compiler;

      -  has runtime : ro Native::Runtime;
      +  has runtime : Native::Runtime;

0.989030 2023-07-28
  [Incompatible Changes]
    * The following native APIs are renamed.
      -  int32_t (*items)(SPVM_ENV* env, SPVM_VALUE* stack);
      +  int32_t (*args_width)(SPVM_ENV* env, SPVM_VALUE* stack);
    * The items operator is renamed to args_width.
  [New Features]
    * The following runtime native APIs were added.
    
      +  int32_t (*get_type_width)(void* runtime, void* basic_type, int32_t dimension, int32_t flag);
      
    * The following argument native APIs were added.
    
      + int32_t (*get_stack_index)(void* runtime, void* arg);
      
  [Changes]
    * The width of the arguments must be less than or equal to 255.
0.989029 2023-07-27
  [New Features]
    * The following native APIs were added.
    
      void* (*get_field_object_defined_and_has_pointer_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* field_name, int32_t* error_id, const char* func_name, const char* file_name, int32_t line);
  [Bug Fix]
    * The Native::Env memory bug is fixed.
    
0.989028 2023-07-26
  [New Features]
    * The following compiler native APIs were added.
    
      void (*add_module_file)(void* compiler, const char* module_name);
      void (*delete_module_file)(void* compiler, const char* module_name);

  [New Features]
    * The following module file native APIs are added.
    
      +  void* (*free_instance)(void* compiler, void* module_file);

  [Incompatible Changes]
    * The order of the compiler native APIs were changed.
      0 new_instance,
      1 free_instance,
      2 get_start_line,
      3 set_start_line,
      4 get_start_file,
      5 set_start_file,
      6 get_include_dirs_length,
      7 get_include_dir,
      8 add_include_dir,
      9 clear_include_dirs,
      10 get_module_file,
      11 set_module_file,
      12 compile,
      13 get_error_message,
      14 get_error_messages_length,
      15 get_runtime,
    * if (rquire Foo) statement was now reset after a single compilation.
    * The set_module_file compiler native API can be set even if the module file alread exists.
    * The following methods in the Native::ModuleFile class were removed.
      
      static method new : Native::ModuleFile ($compiler : Native::Compiler);
      method set_module_name : void ($module_name : string);
      
    * The following module file Native APIs were removed.
      
      void* (*new_instance)(void* compiler);
      void (*set_module_name)(void* compiler, void* module_file, const char* module_name);
    
    * The following compiler native APIs were removed.
      
      void (*set_module_file)(void* compiler, const char* module_name, void* module_file);
    
    * Native API IDs of the module file native APIs were changed.

      0 get_module_name
      1 get_file
      2 set_file
      3 get_dir
      4 set_dir
      5 get_rel_file
      6 set_rel_file
      7 get_content
      8 set_content
      9 get_content_length
      10 set_content_length

    * Native API IDs of the compiler native APIs were changed.

      0 new_instance
      1 free_instance
      2 get_start_line
      3 set_start_line
      4 get_start_file
      5 set_start_file
      6 get_include_dirs_length
      7 get_include_dir
      8 add_include_dir
      9 clear_include_dirs
      10 add_module_file
      11 delete_module_file
      12 get_module_file
      13 compile
      14 get_error_message
      15 get_error_messages_length
      16 get_runtime

      
0.989027 2023-07-23
  [Bug Fix]
    * A bug fixed: The error messages of the compiler had not been freeded properly.
    * A bug fixed: The each time compile memory had not been freeded when the compilation failed.
    
0.989026 2023-07-21
  [Incompatible Changes]
    * The __module_name field in the SPVM::ExchangAPI::Class was renamed to the __name field.
    
    * The module file native APIs were changed.
    
      -  void (*set_module_name)(void* compiler, void* module_file, void* module_name);
      +  void (*set_module_name)(void* compiler, void* module_file, const char* module_name);
      -  void (*set_file)(void* compiler, void* module_file, void* file);
      +  void (*set_file)(void* compiler, void* module_file, const char* file);
      -  void (*set_dir)(void* compiler, void* module_file, void* dir);
      +  void (*set_dir)(void* compiler, void* module_file, const char* dir);
      -  void (*set_rel_file)(void* compiler, void* module_file, void* rel_file);
      +  void (*set_rel_file)(void* compiler, void* module_file, const char* rel_file);
      -  void (*set_content)(void* compiler, void* module_file, void* content);
      +  void (*set_content)(void* compiler, void* module_file, const char* content);
   * The following compiler native APIs were renamed.
     -  void (*add_module_file)(void* compiler, const char* module_name, void* module_file);
     +  void (*set_module_file)(void* compiler, const char* module_name, void* module_file);

  [New Features]
    * The Native::ModuleFile class was added.

    * The following methods were added to the Native::Compiler.
      +  method get_module_file : Native::ModuleFile ($module_name : string);
      +  method set_module_file : void ($module_name : string, $module_file : Native::ModuleFile);

  [Bug Fix]
    * The bug that SPVM file dependencies was wrong was fixed.
0.989025 2023-07-18
  [New Features]
    * The following methods were added to the Native::Runtime.
      method get_basic_types_length : int ();
      
      method get_basic_type : Native::BasicType ($id : int);
      
    * The following argument native API were added.
    
      const char* (*get_name)(void* runtime, void* arg);
      int32_t (*get_index)(void* runtime, void* arg);

  [Incompatible Changes]
    * Modules renamed.
      Env was renamed to Native::Env.
      Stack was renamed to Native::Stack.
      Runtime was renamed to Native::Runtime.
      Compiler was renamed to Native::Compiler.
    
    * The native API IDs in the class variable native APIs were changed.
      
      0 get_name
      1 get_index
      2 get_basic_type
      3 get_type_dimension
      4 get_type_flag
      5 get_current_basic_type
    
    * The index native API were added to the class variable native APIs.
    
      int32_t (*get_index)(void* runtime, void* class_var);

    * The native API IDs in the argument native APIs were changed.

      0 get_name
      1 get_index
      2 get_basic_type
      3 get_type_dimension
      4 get_type_flag
      
    * The following methods in the Native::Runtime were removed.
      
      - method get_basic_type_names : string[] ();
      - method get_basic_type_parent_name : string ($basic_type_name : string);
      - method get_basic_type_anon_basic_type_names : string[] ($basic_type_name : string);
      - method get_method_names : string[] ($basic_type_name : string, $options : object[] = undef)
      - method get_method_is_class_method : int ($basic_type_name : string, $method_name : string);
      - method get_precompile_method_address : Address ($basic_type_name : string, $method_name : string);
      - method get_native_method_address : Address ($basic_type_name : string, $method_name : string);
      - method set_native_method_address : string ($basic_type_name : string, $method_name : string, $address : Address);
      - method set_precompile_method_address : string ($basic_type_name : string, $method_name : string, $address : Address);
      
    * The following methods in the Native::Runtime were changed.
      
      - method build_precompile_module_source : string ($basic_type_name : string);
      + method build_precompile_module_source : string ($basic_type : Native::BasicType);
      
0.989024 2023-07-14
  [New Features]
    * The runtime was created by the additional compile.
    
    * The following native APIs were added.
    
      void* compiler;
      
  [Incompatibe Changes]
    * The DESTROY method in the Runtime class was removed.
  [Incompatibe Changes]
    * The DESTROY method in the Runtime class was removed.
    
    * The following runtime native APIs were removed.
    
      -  void* (*new_instance)(void);
      -  void (*free_instance)(void* runtime);
    
    * The runtime native API IDs were reordered.
    
      0 get_object_data_offset
      1 get_object_ref_count_offset
      2 get_object_length_offset
      3 get_basic_type_by_id
      4 get_basic_type_by_name
      5 get_basic_types_length
      6 is_object_type
      7 can_assign
      8 build_precompile_module_source
      9 build_precompile_method_source
    
    * Compiler native APIs were changed.

      -  void* (*build_runtime)(void* compiler);
      +  void* (*get_runtime)(void* compiler);
    
    * The following methods in the Compiler class were changed.
      
      -  native method build_runtime : Runtime ();
      +  native method get_runtime : Runtime ();

    * The following methods and fields in the Env class were changed.
         # Fields
      -  has runtime : ro Runtime;
      +  has compiler : ro Compiler;

         # Class Methods
      -  native static method new : Env ($runtime : Runtime = undef);
      +  native static method new : Env ($compiler : Compiler = undef);

  [Incompatibe Changes]
  
    * The Native API IDs were reordered.
    0 compiler
    1 runtime
    2 api
    3 new_env
    4 free_env
    5 call_init_methods
    6 set_command_info_program_name
    7 set_command_info_argv
    8 set_command_info_base_time
    9 destroy_class_vars
    10 items
    11 get_object_basic_type
    12 get_object_basic_type_id
    13 get_object_basic_type_name
    14 get_object_type_dimension
    15 get_basic_type
    16 get_basic_type_by_name
    17 get_basic_type_by_id
    18 get_basic_type_id
    19 get_basic_type_id_by_name
    20 get_class_var
    21 get_class_var_byte
    22 get_class_var_short
    23 get_class_var_int
    24 get_class_var_long
    25 get_class_var_float
    26 get_class_var_double
    27 get_class_var_object
    28 get_class_var_string
    29 set_class_var_byte
    30 set_class_var_short
    31 set_class_var_int
    32 set_class_var_long
    33 set_class_var_float
    34 set_class_var_double
    35 set_class_var_object
    36 set_class_var_string
    37 get_class_var_object_address
    38 get_class_var_byte_by_name
    39 get_class_var_short_by_name
    40 get_class_var_int_by_name
    41 get_class_var_long_by_name
    42 get_class_var_float_by_name
    43 get_class_var_double_by_name
    44 get_class_var_object_by_name
    45 get_class_var_string_by_name
    46 set_class_var_byte_by_name
    47 set_class_var_short_by_name
    48 set_class_var_int_by_name
    49 set_class_var_long_by_name
    50 set_class_var_float_by_name
    51 set_class_var_double_by_name
    52 set_class_var_object_by_name
    53 set_class_var_string_by_name
    54 get_field
    55 get_field_static
    56 get_field_byte
    57 get_field_short
    58 get_field_int
    59 get_field_long
    60 get_field_float
    61 get_field_double
    62 get_field_object
    63 get_field_string
    64 set_field_byte
    65 set_field_short
    66 set_field_int
    67 set_field_long
    68 set_field_float
    69 set_field_double
    70 set_field_object
    71 set_field_string
    72 get_field_byte_by_name
    73 get_field_short_by_name
    74 get_field_int_by_name
    75 get_field_long_by_name
    76 get_field_float_by_name
    77 get_field_double_by_name
    78 get_field_object_by_name
    79 get_field_string_by_name
    80 set_field_byte_by_name
    81 set_field_short_by_name
    82 set_field_int_by_name
    83 set_field_long_by_name
    84 set_field_float_by_name
    85 set_field_double_by_name
    86 set_field_object_by_name
    87 set_field_string_by_name
    88 get_field_string_chars_by_name
    89 get_method
    90 get_class_method
    91 get_instance_method_static
    92 get_instance_method
    93 call_method_no_mortal
    94 call_method
    95 call_class_method_by_name
    96 call_instance_method_static_by_name
    97 call_instance_method_by_name
    98 new_object_no_mortal
    99 new_object
    100 new_object_by_name
    101 new_pointer_object_no_mortal
    102 new_pointer_object
    103 new_pointer_object_by_name
    104 get_pointer
    105 set_pointer
    106 new_string_nolen_no_mortal
    107 new_string_nolen
    108 new_string_no_mortal
    109 new_string
    110 new_byte_array_no_mortal
    111 new_byte_array
    112 new_short_array_no_mortal
    113 new_short_array
    114 new_int_array_no_mortal
    115 new_int_array
    116 new_long_array_no_mortal
    117 new_long_array
    118 new_float_array_no_mortal
    119 new_float_array
    120 new_double_array_no_mortal
    121 new_double_array
    122 new_object_array_no_mortal
    123 new_object_array
    124 new_object_array_by_name
    125 new_string_array
    126 new_muldim_array_no_mortal
    127 new_muldim_array
    128 new_muldim_array_by_name
    129 new_mulnum_array_no_mortal
    130 new_mulnum_array
    131 new_mulnum_array_by_name
    132 new_array_proto_no_mortal
    133 new_array_proto
    134 length
    135 get_elems_byte
    136 get_elems_short
    137 get_elems_int
    138 get_elems_long
    139 get_elems_float
    140 get_elems_double
    141 get_elem_object
    142 get_elem_string
    143 set_elem_object
    144 set_elem_string
    145 get_chars
    146 get_bool_object_value
    147 concat_no_mortal
    148 concat
    149 shorten
    150 make_read_only
    151 is_read_only
    152 print
    153 print_stderr
    154 dump_no_mortal
    155 dump
    156 dumpc
    157 copy_no_mortal
    158 copy
    159 get_spvm_version_string
    160 get_spvm_version_number
    161 get_version_string
    162 get_version_number
    163 die
    164 get_exception
    165 set_exception
    166 new_stack_trace_no_mortal
    167 new_stack_trace
    168 is_string
    169 is_class
    170 is_pointer_class
    171 is_array
    172 is_object_array
    173 is_numeric_array
    174 is_mulnum_array
    175 isa
    176 isa_by_name
    177 is_type
    178 is_type_by_name
    179 elem_isa
    180 get_elem_size
    181 get_type_name_no_mortal
    182 get_type_name
    183 get_compile_type_name_no_mortal
    184 get_compile_type_name
    185 enter_scope
    186 leave_scope
    187 push_mortal
    188 remove_mortal
    189 weaken
    190 isweak
    191 unweaken
    192 strerror_string
    193 strerror_string_nolen
    194 strerror
    195 strerror_nolen
    196 allocator
    197 new_memory_env
    198 free_memory_env
    199 get_memory_blocks_count_env
    200 new_memory_stack
    201 free_memory_stack
    202 get_memory_blocks_count_stack
    203 new_stack
    204 free_stack
    205 get_ref_count
    206 inc_ref_count
    207 dec_ref_count
  
0.989023 2023-07-12
  [New Features]
    * The following native APIs were added.
      +  void* (*get_class_var_string)(void* env, void* stack, void* class_var);
      +  void (*set_class_var_string)(void* env, void* stack, void* class_var, void* value);
      +  void* (*get_class_var_string_by_name)(void* env, void* stack, const void* basic_type_name, const void* class_var_name, int32_t** error_id, const void* func_name, const void* file, int32_t line);
      +  void (*set_class_var_string_by_name)(void* env, void* stack, const void* basic_type_name, const void* class_var_name, void* value, int32_t** error_id, const void* func_name, const void* file, int32_t line);
      +  void* (*get_field_string)(void* env, void* stack, void* object, void* field);
      +  void (*set_field_string)(void* env, void* stack, void* object, void* field, void* value);
      +  void* (*get_field_string_by_name)(void* env, void* stack, void* object, const void* field_name, int32_t** error_id, const void* func_name, const void* file, int32_t line);
      +  void (*set_field_string_by_name)(void* env, void* stack, void* object, const void* field_name, void* value, int32_t** error_id, const void* func_name, const void* file, int32_t line);
    
    * The following methods were added to the Env class.
    
      method get_exception : string ();
      method set_exception : void ($exception : string);
      
  [Incompatibe Changes]
    * The Native API IDs were reordered.
    
      0 runtime
      1 api
      2 new_env
      3 free_env
      4 call_init_methods
      5 set_command_info_program_name
      6 set_command_info_argv
      7 set_command_info_base_time
      8 destroy_class_vars
      9 items
      10 get_object_basic_type
      11 get_object_basic_type_id
      12 get_object_basic_type_name
      13 get_object_type_dimension
      14 get_basic_type
      15 get_basic_type_by_name
      16 get_basic_type_by_id
      17 get_basic_type_id
      18 get_basic_type_id_by_name
      19 get_class_var
      20 get_class_var_byte
      21 get_class_var_short
      22 get_class_var_int
      23 get_class_var_long
      24 get_class_var_float
      25 get_class_var_double
      26 get_class_var_object
      27 get_class_var_string
      28 set_class_var_byte
      29 set_class_var_short
      30 set_class_var_int
      31 set_class_var_long
      32 set_class_var_float
      33 set_class_var_double
      34 set_class_var_object
      35 set_class_var_string
      36 get_class_var_object_address
      37 get_class_var_byte_by_name
      38 get_class_var_short_by_name
      39 get_class_var_int_by_name
      40 get_class_var_long_by_name
      41 get_class_var_float_by_name
      42 get_class_var_double_by_name
      43 get_class_var_object_by_name
      44 get_class_var_string_by_name
      45 set_class_var_byte_by_name
      46 set_class_var_short_by_name
      47 set_class_var_int_by_name
      48 set_class_var_long_by_name
      49 set_class_var_float_by_name
      50 set_class_var_double_by_name
      51 set_class_var_object_by_name
      52 set_class_var_string_by_name
      53 get_field
      54 get_field_static
      55 get_field_byte
      56 get_field_short
      57 get_field_int
      58 get_field_long
      59 get_field_float
      60 get_field_double
      61 get_field_object
      62 get_field_string
      63 set_field_byte
      64 set_field_short
      65 set_field_int
      66 set_field_long
      67 set_field_float
      68 set_field_double
      69 set_field_object
      70 set_field_string
      71 get_field_byte_by_name
      72 get_field_short_by_name
      73 get_field_int_by_name
      74 get_field_long_by_name
      75 get_field_float_by_name
      76 get_field_double_by_name
      77 get_field_object_by_name
      78 get_field_string_by_name
      79 set_field_byte_by_name
      80 set_field_short_by_name
      81 set_field_int_by_name
      82 set_field_long_by_name
      83 set_field_float_by_name
      84 set_field_double_by_name
      85 set_field_object_by_name
      86 set_field_string_by_name
      87 get_field_string_chars_by_name
      88 get_method
      89 get_class_method
      90 get_instance_method_static
      91 get_instance_method
      92 call_method_no_mortal
      93 call_method
      94 call_class_method_by_name
      95 call_instance_method_static_by_name
      96 call_instance_method_by_name
      97 new_object_no_mortal
      98 new_object
      99 new_object_by_name
      100 new_pointer_object_no_mortal
      101 new_pointer_object
      102 new_pointer_object_by_name
      103 get_pointer
      104 set_pointer
      105 new_string_nolen_no_mortal
      106 new_string_nolen
      107 new_string_no_mortal
      108 new_string
      109 new_byte_array_no_mortal
      110 new_byte_array
      111 new_short_array_no_mortal
      112 new_short_array
      113 new_int_array_no_mortal
      114 new_int_array
      115 new_long_array_no_mortal
      116 new_long_array
      117 new_float_array_no_mortal
      118 new_float_array
      119 new_double_array_no_mortal
      120 new_double_array
      121 new_object_array_no_mortal
      122 new_object_array
      123 new_object_array_by_name
      124 new_string_array
      125 new_muldim_array_no_mortal
      126 new_muldim_array
      127 new_muldim_array_by_name
      128 new_mulnum_array_no_mortal
      129 new_mulnum_array
      130 new_mulnum_array_by_name
      131 new_array_proto_no_mortal
      132 new_array_proto
      133 length
      134 get_elems_byte
      135 get_elems_short
      136 get_elems_int
      137 get_elems_long
      138 get_elems_float
      139 get_elems_double
      140 get_elem_object
      141 get_elem_string
      142 set_elem_object
      143 set_elem_string
      144 get_chars
      145 get_bool_object_value
      146 concat_no_mortal
      147 concat
      148 shorten
      149 make_read_only
      150 is_read_only
      151 print
      152 print_stderr
      153 dump_no_mortal
      154 dump
      155 dumpc
      156 copy_no_mortal
      157 copy
      158 get_spvm_version_string
      159 get_spvm_version_number
      160 get_version_string
      161 get_version_number
      162 die
      163 get_exception
      164 set_exception
      165 new_stack_trace_no_mortal
      166 new_stack_trace
      167 is_string
      168 is_class
      169 is_pointer_class
      170 is_array
      171 is_object_array
      172 is_numeric_array
      173 is_mulnum_array
      174 isa
      175 isa_by_name
      176 is_type
      177 is_type_by_name
      178 elem_isa
      179 get_elem_size
      180 get_type_name_no_mortal
      181 get_type_name
      182 get_compile_type_name_no_mortal
      183 get_compile_type_name
      184 enter_scope
      185 leave_scope
      186 push_mortal
      187 remove_mortal
      188 weaken
      189 isweak
      190 unweaken
      191 strerror_string
      192 strerror_string_nolen
      193 strerror
      194 strerror_nolen
      195 allocator
      196 new_memory_env
      197 free_memory_env
      198 get_memory_blocks_count_env
      199 new_memory_stack
      200 free_memory_stack
      201 get_memory_blocks_count_stack
      202 new_stack
      203 free_stack
      204 get_ref_count
      205 inc_ref_count
      206 dec_ref_count

    * The following native APIs were removed.
    
      - int32_t (*has_interface)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* interface_basic_type);
      -  int32_t (*has_interface_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* basic_type_name);
      -  void* (*alloc_memory_block_zero)(SPVM_ENV* env, size_t size);
      -  void (*free_memory_block)(SPVM_ENV* env, void* block);
      -  int32_t (*get_memory_blocks_count)(SPVM_ENV* env);
      -  void* memory_blocks_count;

    
    * The following native APIs were renamed.

      -  int32_t (*call_init_blocks)(SPVM_ENV* env, SPVM_VALUE* stack);
      +  int32_t (*call_init_methods)(SPVM_ENV* env, SPVM_VALUE* stack);

      -  void (*cleanup_global_vars)(SPVM_ENV* env, SPVM_VALUE* stack);
      +  void (*destroy_class_vars)(SPVM_ENV* env, SPVM_VALUE* stack);

      -  void* (*new_object_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type);
      +  void* (*new_object_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type);
      -  void* (*new_byte_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      +  void* (*new_byte_array_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      -  void* (*new_short_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      +  void* (*new_short_array_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      -  void* (*new_int_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      +  void* (*new_int_array_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      -  void* (*new_long_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      +  void* (*new_long_array_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      -  void* (*new_float_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      +  void* (*new_float_array_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      -  void* (*new_double_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      +  void* (*new_double_array_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t length);
      -  void* (*new_object_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t length);
      +  void* (*new_object_array_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t length);
      -  void* (*new_muldim_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t element_dimension, int32_t length);
      +  void* (*new_muldim_array_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t element_dimension, int32_t length);
      -  void* (*new_mulnum_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t length);
      +  void* (*new_mulnum_array_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t length);
      -  void* (*new_string_nolen_raw)(SPVM_ENV* env, SPVM_VALUE* stack, const char* bytes);
      +  void* (*new_string_nolen_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, const char* bytes);
      -  void* (*new_string_raw)(SPVM_ENV* env, SPVM_VALUE* stack, const char* bytes, int32_t length);
      +  void* (*new_string_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, const char* bytes, int32_t length);
      -  void* (*concat_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* string1, void* string2);
      +  void* (*concat_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* string1, void* string2);
      -  void* (*new_stack_trace_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* exception, void* method, int32_t line);
      +  void* (*new_stack_trace_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* exception, void* method, int32_t line);
      -  int32_t (*call_method_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* method, int32_t items);
      +  int32_t (*call_method_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* method, int32_t items);
      -  void* (*get_type_name_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
      +  void* (*get_type_name_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
      -  void* (*dump_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
      +  void* (*dump_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
      -  void* (*new_array_proto_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* array, int32_t length);
      +  void* (*new_array_proto_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* array, int32_t length);
      -  void* (*copy_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
      +  void* (*copy_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
      -  void* (*new_pointer_object_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, void* pointer);
      +  void* (*new_pointer_object_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, void* pointer);
      -  void* (*get_compile_type_name_raw)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t dimension, int32_t flag);
      +  void* (*get_compile_type_name_no_mortal)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t dimension, int32_t flag);

    * The following methods in the Env class were renamed.
    
      -  method build_stack : Stack ();
      +  method new_stack : Stack ();
      
0.989022 2023-07-11
  [Document Fix]
    * The doc of Native API IDs of the module file native APIs were fixed.
  
  [Incompatibe Changes]
    * The runtime native APIs were changed.
    
      -  void* object_header_size;
      -  void* object_ref_count_offset;
      -  void* object_length_offset;
      +  int32_t (*get_object_data_offset)(void* runtime);
      +  int32_t (*get_object_ref_count_offset)(void* runtime);
      +  int32_t (*get_object_length_offset)(void* runtime);  

      -  void (*build_precompile_module_source)(void* runtime, void* string_buffer, const char* module_name);
      -  void (*build_precompile_method_source)(void* runtime, void* string_buffer, const char* module_name, const char* method_name);
      +  void (*build_precompile_module_source)(void* runtime, void* string_buffer, void* module_basic_type);
      +  void (*build_precompile_method_source)(void* runtime, void* string_buffer, void* method);

    * The method native APIs were changed.
      -  void* (*get_opcode)(void* runtime, void* method, int32_t opcode_index);
      +  void* (*get_opcode_by_index)(void* runtime, void* method, int32_t opcode_index);
    
0.989021 2023-07-11
  [New Features]
    * The argument native API was added.
    * The class native variable API was added.
    * The field native API was added.
    * The method native API was added.
    * The basic type native API was added.
    
    * The following method were added to the Env class.
    
      static method new : Env ($runtime : Runtime = undef);
    
    * The following native APIs were added.
      void* (*get_runtime)(SPVM_ENV* env, SPVM_VALUE* stack);
      void (*set_runtime)(SPVM_ENV* env, SPVM_VALUE* stack, void* runtime);

  [Document Changes]
    * SPVM::Document::NativeClass was renamed to SPVM::Document::NativeModule.
  [Incompatibe Changes]
    * Native API IDs of the runtime native APIs were reordered.

      0 new_instance
      1 free_instance
      2 object_header_size
      3 object_ref_count_offset
      4 object_length_offset
      5 get_basic_type_by_id
      6 get_basic_type_by_name
      7 get_basic_types_length
      8 is_object_type
      9 can_assign
      10 build_precompile_module_source
      11 build_precompile_method_source

    * The following runtime native APIs were removed.

      -  const char* (*get_method_name)(void* runtime, void* method);
      -  int32_t (*get_method_is_class_method)(void* runtime, void* method);
      -  int32_t (*get_method_is_anon)(void* runtime, void* method);
      -  int32_t (*get_method_is_native)(void* runtime, void* method);
      -  int32_t (*get_method_is_precompile)(void* runtime, void* method);
      -  int32_t (*get_method_byte_vars_width)(void* runtime, void* method);
      -  int32_t (*get_method_short_vars_width)(void* runtime, void* method);
      -  int32_t (*get_method_int_vars_width)(void* runtime, void* method);
      -  int32_t (*get_method_long_vars_width)(void* runtime, void* method);
      -  int32_t (*get_method_float_vars_width)(void* runtime, void* method);
      -  int32_t (*get_method_double_vars_width)(void* runtime, void* method);
      -  int32_t (*get_method_object_vars_width)(void* runtime, void* method);
      -  int32_t (*get_method_ref_vars_width)(void* runtime, void* method);
      -  int32_t (*get_method_mortal_stack_length)(void* runtime, void* method);
      -  int32_t (*get_method_opcodes_length)(void* runtime, void* method);
      -  int32_t (*get_method_args_length)(void* runtime, void* method);
      -  int32_t (*get_method_required_args_length)(void* runtime, void* method);
      -  int32_t (*get_method_is_enum)(void* runtime, void* method);
      -  void* (*get_method_return_basic_type)(void* runtime, void* method);
      -  int32_t (*get_method_return_type_dimension)(void* runtime, void* method);
      -  int32_t (*get_method_return_type_flag)(void* runtime, void* method);
      -  void* (*get_method_current_basic_type)(void* runtime, void* method);
      -  void* (*get_method_by_index)(void* runtime, void* basic_type, int32_t method_index);
      -  void* (*get_method_by_name)(void* runtime, void* basic_type, const char* method_name);
      -  void* (*get_method_by_name)(void* runtime, void* basic_type, const char* method_name);
      -  int32_t (*get_method_index)(void* runtime, void* method);
      -  void* (*get_native_method_address)(void* runtime, void* method);
      -  void (*set_native_method_address)(void* runtime, void* method, void* address);
      -  void* (*get_precompile_method_address)(SPVM_ENV*, void* method);
      -  void (*set_precompile_method_address)(void* runtime, void* method, void* address);
         
      -  const char* (*get_field_name)(void* runtime, void* field);
      -  void* (*get_field_basic_type)(void* runtime, void* field);
      -  int32_t (*get_field_type_dimension)(void* runtime, void* field);
      -  int32_t (*get_field_type_flag)(void* runtime, void* field);
      -  void* (*get_field_current_basic_type)(void* runtime, void* field);
      -  void* (*get_field_by_index)(void* runtime, void* basic_type, int32_t field_index);
      -  void* (*get_field_by_name)(void* runtime, void* basic_type, const char* field_name);
      -  int32_t (*get_field_index)(void* runtime, void* field);
      -  int32_t (*get_field_offset)(void* runtime, void* field);

      -  void* (*get_class_var_by_index)(void* runtime, void* basic_type, int32_t class_var_index);
      -  const char* (*get_class_var_name)(void* runtime, void* class_var);
      -  void* (*get_class_var_basic_type)(void* runtime, void* class_var);
      -  int32_t (*get_class_var_type_dimension)(void* runtime, void* class_var);
      -  int32_t (*get_class_var_type_flag)(void* runtime, void* class_var);
      -  void* (*get_class_var_current_basic_type)(void* runtime, void* class_var);
      -  void* (*get_class_var_by_name)(void* runtime, void* basic_type, const char* class_var_name);
      -  int32_t (*get_class_var_index)(void* runtime, void* class_var);
      -  void* (*get_class_var_current_basic_type)(void* runtime, void* class_var);
      -  void* (*get_class_var_by_name)(void* runtime, void* basic_type, const char* class_var_name);
      -  int32_t (*get_class_var_index)(void* runtime, void* class_var);
          
      -  void* (*get_arg_basic_type)(void* runtime, void* arg);
      -  int32_t (*get_arg_type_dimension)(void* runtime, void* arg);
      -  int32_t (*get_arg_type_flag)(void* runtime, void* arg);
      -  void* (*get_arg_by_index)(void* runtime, void* method, int32_t arg_index);
    
      - void* (*get_basic_type_anon_basic_type)(void* runtime, void* basic_type, int32_t anon_basic_type_index);
      -  const char* (*get_basic_type_module_rel_file)(void* runtime, void* basic_type);
      -  const char* (*get_basic_type_module_dir)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_is_anon)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_fields_length)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_methods_length)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_class_vars_length)(void* runtime, void* basic_type);
      -  void* (*get_basic_type_parent)(void* runtime, void* basic_type);
      -  const char* (*get_basic_type_version_string)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_class_vars_length)(void* runtime, void* basic_type);
      -  void* (*get_basic_type_parent)(void* runtime, void* basic_type);
      -  const char* (*get_basic_type_version_string)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_class_vars_length)(void* runtime, void* basic_type);
      -  void* (*get_basic_type_parent)(void* runtime, void* basic_type);
      -  const char* (*get_basic_type_version_string)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_id)(void* runtime, void* basic_type);

    * The following runtime native APIs were renamed.
    
      -  void* (*get_field)(void* runtime, void* basic_type, int32_t field_index);
      +  void* (*get_field_by_index)(void* runtime, void* basic_type, int32_t field_index);
      
      -  void* (*get_class_var)(void* runtime, void* basic_type, int32_t class_var_index);
      +  void* (*get_class_var_by_index)(void* runtime, void* basic_type, int32_t class_var_index);
      
      -  void* (*get_method)(void* runtime, void* basic_type, int32_t method_index);
      +  void* (*get_method_by_index)(void* runtime, void* basic_type, int32_t method_index);

      -  void* (*get_arg)(void* runtime, void* method, int32_t arg_index);
      +  void* (*get_arg_by_index)(void* runtime, void* method, int32_t arg_index);

    * The spvm_native.c was removed.
      
    * The methods in the Runtime class were removed.

      -  method build_env : Env ();

    * The following structures in Native API were renamed.

      -struct spvm_env_compiler;
      -typedef struct spvm_env_compiler SPVM_ENV_COMPILER;
      +struct spvm_api_compiler;
      +typedef struct spvm_api_compiler SPVM_API_COMPILER;

      -struct spvm_env_module_file;
      -typedef struct spvm_env_module_file SPVM_ENV_MODULE_FILE;
      +struct spvm_api_module_file;
      +typedef struct spvm_api_module_file SPVM_API_MODULE_FILE;

      -struct spvm_env_runtime;
      -typedef struct spvm_env_runtime SPVM_ENV_RUNTIME;
      +struct spvm_api_runtime;
      +typedef struct spvm_api_runtime SPVM_API_RUNTIME;

      -struct spvm_env_string_buffer;
      -typedef struct spvm_env_string_buffer SPVM_ENV_STRING_BUFFER;
      +struct spvm_api_string_buffer;
      +typedef struct spvm_api_string_buffer SPVM_API_STRING_BUFFER;

      -struct spvm_env_allocator;
      -typedef struct spvm_env_allocator SPVM_ENV_ALLOCATOR;
      +struct spvm_api_allocator;
      +typedef struct spvm_api_allocator SPVM_API_ALLOCATOR;
    
    * The following native API were removed.
    
      -  void (*free_env_prepared)(SPVM_ENV* env);
      -  void (*free_env)(SPVM_ENV* env);
      -  SPVM_ENV* (*new_env)(SPVM_ENV* env);

    * The following native API were renamed.

      -  SPVM_ENV* (*new_env_raw)();
      -  void (*free_env_raw)(SPVM_ENV* env);
      +  SPVM_ENV* (*new_env)();
      +  void (*free_env)(SPVM_ENV* env);

      -SPVM_ENV* SPVM_NATIVE_new_env_raw(void);
      +SPVM_ENV* SPVM_NATIVE_new_env(void);

    * The following native module file API were removed.
       
       - SPVM_API_MODULE_FILE* (*new_env)(void);

0.989020 2023-07-07
  [Incompatibe Changes]
    * The following Native APIs were removed.
      int32_t (*init_env)(SPVM_ENV* env);
    
    * The following Native Runtime APIs were removed.
      - int32_t* (*get_runtime_codes)(void* runtime);
      - int32_t (*get_runtime_codes_length)(void* runtime);
      - void (*build)(void* runtime, int32_t* runtime_codes);
      - void* (*get_allocator)(void* runtime);
      - int32_t* (*get_opcodes)(void* runtime);
      -  int32_t (*get_method_opcodes_base)(void* runtime, void* method);
      -  int32_t (*get_method_args_base)(void* runtime, void* method);
      -  int32_t (*get_basic_type_fields_base)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_methods_base)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_class_vars_base)(void* runtime, void* basic_type);
    
    * The following Native Runtime APIs were renamed.
      -  int32_t (*get_method_call_stack_byte_vars_length)(void* runtime, void* method);
      -  int32_t (*get_method_call_stack_short_vars_length)(void* runtime, void* method);
      -  int32_t (*get_method_call_stack_int_vars_length)(void* runtime, void* method);
      -  int32_t (*get_method_call_stack_long_vars_length)(void* runtime, void* method);
      -  int32_t (*get_method_call_stack_float_vars_length)(void* runtime, void* method);
      -  int32_t (*get_method_call_stack_double_vars_length)(void* runtime, void* method);
      -  int32_t (*get_method_call_stack_object_vars_length)(void* runtime, void* method);
      -  int32_t (*get_method_call_stack_ref_vars_length)(void* runtime, void* method);
      +  int32_t (*get_method_byte_vars_width)(void* runtime, void* method);
      +  int32_t (*get_method_short_vars_width)(void* runtime, void* method);
      +  int32_t (*get_method_int_vars_width)(void* runtime, void* method);
      +  int32_t (*get_method_long_vars_width)(void* runtime, void* method);
      +  int32_t (*get_method_float_vars_width)(void* runtime, void* method);
      +  int32_t (*get_method_double_vars_width)(void* runtime, void* method);
      +  int32_t (*get_method_object_vars_width)(void* runtime, void* method);
      +  int32_t (*get_method_ref_vars_width)(void* runtime, void* method);

    * The following methods in the Runtime were removed.
     
      method get_runtime_codes : int[] ();
      
    * The following Native Compiler APIs were removed.
      -  int32_t* (*create_runtime_codes)(void* compiler, void* allocator);
    
  [Changes]
    * The start_file argument of the set_start_file method in the Native Compiler API was copied.
    * The include_dir argument of the add_include_dir method in the Native Compiler API was copied.
  [New Features]
    * The following Native Compiler APIs were added.
    
      void* (*get_module_file)(void* compiler, const char* module_name);
      void (*add_module_file)(void* compiler, const char* module_name, void* module_file);
      void* (*build_runtime)(void* compiler);
      
    * SPVM Module File Native APIs were added.
    
    * The following Native API was added.
    
      void* (*get_object_basic_type)(SPVM_ENV* env, SPVM_VALUE* stack, void* object);
  
0.989019 2023-07-04
  [Changes]
    * spvm_module_file.h and spvm_module_c were added to include and src directories.
    * Compilation error messages in toke.c were improved.
    * Compilation error messages in op.c were improved.
  [Incompatibe Changes]
    * The no_compiler_api option in the SPVM::Builder::Config::Exe module was removed.
    * The no_precompile option in the SPVM::Builder::Config::Exe module was removed.
    * The following Native Runtime APIs were changed.

      -  void* (*new_object)();
      +  void* (*new_instance)(void);

      -  void (*free_object)(void* runtime);
      +  void (*free_instance)(void* runtime);

    * The following Native Compiler APIs were changed.

      -  void* (*new_object)();
      +  void* (*new_instance)(void);

      -  void (*free_object)(void* compiler);
      +  void (*free_instance)(void* compiler);

    * The following Native Precompile APIs were changed.

      -  void* (*new_object)();
      +  void* (*new_instance)(void);

      -  void (*free_object)(void* precompile);
      +  void (*free_instance)(void* precompile);

      -  void (*build_source)(void* precompile, void* string_buffer, const char* basic_type_name);
      +  void (*build_module_source)(void* precompile, void* string_buffer, const char* basic_type_name);

    * The following Native Allocator APIs were changed.

      -  void* (*new_object)();
      +  void* (*new_instance)(void);

      -  void (*free_object)(void* allocator);
      +  void (*free_instance)(void* allocator);

    * The following Native String Buffer APIs were changed.

      -  void* (*new_object)();
      +  void* (*new_instance)(void* allocator, int32_t capacity);

      -  void (*free_object)(void* string_buffer);
      +  void (*free_instance)(void* string_buffer);

      -  const char* (*get_value)(void* string_buffer);
      +  const char* (*get_string)(void* string_buffer);
    
    * The following Native Runtime APIs were added.
    
      +  void (*build_precompile_module_source)(void* runtime, void* string_buffer, const char* module_name);
      +  void (*build_precompile_method_source)(void* runtime, void* string_buffer, const char* module_name, const char* method_name);

    * The methods in the Rutnime class were added and Native Precompile APIs were removed.

      -  method build_precompile_source : string ($basic_type_name : string);
      +  method build_precompile_module_source : string ($basic_type_name : string);

0.989018 2023-07-03
  [Incompatibe Changes]
    * The following Native Runtime APIs were changed.

      -  void* (*get_basic_type)(void* runtime, int32_t basic_type_id);
      +  void* (*get_basic_type_by_id)(void* runtime, int32_t basic_type_id);
    
0.989017 2023-06-30
  [New Features]
    The following Native APIs were added.
    
      * void* (*get_basic_type_by_id)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id);
    
  [Incompatibe Changes]
    * The following Native Runtime APIs were removed.
      - int32_t (*get_basic_type_id_by_name)(void* runtime, const char* basic_type_name);
  
    * The following Native APIs were change.
      -  void* (*new_pointer_object_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, void* pointer);
      -  void* (*new_pointer_object)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, void* pointer);
      +  void* (*new_pointer_object_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, void* pointer);
      +  void* (*new_pointer_object)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, void* pointer);

      -  int32_t (*is_type)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t basic_type_id, int32_t type_dimension);
      +  int32_t (*is_type)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* basic_type, int32_t type_dimension);

      -  void* (*new_mulnum_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t length);
      -  void* (*new_mulnum_array)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t length);
      +  void* (*new_mulnum_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t length);
      +  void* (*new_mulnum_array)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t length);

      -  void* (*new_muldim_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t element_dimension, int32_t length);
      -  void* (*new_muldim_array)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t element_dimension, int32_t length);
      +  void* (*new_muldim_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t element_dimension, int32_t length);
      +  void* (*new_muldim_array)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t element_dimension, int32_t length);

      -  void* (*new_object_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t length);
      -  void* (*new_object_array)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t length);
      +  void* (*new_object_array_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t length);
      +  void* (*new_object_array)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type, int32_t length);

      -  void* (*new_object_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id);
      -  void* (*new_object)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id);
      +  void* (*new_object_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type);
      +  void* (*new_object)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type);

      -  int32_t (*isa)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t basic_type_id, int32_t type_dimension);
      +  int32_t (*isa)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* basic_type, int32_t type_dimension);

      -  const char* (*get_version_string)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id);
      -  double (*get_version_number)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id);
      +  const char* (*get_version_string)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type);
      +  double (*get_version_number)(SPVM_ENV* env, SPVM_VALUE* stack, void* basic_type);

      -  int32_t (*has_interface)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t interface_basic_type_id);
      +  int32_t (*has_interface)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* interface_basic_type);

    * The following Native Runtime APIs were change.
      -  int32_t (*can_assign)(void* runtime, int32_t dist_basic_type_id, int32_t dist_type_dimension, int32_t dist_type_flag, int32_t src_basic_type_id, int32_t src_type_dimension, int32_t src_type_flag);
      +  int32_t (*can_assign)(void* runtime, void* dist_basic_type, int32_t dist_type_dimension, int32_t dist_type_flag, void* src_basic_type, int32_t src_type_dimension, int32_t src_type_flag);

      -  int32_t (*is_object_type)(void* runtime, int32_t basic_type_id, int32_t type_dimension, int32_t flag);
      +  int32_t (*is_object_type)(void* runtime, void* basic_type, int32_t type_dimension, int32_t flag);

      -  int32_t (*get_arg_basic_type_id)(void* runtime, void* arg);
      +  void* (*get_arg_basic_type)(void* runtime, void* arg);

      -  int32_t (*get_method_return_basic_type_id)(void* runtime, void* method);
      +  void* (*get_method_return_basic_type)(void* runtime, void* method);

      -  int32_t (*get_method_current_basic_type_id)(void* runtime, void* method);
      +  void* (*get_method_current_basic_type)(void* runtime, void* method);

      -  void* (*get_method)(void* runtime, int32_t basic_type_id, int32_t method_index);
      +  void* (*get_method)(void* runtime, void* basic_type, int32_t method_index);
      -  void* (*get_method_by_name)(void* runtime, int32_t basic_type_id, const char* method_name);
      +  void* (*get_method_by_name)(void* runtime, void* basic_type, const char* method_name);

      -  int32_t (*get_field_basic_type_id)(void* runtime, void* field);
      +  void* (*get_field_basic_type)(void* runtime, void* field);

      -  int32_t (*get_field_current_basic_type_id)(void* runtime, void* method);
      +  void* (*get_field_current_basic_type)(void* runtime, void* field);

      -  void* (*get_field_by_name)(void* runtime, int32_t basic_type_id, const char* field_name);
      +  void* (*get_field_by_name)(void* runtime, void* basic_type, const char* field_name);

      -  void* (*get_field)(void* runtime, int32_t basic_type_id, int32_t field_index);
      +  void* (*get_field)(void* runtime, void* basic_type, int32_t field_index);

      -  int32_t (*get_class_var_basic_type_id)(void* runtime, void* class_var);
      +  void* (*get_class_var_basic_type)(void* runtime, void* class_var);

      -  int32_t (*get_class_var_current_basic_type_id)(void* runtime, void* class_var);
      +  void* (*get_class_var_current_basic_type)(void* runtime, void* class_var);

      -  void* (*get_class_var_by_name)(void* runtime, int32_t basic_type_id, const char* class_var_name);
      +  void* (*get_class_var_by_name)(void* runtime, void* basic_type, const char* class_var_name);

      -  void* (*get_class_var)(void* runtime, int32_t basic_type_id, int32_t class_var_index);
      +  void* (*get_class_var)(void* runtime, void* basic_type, int32_t class_var_index);

      -  const char* (*get_basic_type_version_string)(void* runtime, int32_t basic_type_id);
      +  const char* (*get_basic_type_version_string)(void* runtime, void* basic_type);

      -  int32_t (*get_basic_type_parent_id)(void* runtime, int32_t basic_type_id);
      +  void* (*get_basic_type_parent)(void* runtime, void* basic_type);

      -  int32_t (*get_basic_type_class_vars_length)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_class_vars_length)(void* runtime, void* basic_type);

      -  int32_t (*get_basic_type_class_vars_base)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_class_vars_base)(void* runtime, void* basic_type);

      -  int32_t (*get_basic_type_methods_length)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_methods_length)(void* runtime, void* basic_type);

      -  int32_t (*get_basic_type_methods_base)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_methods_base_v2)(void* runtime, void* basic_type);

      -  int32_t (*get_basic_type_fields_length)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_fields_length)(void* runtime, void* basic_type);

      -  int32_t (*get_basic_type_fields_base)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_fields_base)(void* runtime, void* basic_type);

      -  int32_t (*get_basic_type_is_anon)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_is_anon)(void* runtime, void* basic_type);

      -  const char* (*get_basic_type_module_dir)(void* runtime, int32_t basic_type_id);
      +  const char* (*get_basic_type_module_dir)(void* runtime, void* basic_type);

      -  const char* (*get_basic_type_module_rel_file)(void* runtime, int32_t basic_type_id);
      +  const char* (*get_basic_type_module_rel_file)(void* runtime, void* basic_type);

      -  int32_t (*get_basic_type_category)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_category)(void* runtime, void* basic_type);

      -  const char* (*get_basic_type_name)(void* runtime, int32_t basic_type_id);
      +  const char* (*get_basic_type_name)(void* runtime, void* basic_type);

0.989016 2023-06-29
  [Incompatibe Changes]
    * The following Native Runtime APIs were changed.
      -  int32_t (*get_basic_type_name_id)(void* runtime, int32_t basic_type_id);
      +  const char* (*get_basic_type_name)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_class_var_name_id)(void* runtime, void* class_var);
      +  const char* (*get_class_var_name)(void* runtime, void* class_var);
      -  int32_t (*get_field_name_id)(void* runtime, void* field);
      +  const char* (*get_field_name)(void* runtime, void* field);
      -  int32_t (*get_method_name_id)(void* runtime, void* method);
      +  const char* (*get_method_name)(void* runtime, void* method);

      -  int32_t (*get_basic_type_module_rel_file_id)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_module_dir_id)(void* runtime, int32_t basic_type_id);
      +  const char* (*get_basic_type_module_rel_file)(void* runtime, int32_t basic_type_id);
      +  const char* (*get_basic_type_module_dir)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_version_string_id)(void* runtime, int32_t basic_type_id);
      +  const char* (*get_basic_type_version_string)(void* runtime, int32_t basic_type_id);

    * The following Native Runtime APIs were removed.
      -  const char* (*get_constant_string_value)(void* runtime, int32_t constant_string_id, int32_t* string_length);
      -  const char* (*get_name)(void* runtime, int32_t constant_string_id);
    
  [New Features]
    * The following Native Runtime APIs were added.
    const char* (*get_basic_type_name)(void* runtime, int32_t basic_type_id);
    const char* (*get_class_var_name)(void* runtime, void* class_var);
    const char* (*get_field_name)(void* runtime, void* field);
    const char* (*get_method_name)(void* runtime, void* method);
  [Compilation Error Message Improvement]
    * Complication error messages were improved.
  [Changes]
    * The string cancatlation optimization was removed.

0.989015 2023-06-27
  [Incompatibe Changes]
    * The following native APIs were removed.
    
      void (*set_args_stack_length)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t args_length);
      int32_t (*get_args_stack_length)(SPVM_ENV* env, SPVM_VALUE* stack);

  [Incompatibe Changes]
    * The following Native APIs were removed.
    
      void* class_vars_heap
      void* init_flags;
      int32_t (*get_opcodes_length)(void* runtime);

    * The following Native Runtime APIs were removed.
    
      void* init_flags;

0.989014 2023-06-26
  [Bug Fix]
    * The bug that the get_field_static Native API didn't work well was fixed.
  [Incompatibe Changes]
    * The following Native APIs were removed.
      
      void* object_flag_offset;
      void* object_weaken_backref_head;
      void* object_basic_type_id_offset;
      void* object_type_dimension_offset;
      void* object_length_offset;
      void* object_header_size;
      void* object_ref_count_offset;
      
    * The following Native Runtime APIs were removed.
      
      void* object_flag_offset;
      void* object_weaken_backref_head;
      void* object_basic_type_id_offset;
      void* object_type_dimension_offset;
    
    * The following Native Runtime APIs were change.

      -  int32_t (*get_arg_basic_type_id)(void* runtime, int32_t arg_id);
      -  int32_t (*get_arg_type_dimension)(void* runtime, int32_t arg_id);
      -  int32_t (*get_arg_type_flag)(void* runtime, int32_t arg_id);
      +  int32_t (*get_arg_basic_type_id)(void* runtime, void* arg);
      +  int32_t (*get_arg_type_dimension)(void* runtime, void* arg);
      +  int32_t (*get_arg_type_flag)(void* runtime, void* arg);

  [New Features]
    * The following Native Runtime APIs were added.
        +  void* (*get_arg)(void* runtime, void* method, int32_t arg_index);
  
0.989013 2023-06-26
  [New Features]
    * The following methods were added.
      
      The get_array_unsafe field in the ByteList class was added.
      The get_array_unsafe field in the ShortList class was added.
      The get_array_unsafe field in the IntList class was added.
      The get_array_unsafe field in the LongList class was added.
      The get_array_unsafe field in the FloatList class was added.
      The get_array_unsafe field in the DoubleList class was added.
      The get_array_unsafe field in the List class was added.
      The get_array_unsafe field in the StringList class was added.
      The get_string_unsafe field in the StringBuffer class was added.
   
   * The following Native API constant value were added.
      
      SPVM_NATIVE_VERSION_NUMBER
      
      SPVM_NATIVE_VERSION_STRING
      
  [Incompatibe Changes]
    * The following fields were removed.
    
      The values field in the ByteList class was removed.
      The values field in the ShortList class was removed.
      The values field in the IntList class was removed.
      The values field in the LongList class was removed.
      The values field in the FloatList class was removed.
      The values field in the DoubleList class was removed.
      The values field in the List class was removed.
      The values field in the StringList class was removed.
      The value field in the StringBuffer class was removed.
    
    * A version string cannot contain "_".
      A version string must be able to be parsed by the C<strtod> C function. Otherwise a compilation error occurs.
      
0.989012 2023-06-26
  [Bug Fix]
    * A bug was fixed: Some native APIs had not returned correct error return values.

  [Incompatibe Changes]
    * The following Native APIs were changed.
      -  int32_t (*call_class_method_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* method_name, int32_t args_stack_length, const char* func_nam
      e, const char* file, int32_t line);
      -  int32_t (*call_instance_method_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* method_name, int32_t args_stack_length, const char* func_name, const char* file, int32
      _t line);
      +  void (*call_class_method_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* method_name, int32_t args_stack_length, int32_t* error, const c
      har* func_name, const char* file, int32_t line);
      +  void (*call_instance_method_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* method_name, int32_t args_stack_length, int32_t* error, const char* func_name, const char
      * file, int32_t line);
      -  int32_t (*call_instance_method_static_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* method_name, int32_t args_stack_length, const char* func_name, const char* file, int32_t line);
      +  void (*call_instance_method_static_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* method_name, int32_t args_stack_length, int32_t* error, const char* func_name, const char* file, int32_t line);

0.989011 2023-06-25
  [New Features]
    * The following Native Runtime API were added.

      int32_t (*get_field_offset)(void* runtime, void* field);

  [Incompatibe Changes]
    * The following Native Runtime APIs were removed.
    
      int32_t (*get_field_address_id_by_index)(void* runtime, int32_t basic_type_id, int32_t field_index);
      int32_t (*get_field_address_id_by_name)(void* runtime, const char* basic_type_name, const char* field_name);
    * The length of the merged fields in a class must be lower than 65535.

    * The following Native APIs were changed.
      -  void* (*get_class_var)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, const char* class_var_name);
      +  void* (*get_class_var)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* class_var_name);
      
      -  void* (*get_method)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, const char* method_name);
      +  void* (*get_method)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* method_name);
      
      -  void* (*get_class_method)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, const char* method_name);
      +  void* (*get_class_method)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* method_name);
      -  void* (*get_instance_method_static)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, const char* method_name);
      +  void* (*get_instance_method_static)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* method_name);
      
      -  int32_t (*get_field_id)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* field_name);
      +  void* (*get_field)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* field_name);
      -  int32_t (*get_field_id_static)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* field_name);
      +  void* (*get_field_static)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* field_name);
      
      -  int8_t (*get_field_byte)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id);
      -  int16_t (*get_field_short)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id);
      -  int32_t (*get_field_int)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id);
      -  int64_t (*get_field_long)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id);
      -  float (*get_field_float)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id);
      -  double (*get_field_double)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id);
      -  void* (*get_field_object)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id);
      -  void (*set_field_byte)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id, int8_t value);
      -  void (*set_field_short)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id, int16_t value);
      -  void (*set_field_int)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id, int32_t value);
      -  void (*set_field_long)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id, int64_t value);
      -  void (*set_field_float)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id, float value);
      -  void (*set_field_double)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id, double value);
      -  void (*set_field_object)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, int32_t field_address_id, void* value);
      +  int8_t (*get_field_byte)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      +  int16_t (*get_field_short)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      +  int32_t (*get_field_int)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      +  int64_t (*get_field_long)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      +  float (*get_field_float)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      +  double (*get_field_double)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      +  void* (*get_field_object)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      +  void (*set_field_byte)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field, int8_t value);
      +  void (*set_field_short)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field, int16_t value);
      +  void (*set_field_int)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field, int32_t value);
      +  float (*get_field_float)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      +  double (*get_field_double)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      +  void* (*get_field_object)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field);
      +  void (*set_field_byte)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field, int8_t value);
      +  void (*set_field_short)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field, int16_t value);
      +  void (*set_field_int)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field, int32_t value);
      +  void (*set_field_long)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field, int64_t value);
      +  void (*set_field_float)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field, float value);
      +  void (*set_field_double)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field, double value);
      +  void (*set_field_object)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, void* field, void* value);

    * The following Native APIs were removed.

      -  int32_t (*get_field_offset)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t field_address_id);
0.989010 2023-06-22
  [New Features]
    * The following Native Runtime APIs were added.
      +int32_t SPVM_API_RUNTIME_get_class_var_address_id(SPVM_RUNTIME* runtime, SPVM_RUNTIME_METHOD* class_var);
      +int32_t SPVM_API_RUNTIME_get_class_var_index(SPVM_RUNTIME* runtime, SPVM_RUNTIME_METHOD* class_var);
      +int32_t SPVM_API_RUNTIME_get_field_address_id(SPVM_RUNTIME* runtime, SPVM_RUNTIME_METHOD* field);
      +int32_t SPVM_API_RUNTIME_get_field_index(SPVM_RUNTIME* runtime, SPVM_RUNTIME_METHOD* field);
    * The following Native APIs were added.
      +  void* (*new_stack_trace_raw_v2)(SPVM_ENV* env, SPVM_VALUE* stack, void* exception, void* method, int32_t line);
      +  void* (*new_stack_trace_v2)(SPVM_ENV* env, SPVM_VALUE* stack, void* exception, void* method, int32_t line);
      
      int8_t (*get_class_var_byte_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index);
      int16_t (*get_class_var_short_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index);
      int32_t (*get_class_var_int_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index);
      int64_t (*get_class_var_long_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index);
      float (*get_class_var_float_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index);
      double (*get_class_var_double_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index);
      void* (*get_class_var_object_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index);
      void (*set_class_var_byte_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index, int8_t value);
      void (*set_class_var_short_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index, int16_t value);
      void (*set_class_var_int_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index, int32_t value);
      void (*set_class_var_long_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index, int64_t value);
      void (*set_class_var_float_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index, float value);
      void (*set_class_var_double_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index, double value);
      void (*set_class_var_object_v2)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t class_var_index, void* value);
  [Warnings]
    * The beheivior of the following Native APIs were deprecated and will be replaced with version 2 APIs.
      +  void* (*new_stack_trace_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* exception, int32_t method_address_id, int32_t line);
      +  void* (*new_stack_trace)(SPVM_ENV* env, SPVM_VALUE* stack, void* exception, int32_t method_address_id, int32_t line);
      
      int8_t (*get_class_var_byte)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      int16_t (*get_class_var_short)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      int32_t (*get_class_var_int)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      int64_t (*get_class_var_long)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      float (*get_class_var_float)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      double (*get_class_var_double)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      void* (*get_class_var_object)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      void (*set_class_var_byte)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, int8_t value);
      void (*set_class_var_short)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, int16_t value);
      void (*set_class_var_int)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, int32_t value);
      void (*set_class_var_long)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, int64_t value);
      void (*set_class_var_float)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, float value);
      void (*set_class_var_double)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, double value);
      void (*set_class_var_object)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, void* value);
  [Incompatibe Changes]
    * The following Native Runtime APIs were changed.
      -  int32_t (*get_basic_type_name_id)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_name_id)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_category)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_category)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_module_rel_file_id)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_module_dir_id)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_is_anon)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_fields_base_address_id)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_fields_length)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_methods_base_address_id)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_methods_length)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_class_vars_base_address_id)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_class_vars_length)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_module_rel_file_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_module_dir_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_is_anon)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_fields_base_address_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_fields_length)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_methods_base_address_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_methods_length)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_class_vars_base_address_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_class_vars_length)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_parent_id)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_version_string_id)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_parent_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_version_string_id)(void* runtime, int32_t basic_type_id);
    * The following Native APIs were changed.
      -  int32_t (*call_method_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t method_id, int32_t args_stack_length);
      +  int32_t (*call_method_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* method, int32_t args_stack_length);
      -  int32_t (*call_method)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t method_id, int32_t args_stack_length);
      +  int32_t (*call_method)(SPVM_ENV* env, SPVM_VALUE* stack, void* method, int32_t args_stack_length);
      
      -  void* (*new_stack_trace_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* exception, int32_t method_address_id, int32_t line);
      -  void* (*new_stack_trace)(SPVM_ENV* env, SPVM_VALUE* stack, void* exception, int32_t method_address_id, int32_t line);
      +  void* (*new_stack_trace_raw)(SPVM_ENV* env, SPVM_VALUE* stack, void* exception, void* method, int32_t line);
      +  void* (*new_stack_trace)(SPVM_ENV* env, SPVM_VALUE* stack, void* exception, void* method, int32_t line);0.989009 2023-06-21
      -  int32_t (*get_class_method_id)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* method_name);
      +  void* (*get_class_method)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, const char* method_name);
      
      -  int32_t (*get_instance_method_id_static)(SPVM_ENV* env, const char* basic_type_name, const char* method_name);
      +  void* (*get_instance_method_static)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, const char* method_name);
      
      -  int32_t (*get_instance_method_id)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* method_name);
      +  void* (*get_instance_method)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* method_name);
      
      -  int32_t (*get_method_id)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* method_name);
      +  void* (*get_method)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, const char* method_name);
            
      -  int32_t (*get_class_var_id)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, const char* class_var_name);
      +  void* (*get_class_var)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, const char* class_var_name);

      -  int8_t (*get_class_var_byte)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      -  int16_t (*get_class_var_short)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      -  int32_t (*get_class_var_int)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      -  int64_t (*get_class_var_long)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      -  float (*get_class_var_float)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      -  double (*get_class_var_double)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      -  void* (*get_class_var_object)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id);
      -  void (*set_class_var_byte)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, int8_t value);
      -  void (*set_class_var_short)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, int16_t value);
      -  void (*set_class_var_int)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, int32_t value);
      -  void (*set_class_var_long)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, int64_t value);
      -  void (*set_class_var_float)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, float value);
      -  void (*set_class_var_double)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, double value);
      -  void (*set_class_var_object)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t class_var_address_id, void* value);
      +  int8_t (*get_class_var_byte)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var);
      +  int16_t (*get_class_var_short)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var);
      +  int32_t (*get_class_var_int)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var);
      +  int64_t (*get_class_var_long)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var);
      +  float (*get_class_var_float)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var);
      +  double (*get_class_var_double)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var);
      +  void* (*get_class_var_object)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var);
      +  void (*set_class_var_byte)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var, int8_t value);
      +  void (*set_class_var_short)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var, int16_t value);
      +  void (*set_class_var_int)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var, int32_t value);
      +  void (*set_class_var_long)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var, int64_t value);
      +  void (*set_class_var_float)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var, float value);
      +  void (*set_class_var_double)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var, double value);
      +  void (*set_class_var_object)(SPVM_ENV* env, SPVM_VALUE* stack, void* class_var, void* value);

    * The following Native Runtime APIs were changed.
      - void* (*get_field)(void* runtime, void* basic_type, int32_t field_index);
      - void* (*get_class_var)(void* runtime, void* basic_type, int32_t class_var_index);
      - void* (*get_method)(void* runtime, void* basic_type, int32_t method_index);
      + void* (*get_field)(void* runtime, int32_t basic_type_id, int32_t field_index);
      + void* (*get_class_var)(void* runtime, int32_t basic_type_id, int32_t class_var_index);
      + void* (*get_method)(void* runtime, int32_t basic_type_id, int32_t method_index);
      
      -  int32_t (*get_method_is_static)(void* runtime, void* method);
      +  int32_t (*get_method_is_class_method)(void* runtime, void* method);
      
      -  void* (*get_basic_type_by_id)(void* runtime, int32_t basic_type_id);
      +  void* (*get_basic_type)(void* runtime, int32_t basic_type_id);
    * The following Native Runtime APIs were removed.
      - int32_t (*get_method_address_id_by_index)(void* runtime, int32_t basic_type_id, int32_t method_index);
      - int32_t (*get_method_address_id_by_name)(void* runtime, const char* basic_type_name, const char* method_name);

  [New Features]
    * The following Native Runtime APIs were added.
    
      void* (*get_instance_method)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* method_name);
      
    * The following Native Runtime APIs were added.

      void* (*get_class_var_by_name)(void* runtime, int32_t basic_type_id, const char* class_var_name);
      void* (*get_field_by_name)(void* runtime, int32_t basic_type_id, const char* field_name);
      void* (*get_method_by_name)(void* runtime, int32_t basic_type_id, const char* method_name);
      int32_t (*get_method_address_id)(void* runtime, void* method);
      int32_t (*get_method_index)(void* runtime, void* method);
  [Bug Fix]
    * The following bug was fixed. Cached symbol IDs in the precompile code does not work well in some cases.
0.989008 2023-06-20
  [Incompatibe Changes]
    * The following Native Runtime APIs were changed.
    
      -  int32_t (*get_basic_type_rel_file_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_module_rel_file_id)(void* runtime, int32_t basic_type_id);
      
      -  int32_t (*get_basic_type_dir_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_module_dir_id)(void* runtime, int32_t basic_type_id);

      -  int32_t (*get_method_opcodes_base_id)(void* runtime, int32_t method_id);
      +  int32_t (*get_method_opcodes_base_address_id)(void* runtime, int32_t method_id);
      
      -  int32_t (*get_method_args_base_id)(void* runtime, int32_t method_id);
      +  int32_t (*get_method_args_base_address_id)(void* runtime, int32_t method_id);
      
      -  int32_t (*get_basic_type_fields_base_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_fields_base_address_id)(void* runtime, int32_t basic_type_id);
      
      -  int32_t (*get_basic_type_methods_base_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_methods_base_address_id)(void* runtime, int32_t basic_type_id);
      
      -  int32_t (*get_basic_type_class_vars_base_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_class_vars_base_address_id)(void* runtime, int32_t basic_type_id);
      
      -  int32_t (*get_method_id_by_index)(void* runtime, int32_t basic_type_id, int32_t method_index);
      -  int32_t (*get_method_id_by_name)(void* runtime, const char* basic_type_name, const char* method_name);
      -  int32_t (*get_method_name_id)(void* runtime, int32_t method_id);
      +  int32_t (*get_method_address_id_by_index)(void* runtime, int32_t basic_type_id, int32_t method_index);
      +  int32_t (*get_method_address_id_by_name)(void* runtime, const char* basic_type_name, const char* method_name);
      +  int32_t (*get_method_name_id)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_is_static)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_is_anon)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_is_native)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_is_precompile)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_call_stack_byte_vars_length)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_call_stack_short_vars_length)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_call_stack_int_vars_length)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_call_stack_long_vars_length)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_call_stack_float_vars_length)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_call_stack_double_vars_length)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_call_stack_object_vars_length)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_call_stack_ref_vars_length)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_mortal_stack_length)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_opcodes_base_address_id)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_opcodes_length)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_args_base_address_id)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_args_length)(void* runtime, int32_t method_id);
      +  int32_t (*get_method_is_static)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_is_anon)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_is_native)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_is_precompile)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_call_stack_byte_vars_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_call_stack_short_vars_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_call_stack_int_vars_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_call_stack_long_vars_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_call_stack_float_vars_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_call_stack_double_vars_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_call_stack_object_vars_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_call_stack_ref_vars_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_mortal_stack_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_opcodes_base_address_id)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_opcodes_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_args_base_address_id)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_args_length)(void* runtime, int32_t method_address_id);
      -  void* (*get_native_method_address)(void* runtime, int32_t method_id);
      -  void (*set_native_method_address)(void* runtime, int32_t method_id, void* address);
      -  void* (*get_precompile_method_address)(SPVM_ENV*, int32_t method_id);
      -  void (*set_precompile_method_address)(void* runtime, int32_t method_id, void* address);
      +  void* (*get_native_method_address)(void* runtime, int32_t method_address_id);
      +  void (*set_native_method_address)(void* runtime, int32_t method_address_id, void* address);
      +  void* (*get_precompile_method_address)(SPVM_ENV*, int32_t method_address_id);
      +  void (*set_precompile_method_address)(void* runtime, int32_t method_address_id, void* address);
      -  int32_t (*get_method_required_args_length)(void* runtime, int32_t method_id);
      +  int32_t (*get_method_required_args_length)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_is_enum)(void* runtime, int32_t method_id);
      +  int32_t (*get_method_is_enum)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_return_basic_type_id)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_return_type_dimension)(void* runtime, int32_t method_id);
      -  int32_t (*get_method_return_type_flag)(void* runtime, int32_t method_id);
      +  int32_t (*get_method_return_basic_type_id)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_return_type_dimension)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_return_type_flag)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_current_basic_type_id)(void* runtime, int32_t method_id);
      -  int32_t (*get_field_current_basic_type_id)(void* runtime, int32_t method_id);
      -  int32_t (*get_class_var_current_basic_type_id)(void* runtime, int32_t method_id);
      +  int32_t (*get_method_current_basic_type_id)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_field_current_basic_type_id)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_class_var_current_basic_type_id)(void* runtime, int32_t method_address_id);

      -  int32_t (*get_field_id_by_index)(void* runtime, int32_t basic_type_id, int32_t field_index);
      -  int32_t (*get_field_id_by_name)(void* runtime, const char* basic_type_name, const char* field_name);
      -  int32_t (*get_field_name_id)(void* runtime, int32_t field_id);
      +  int32_t (*get_field_address_id_by_index)(void* runtime, int32_t basic_type_id, int32_t field_index);
      +  int32_t (*get_field_address_id_by_name)(void* runtime, const char* basic_type_name, const char* field_name);
      +  int32_t (*get_field_name_id)(void* runtime, int32_t field_address_id);
      -  int32_t (*get_field_basic_type_id)(void* runtime, int32_t field_id);
      -  int32_t (*get_field_type_dimension)(void* runtime, int32_t field_id);
      -  int32_t (*get_field_type_flag)(void* runtime, int32_t field_id);
      +  int32_t (*get_field_basic_type_id)(void* runtime, int32_t field_address_id);
      +  int32_t (*get_field_type_dimension)(void* runtime, int32_t field_address_id);
      +  int32_t (*get_field_type_flag)(void* runtime, int32_t field_address_id);

      -  int32_t (*get_class_var_id_by_index)(void* runtime, int32_t basic_type_id, int32_t class_var_index);
      -  int32_t (*get_class_var_id_by_name)(void* runtime, const char* basic_type_name, const char* class_var_name);
      -  int32_t (*get_class_var_name_id)(void* runtime, int32_t class_var_id);
      +  int32_t (*get_class_var_address_id_by_index)(void* runtime, int32_t basic_type_id, int32_t class_var_index);
      +  int32_t (*get_class_var_address_id_by_name)(void* runtime, const char* basic_type_name, const char* class_var_name);
      +  int32_t (*get_class_var_name_id)(void* runtime, int32_t class_var_address_id);
      -  int32_t (*get_class_var_basic_type_id)(void* runtime, int32_t class_var_id);
      -  int32_t (*get_class_var_type_dimension)(void* runtime, int32_t class_var_id);
      -  int32_t (*get_class_var_type_flag)(void* runtime, int32_t class_var_id);
      +  int32_t (*get_class_var_basic_type_id)(void* runtime, int32_t class_var_address_id);
      +  int32_t (*get_class_var_type_dimension)(void* runtime, int32_t class_var_address_id);
      +  int32_t (*get_class_var_type_flag)(void* runtime, int32_t class_var_address_id);

      -  int32_t (*get_class_var_address_id_by_index)(void* runtime, int32_t basic_type_id, int32_t class_var_index);
      +  void* (*get_class_var)(void* runtime, void* basic_type, int32_t class_var_index);

      -  int32_t (*get_class_var_name_id)(void* runtime, int32_t class_var_address_id);
      +  int32_t (*get_class_var_name_id)(void* runtime, void* class_var);
      -  int32_t (*get_class_var_basic_type_id)(void* runtime, int32_t class_var_address_id);
      -  int32_t (*get_class_var_type_dimension)(void* runtime, int32_t class_var_address_id);
      -  int32_t (*get_class_var_type_flag)(void* runtime, int32_t class_var_address_id);
      +  int32_t (*get_class_var_basic_type_id)(void* runtime, void* class_var);
      +  int32_t (*get_class_var_type_dimension)(void* runtime, void* class_var);
      +  int32_t (*get_class_var_type_flag)(void* runtime, void* class_var);
      -  int32_t (*get_class_var_current_basic_type_id)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_class_var_current_basic_type_id)(void* runtime, void* class_var);

      -  int32_t (*get_field_name_id)(void* runtime, int32_t field_address_id);
      +  int32_t (*get_field_name_id)(void* runtime, void* field);
      -  int32_t (*get_field_basic_type_id)(void* runtime, int32_t field_address_id);
      -  int32_t (*get_field_type_dimension)(void* runtime, int32_t field_address_id);
      -  int32_t (*get_field_type_flag)(void* runtime, int32_t field_address_id);
      +  int32_t (*get_field_basic_type_id)(void* runtime, void* field);
      +  int32_t (*get_field_type_dimension)(void* runtime, void* field);
      +  int32_t (*get_field_type_flag)(void* runtime, void* field);
      +  void* (*get_field_by_address_id)(void* runtime, int32_t field_address_id);

      -  int32_t (*get_method_name_id)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_name_id)(void* runtime, void* method);
      -  int32_t (*get_method_is_static)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_is_anon)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_is_native)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_is_precompile)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_call_stack_byte_vars_length)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_call_stack_short_vars_length)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_call_stack_int_vars_length)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_call_stack_long_vars_length)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_call_stack_float_vars_length)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_call_stack_double_vars_length)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_call_stack_object_vars_length)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_call_stack_ref_vars_length)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_mortal_stack_length)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_opcodes_base_address_id)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_opcodes_length)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_args_base_address_id)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_args_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_is_static)(void* runtime, void* method);
      +  int32_t (*get_method_is_anon)(void* runtime, void* method);
      +  int32_t (*get_method_is_native)(void* runtime, void* method);
      +  int32_t (*get_method_is_precompile)(void* runtime, void* method);
      +  int32_t (*get_method_call_stack_byte_vars_length)(void* runtime, void* method);
      +  int32_t (*get_method_call_stack_short_vars_length)(void* runtime, void* method);
      +  int32_t (*get_method_call_stack_int_vars_length)(void* runtime, void* method);
      +  int32_t (*get_method_call_stack_long_vars_length)(void* runtime, void* method);
      +  int32_t (*get_method_call_stack_float_vars_length)(void* runtime, void* method);
      +  int32_t (*get_method_call_stack_double_vars_length)(void* runtime, void* method);
      +  int32_t (*get_method_call_stack_object_vars_length)(void* runtime, void* method);
      +  int32_t (*get_method_call_stack_ref_vars_length)(void* runtime, void* method);
      +  int32_t (*get_method_mortal_stack_length)(void* runtime, void* method);
      +  int32_t (*get_method_opcodes_base_address_id)(void* runtime, void* method);
      +  int32_t (*get_method_opcodes_length)(void* runtime, void* method);
      +  int32_t (*get_method_args_base_address_id)(void* runtime, void* method);
      +  int32_t (*get_method_args_length)(void* runtime, void* method);
      -  void* (*get_native_method_address)(void* runtime, int32_t method_address_id);
      -  void (*set_native_method_address)(void* runtime, int32_t method_address_id, void* address);
      -  void* (*get_precompile_method_address)(SPVM_ENV*, int32_t method_address_id);
      -  void (*set_precompile_method_address)(void* runtime, int32_t method_address_id, void* address);
      +  void* (*get_native_method_address)(void* runtime, void* method);
      +  void (*set_native_method_address)(void* runtime, void* method, void* address);
      +  void* (*get_precompile_method_address)(SPVM_ENV*, void* method);
      +  void (*set_precompile_method_address)(void* runtime, void* method, void* address);
      -  int32_t (*get_method_required_args_length)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_required_args_length)(void* runtime, void* method);
      -  int32_t (*get_method_is_enum)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_is_enum)(void* runtime, void* method);
      -  int32_t (*get_method_return_basic_type_id)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_return_type_dimension)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_method_return_type_flag)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_return_basic_type_id)(void* runtime, void* method);
      +  int32_t (*get_method_return_type_dimension)(void* runtime, void* method);
      +  int32_t (*get_method_return_type_flag)(void* runtime, void* method);
      -  int32_t (*get_method_current_basic_type_id)(void* runtime, int32_t method_address_id);
      -  int32_t (*get_field_current_basic_type_id)(void* runtime, int32_t method_address_id);
      +  int32_t (*get_method_current_basic_type_id)(void* runtime, void* method);
      +  int32_t (*get_field_current_basic_type_id)(void* runtime, void* method);
      
      -  int32_t (*get_basic_type_name_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_name_id)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_category)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_category)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_module_rel_file_id)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_module_dir_id)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_is_anon)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_fields_base_address_id)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_fields_length)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_methods_base_address_id)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_fields_base_address_id)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_fields_length)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_methods_base_address_id)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_methods_length)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_class_vars_base_address_id)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_class_vars_length)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_module_rel_file_id)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_module_dir_id)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_is_anon)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_fields_base_address_id)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_fields_length)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_methods_base_address_id)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_methods_length)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_class_vars_base_address_id)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_class_vars_length)(void* runtime, void* basic_type);
      -  int32_t (*get_basic_type_parent_id)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_version_string_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_parent_id)(void* runtime, void* basic_type);
      +  int32_t (*get_basic_type_version_string_id)(void* runtime, void* basic_type);
      
    * The following Native Runtime API were removed.
      -  int32_t (*get_anon_method_method_id)(void* runtime, int32_t anon_method_id);
      -  int32_t (*get_basic_type_anon_methods_base_id)(void* runtime, int32_t basic_type_id);
      -  int32_t (*get_basic_type_anon_methods_length)(void* runtime, int32_t basic_type_id);
0.989007 2023-06-19
  [Document Changes]
    * The hedding "Class Attribute" was renamed to "Module Attribute"
    * The hedding "Class Name" was renamed to "Basic Type Name"
    
  [Bug Fix and Incompatibe Changes]
    * The no-build-spvm-classes option in the Makefile.PL that was generated by spvmdist command was renamed to the no-build-spvm-modules option.
      This had been wrongly changed.
  [Incompatibe Changes]
    * The class_name fields in the all classes(.spvm) were renamed to the basic_type_name methods and fields.
    * The class_name method and fields in the Perl modules(.pm) were renamed to module_name.
    * The following Native Runtime APIs were changed.
      -  int32_t (*get_basic_type_parent_class_basic_type_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_parent_id)(void* runtime, int32_t basic_type_id);
    * The __CLASS__ operator was renamed to __PACKAGE__ operator.
    
  [Compilation Error Messages]
    * The expression "class name" was reduced.
  [Exception Messages]
    * The expression "class name" was reduced.

0.989006 2023-06-18
  [New Features]
    * The get_basic_type_name method in the Runtime class was added.
    
  [Incompatible Changes]
    * The following Native Runtime APIs were changed.
      -  int32_t (*get_basic_type_class_path_id)(void* runtime, int32_t basic_type_id);
      +  int32_t (*get_basic_type_dir_id)(void* runtime, int32_t basic_type_id);
      
      -  int32_t (*get_method_class_basic_type_id)(void* runtime, int32_t method_id);
      +  int32_t (*get_method_current_basic_type_id)(void* runtime, int32_t method_id);
      
      -  int32_t (*get_field_class_basic_type_id)(void* runtime, int32_t method_id);
      +  int32_t (*get_field_current_basic_type_id)(void* runtime, int32_t method_id);
      
      -  int32_t (*get_class_var_class_basic_type_id)(void* runtime, int32_t method_id);
      +  int32_t (*get_class_var_current_basic_type_id)(void* runtime, int32_t method_id);
    * The following Native API contant values were changed.
    
      [Before]
      0 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_UNKNOWN
      1 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_NOT_FOUND_CLASS
      2 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_UNDEF
      3 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_VOID
      4 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_NUMERIC
      5 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_MULNUM
      6 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_STRING
      7 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_CLASS
      8 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_INTERFACE
      9 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_ANY_OBJECT
      
      [After]
      0 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_UNKNOWN
      1 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_UNDEF
      2 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_VOID
      3 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_NUMERIC
      4 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_MULNUM
      5 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_STRING
      6 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_CLASS
      7 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_INTERFACE
      8 SPVM_NATIVE_C_BASIC_TYPE_CATEGORY_ANY_OBJECT
    * The get_classes_length method in the Runtime class was removed.
    * The get_class_names in the Runtime class was removed.
    * The get_parent_class_name in the Runtime class was renamed to the get_basic_type_parent_name method.
    * The get_class_file in the Runtime class was renamed to the get_file method.
    * The build_precompile_class_source in the Runtime class was renamed to the build_precompile_source method.
    * The get_anon_class_names in the Runtime class was renamed to the get_basic_type_anon_basic_type_names method.

    * The following Native Runtime API were changed.
    
      -  int32_t (*get_method_is_class_method)(void* runtime, int32_t method_id);
      +  int32_t (*get_method_is_static)(void* runtime, int32_t method_id);
    
    * The following Native Precompile API were changed.
    
      -  void (*build_class_source)(void* precompile, void* string_buffer, const char* class_name);
      +  void (*build_source)(void* precompile, void* string_buffer, const char* class_name);
    
    * The following Native Compiler API were changed.
    
      -  void (*add_class_path)(void* compiler, const char* class_path);
      +  void (*add_include_dir)(void* compiler, const char* include_dir);

      -  int32_t (*get_class_paths_length )(void* compiler);
      +  int32_t (*get_include_dirs_length )(void* compiler);

      -  const char* (*get_class_path )(void* compiler, int32_t index);
      +  const char* (*get_include_dir )(void* compiler, int32_t index);

      -  void (*clear_class_paths)(void* compiler);
      +  void (*clear_include_dirs)(void* compiler);

    * The class-path option in the spvmcc command was renamed to include-dir.
  [Breaking Binary Compatibility]
    * Binary compatibility was broken.
    
0.989005 2023-06-15
  [Changes]
    * include/spvm_class.h and src/spvm_class.c were removed.
0.989004 2023-06-14
  [New Features]
    * The get_field_basic_type_id Native Runtime API was added.
    * The get_field_type_dimension Native Runtime API was added.
    * The get_field_type_flag Native Runtime API was added.
    * The get_class_var_basic_type_id Native Runtime API was added.
    * The get_class_var_type_dimension Native Runtime API was added.
    * The get_class_var_type_flag Native Runtime API was added.
    * The get_method_return_basic_type_id Native Runtime API was added.
    * The get_method_return_type_dimension Native Runtime API was added.
    * The get_method_return_type_flag Native Runtime API was added.
    * The get_arg_basic_type_id Native Runtime API was added.
    * The get_arg_type_dimension Native Runtime API was added.
    * The get_arg_type_flag Native Runtime API was added.
    * The get_method_class_basic_type_id Native Runtime API was added.
    * The get_field_class_basic_type_id Native Runtime API was added.
    * The get_class_var_class_basic_type_id Native Runtime API was added.
    * The get_basic_type_parent_class_basic_type_id Native Runtime API was added.
  [Incompatible Changes]
    * The get_field_type_id Native Runtime API was removed.
    * The get_method_return_type_id Native Runtime API was removed.
    * The get_type_stack_length Native Runtime API was removed.
    * The get_arg_type_id Native Runtime API was removed.
    * The get_basic_type_is_class Native Runtime API was removed.
    * The following Native Runtime APIs were removed.
      int32_t (*get_type_basic_type_id)(void* runtime, int32_t type_id);
      int32_t (*get_type_dimension)(void* runtime, int32_t type_id);
      int32_t (*get_type_is_object)(void* runtime, int32_t type_id);
      int32_t (*get_type_is_ref)(void* runtime, int32_t type_id);
      int32_t (*get_type_flag)(void* runtime, int32_t type_id);
      int32_t (*get_basic_type_class_id)(void* runtime, int32_t basic_type_id);
      int32_t (*get_field_class_id)(void* runtime, int32_t basic_type_id);
      int32_t (*get_method_class_id)(void* runtime, int32_t basic_type_id);
      int32_t (*get_class_var_class_id)(void* runtime, int32_t basic_type_id);
      int32_t (*get_class_id_by_name)(void* runtime, const char* class_name);
      int32_t (*get_class_name_id)(void* runtime, int32_t class_id);
      int32_t (*get_class_class_rel_file_id)(void* runtime, int32_t class_id);
      int32_t (*get_class_class_path_id)(void* runtime, int32_t class_id);
      int32_t (*get_class_is_anon)(void* runtime, int32_t class_id);
      int32_t (*get_class_fields_base_id)(void* runtime, int32_t class_id);
      int32_t (*get_class_fields_length)(void* runtime, int32_t class_id);
      int32_t (*get_class_methods_base_id)(void* runtime, int32_t class_id);
      int32_t (*get_class_methods_length)(void* runtime, int32_t class_id);
      int32_t (*get_class_class_vars_base_id)(void* runtime, int32_t class_id);
      int32_t (*get_class_class_vars_length)(void* runtime, int32_t class_id);
      int32_t (*get_class_anon_methods_base_id)(void* runtime, int32_t class_id);
      int32_t (*get_class_anon_methods_length)(void* runtime, int32_t class_id);

    * The following Native Runtime APIs were changed.
      -  int32_t (*get_class_var_id_by_index)(void* runtime, int32_t class_id, int32_t class_var_index);
      +  int32_t (*get_class_var_id_by_index)(void* runtime, int32_t basic_type_id, int32_t class_var_index);
      
      -  int32_t (*get_field_id_by_index)(void* runtime, int32_t class_id, int32_t field_index);
      +  int32_t (*get_field_id_by_index)(void* runtime, int32_t basic_type_id, int32_t field_index);
      
      -  int32_t (*get_method_id_by_index)(void* runtime, int32_t class_id, int32_t method_index);
      +  int32_t (*get_method_id_by_index)(void* runtime, int32_t basic_type_id, int32_t method_index);
      
0.989003 2023-06-09
  [Bug Fix]
    * The following bug was fixed: The can_assign Native Runtime API didnot work well.
  [New Features]
    * The isa_error operator and the is_operator were added.
  [Changes]
    * The Error::System class extends the Error class.
    * The Error::NotSupported class extends the Error class.
  [Incompatible Changes]
    * The get_class_id Native API was removed. This is internally used now.
    * The get_class_id_by_name Native API was removed. This is internally used now.
  [Warnings]
    * Native Runtime APIs that get and set the class id will be removed in the nearly feature.
0.989002 2023-06-08
  [Document Bug]
    * The basic type IDs were wrong. This was fixed.
    
      0  SPVM_NATIVE_C_BASIC_TYPE_ID_UNKNOWN
      1  SPVM_NATIVE_C_BASIC_TYPE_ID_UNDEF
      2  SPVM_NATIVE_C_BASIC_TYPE_ID_VOID
      3  SPVM_NATIVE_C_BASIC_TYPE_ID_BYTE
      4  SPVM_NATIVE_C_BASIC_TYPE_ID_SHORT
      5  SPVM_NATIVE_C_BASIC_TYPE_ID_INT
      6  SPVM_NATIVE_C_BASIC_TYPE_ID_LONG
      7  SPVM_NATIVE_C_BASIC_TYPE_ID_FLOAT
      8  SPVM_NATIVE_C_BASIC_TYPE_ID_DOUBLE
      9  SPVM_NATIVE_C_BASIC_TYPE_ID_STRING
      10 SPVM_NATIVE_C_BASIC_TYPE_ID_ANY_OBJECT
      11 SPVM_NATIVE_C_BASIC_TYPE_ID_BYTE_CLASS
      12 SPVM_NATIVE_C_BASIC_TYPE_ID_SHORT_CLASS
      13 SPVM_NATIVE_C_BASIC_TYPE_ID_INT_CLASS
      14 SPVM_NATIVE_C_BASIC_TYPE_ID_LONG_CLASS
      15 SPVM_NATIVE_C_BASIC_TYPE_ID_FLOAT_CLASS
      16 SPVM_NATIVE_C_BASIC_TYPE_ID_DOUBLE_CLASS
      17 SPVM_NATIVE_C_BASIC_TYPE_ID_BOOL_CLASS
      18 SPVM_NATIVE_C_BASIC_TYPE_ID_ERROR_CLASS
      19 SPVM_NATIVE_C_BASIC_TYPE_ID_ERROR_SYSTEM_CLASS
      20 SPVM_NATIVE_C_BASIC_TYPE_ID_ERROR_NOT_SUPPORTED_CLASS
      21 SPVM_NATIVE_C_BASIC_TYPE_ID_COMMAND_INFO_CLASS
      22 SPVM_NATIVE_C_BASIC_TYPE_ID_ADDRESS_CLASS

  [New Features]
    * The basic_type_id operator was added.
  [Incompatible Changes]
    * The error operator was renamed to the eval_error_id operator. The eval_error_id operator returns the basic type id, not the class id.
    * The class_id operator was removed.
    * The code field in the ExchangeAPI::Error class was renamed to the id field.
    * The set_error_code operator was removed.
    * The error_code operator was removed.
    * The die Native API returned the basic type ID of the Error class.
    * The deprecated following syntax was removed.
    
      var ASSIGN operator ':' qualified_type opt_type_comment

0.989001 2023-06-07
  [Incompatible Changes]
    * The new_stack_trace_by_name Native API was removed.
    * The new_stack_trace_raw_by_name Native API was removed.
    * The following Native APIs were removed.
      void* (*new_object_array_raw_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t length);
      void* (*new_muldim_array_raw_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t element_dimension, int32_t length);
      void* (*new_mulnum_array_raw_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t length);
      int32_t (*has_interface_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* interface_basic_type_name);
    * The IDs of the following Native APIs were changed.
      new_object_array_by_name
      new_muldim_array_by_name
      new_mulnum_array_by_name
      has_interface_by_name
    * The definition of the following Native APIs were changed.
      -  void* (*new_object_array_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t length);
      +  void* (*new_object_array_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t length, int32_t* error, const char* func_name, const char* file, int32_t line);
      
      -  void* (*new_muldim_array_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t element_dimension, int32_t length);
      +  void* (*new_muldim_array_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t element_dimension, int32_t length, int32_t* error, const char* func_name, const char* file, int32_t line);
      
      -  void* (*new_mulnum_array_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t length);
      +  void* (*new_mulnum_array_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t length, int32_t* error, const char* func_name, const char* file, int32_t line);
  [Bug Fix]
    * A following bug was fiexed. The new_object_array_by_name, new_muldim_array_by_name, and new_mulnum_array_by_name Native APIs could not be called.
    * A following bug was fiexed. The isa_by_name, is_type_by_name, and has_interface_by_name Native APIs didnot work correctly.
  [Internale Changes]
    * The spvm_object structure was restored. The basci_type_name member was removed in the spvm_object strucutre and the basic_type_id member is added again.
0.989 2023-06-06
  [New Features]
    * The get_object_basic_type_name Native API was added.
    * The isa_by_name Native API was added.
    * The is_type_by_name Native API was added.
    * The new_stack_trace_by_name Native API was added.
    * The new_stack_trace_raw_by_name Native API was added.
    * The can_assign Native Runtime API was added.
    * The following Native APIs were added.
      void* (*new_object_array_raw_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t length);
      void* (*new_object_array_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t length);
      void* (*new_muldim_array_raw_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t element_dimension, int32_t length);
      void* (*new_muldim_array_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t element_dimension, int32_t length);
      void* (*new_mulnum_array_raw_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t length);
      void* (*new_mulnum_array_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t length);
      int32_t (*has_interface_by_name)(SPVM_ENV* env, SPVM_VALUE* stack, void* object, const char* interface_basic_type_name);
      
  [Incompatible Changes]
    * The definition of the get_compile_type_name_raw Native API was changed.
      -  void* (*get_compile_type_name_raw)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t type_dimension, int32_t type_flag);
      +  void* (*get_compile_type_name_raw)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t type_dimension, int32_t type_flag);
    * The definition of the get_compile_type_name Native API was changed.
      -  void* (*get_compile_type_name)(SPVM_ENV* env, SPVM_VALUE* stack, int32_t basic_type_id, int32_t type_dimension, int32_t type_flag);
      +  void* (*get_compile_type_name)(SPVM_ENV* env, SPVM_VALUE* stack, const char* basic_type_name, int32_t type_dimension, int32_t type_flag);
  [Warning]
    * Many Native APIs will be changed in the nearly release.
      The IDs of the symbol will not be published to the user.
      Risky operations such as ID will be moved from Native APIs to Native Runtime APIs.
  [Bug Fix]
    * The bug that the dump operator does not work well weaken fields and elements.
0.988 2023-06-05
  [New Features]
    * The has_keys method in the Hash class is added.
    * The replacement argument is added to the substr method in the Fn class.
    
      static method substr : string ($string : string, $offset : int, $length : int = -1, $replacement : string = undef);
    
  [Changed]
    * An exception is thrown when the invocant of the instance method call is undef.
  [Exception Message Improvement]
    The following exception message is changed.
      -  "The implementation of the \"%s\" instance method defined in \"%s\" is not found.",
      +  "The implementation of the \"%s\" method in the \"%s\" interface is not found.",
0.987 2023-05-29
  [Changes]
    * INIT block in precompile class is not precompiled.
0.986 2023-05-29
  [Incompatible Changes]
    * The syntax of the optional argument is changed. The before syntax is deprecated and will be removed.
    [Before]
